#!/usr/bin/perl

# This chunk of stuff was generated by App::FatPacker. To find the original
# file's code, look for the end of this BEGIN block or the string 'FATPACK'
BEGIN {
my %fatpacked;

$fatpacked{"centreon/common/protocols/sql/mode/connectiontime.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_COMMON_PROTOCOLS_SQL_MODE_CONNECTIONTIME';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::common::protocols::sql::mode::connectiontime;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  use Time::HiRes;
  use POSIX;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "warning:s"       => { name => 'warning', },
          "critical:s"      => { name => 'critical', },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
         $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
         $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
         $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
         $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      my $now = Time::HiRes::time();
      my ($exit, $msg_error) = $self->{sql}->connect(dontquit => 1);
      my $now2 = Time::HiRes::time();
      $self->{sql}->disconnect();
   
      if ($exit == -1) {
          $self->{output}->output_add(severity => 'CRITICAL',
                                      short_msg => $msg_error);
      } else {
  		my $milliseconds = $now2 - $now;
          $milliseconds = floor($milliseconds * 1000);
          my $exit_code = $self->{perfdata}->threshold_check(value => $milliseconds, threshold => [ { label => 'critical', 'exit_litteral' => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
          $self->{output}->output_add(severity => $exit_code,
                                      short_msg => sprintf("Connection established in %.3fs.", $milliseconds / 1000));
          $self->{output}->perfdata_add(label => 'connection_time',
                                        value => $milliseconds,
                                        unit => 'ms',
                                        warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning'),
                                        critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical'),
                                        min => 0);
      }
      
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check database connection time.
  
  =over 8
  
  =item B<--warning>
  
  Threshold warning in milliseconds.
  
  =item B<--critical>
  
  Threshold critical in milliseconds.
  
  =back
  
  =cut
CENTREON_COMMON_PROTOCOLS_SQL_MODE_CONNECTIONTIME

$fatpacked{"centreon/common/protocols/sql/mode/sql.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_COMMON_PROTOCOLS_SQL_MODE_SQL';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::common::protocols::sql::mode::sql;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "sql-statement:s"         => { name => 'sql_statement', },
          "format:s"                => { name => 'format', default => 'SQL statement result : %i.'},
          "perfdata-unit:s"         => { name => 'perfdata_unit', default => ''},
          "perfdata-name:s"         => { name => 'perfdata_name', default => 'value'},
          "perfdata-min:s"          => { name => 'perfdata_min', default => ''},
          "perfdata-max:s"          => { name => 'perfdata_max', default => ''},
          "warning:s"               => { name => 'warning', },
          "critical:s"              => { name => 'critical', },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
         $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
         $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
         $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
         $self->{output}->option_exit();
      }
      if (!defined($self->{option_results}->{sql_statement}) || $self->{option_results}->{sql_statement} eq '') {
          $self->{output}->add_option_msg(short_msg => "Need to specify '--sql-statement' option.");
          $self->{output}->option_exit();
      }
      if (!defined($self->{option_results}->{format}) || $self->{option_results}->{format} eq '') {
          $self->{output}->add_option_msg(short_msg => "Need to specify '--format' option.");
          $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
  
      my $query = $self->{option_results}->{sql_statement};
  
      $self->{sql}->connect();
      $self->{sql}->query(query => $query);
      my $value = $self->{sql}->fetchrow_array();
      $self->{sql}->disconnect();
  
      my $exit_code = $self->{perfdata}->threshold_check(value => $value, threshold => [ { label => 'critical', 'exit_litteral' => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
      $self->{output}->output_add(severity => $exit_code,
                                  short_msg => sprintf($self->{option_results}->{format}, $value));
      $self->{output}->perfdata_add(label => $self->{option_results}->{perfdata_name},
                                    unit => $self->{option_results}->{perfdata_unit},
                                    value => $value,
                                    warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning'),
                                    critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical'),
                                    min => $self->{option_results}->{perfdata_min},
                                    max => $self->{option_results}->{perfdata_max});
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check SQL statement.
  
  =over 8
  
  =item B<--sql-statement>
  
  SQL statement that returns a number.
  
  =item B<--format>
  
  Output format (Default: 'SQL statement result : %i.').
  
  =item B<--perfdata-unit>
  
  Perfdata unit in perfdata output (Default: '')
  
  =item B<--perfdata-name>
  
  Perfdata name in perfdata output (Default: 'value')
  
  =item B<--perfdata-min>
  
  Minimum value to add in perfdata output (Default: '')
  
  =item B<--perfdata-max>
  
  Maximum value to add in perfdata output (Default: '')
  
  =item B<--warning>
  
  Threshold warning.
  
  =item B<--critical>
  
  Threshold critical.
  
  =back
  
  =cut
CENTREON_COMMON_PROTOCOLS_SQL_MODE_SQL

$fatpacked{"centreon/common/protocols/sql/mode/sqlstring.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_COMMON_PROTOCOLS_SQL_MODE_SQLSTRING';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::common::protocols::sql::mode::sqlstring;
  
  use base qw(centreon::plugins::templates::counter);
  use strict;
  use warnings;
  use centreon::plugins::templates::catalog_functions qw(catalog_status_threshold);
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'rows', type => 1, message_multiple => "SQL Query is OK" },
      ];
  
      $self->{maps_counters}->{rows} = [
          { label => 'string', threshold => 0, set => {
                  key_values => [ { name => 'key_field' }, { name => 'value_field' } ],
                  closure_custom_calc => $self->can('custom_string_calc'),
                  closure_custom_output => $self->can('custom_string_output'),
                  closure_custom_threshold_check => $self->can('custom_string_threshold'),
                  closure_custom_perfdata => sub { return 0; },
              }
          },
      ];
  }
  
  sub custom_string_calc {
      my ($self, %options) = @_;
  
      $self->{result_values}->{key_field} = $options{new_datas}->{$self->{instance} . '_key_field'};
      $self->{result_values}->{value_field} = $options{new_datas}->{$self->{instance} . '_value_field'};
  
      return 0;
  }
  
  sub custom_string_output {
      my ($self, %options) = @_;
  
      my $msg;
      my $message;
  
      if (defined($self->{instance_mode}->{option_results}->{printf_format}) && $self->{instance_mode}->{option_results}->{printf_format} ne '') {
          eval {
              local $SIG{__WARN__} = sub { $message = $_[0]; };
              local $SIG{__DIE__} = sub { $message = $_[0]; };
              $msg = sprintf("$self->{instance_mode}->{option_results}->{printf_format}", eval $self->{instance_mode}->{option_results}->{printf_value});
          };
      } else {
          $msg = sprintf("'%s'", $self->{result_values}->{value_field});
      }
  
      if (defined($message)) {
          $self->{output}->output_add(long_msg => 'output value issue: ' . $message);
      }
      return $msg;
  }
  
  sub custom_string_threshold {
      my ($self, %options) = @_;
      my $status = 'ok';
      my $message;
  
      eval {
          local $SIG{__WARN__} = sub { $message = $_[0]; };
          local $SIG{__DIE__} = sub { $message = $_[0]; };
  
          if (defined($self->{instance_mode}->{option_results}->{critical_string}) && $self->{instance_mode}->{option_results}->{critical_string} ne '' &&
              eval "$self->{instance_mode}->{option_results}->{critical_string}") {
              $status = 'critical';
          } elsif (defined($self->{instance_mode}->{option_results}->{warning_string}) && $self->{instance_mode}->{option_results}->{warning_string} ne '' &&
              eval "$self->{instance_mode}->{option_results}->{warning_string}") {
              $status = 'warning';
          }
      };
  
      if (defined($message)) {
          $self->{output}->output_add(long_msg => 'threshold regex issue: ' . $message);
      }
  
      return $status;
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "sql-statement:s"         => { name => 'sql_statement' },
          "key-column:s"            => { name => 'key_column' },
          "value-column:s"          => { name => 'value_column' },
          "warning-string:s"        => { name => 'warning_string', default => '' },
          "critical-string:s"       => { name => 'critical_string', default => '' },
          "printf-format:s"         => { name => 'printf_format' },
          "printf-value:s"          => { name => 'printf_value' },
          "dual-table"              => { name => 'dual_table' },
          "empty-sql-string:s"      => { name => 'empty_sql_string', default => 'No row returned or --key-column/--value-column do not correctly match selected field' },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::check_options(%options);
  
      if (!defined($self->{option_results}->{sql_statement}) || $self->{option_results}->{sql_statement} eq '') {
          $self->{output}->add_option_msg(short_msg => "Need to specify '--sql-statement' option.");
          $self->{output}->option_exit();
      }
  
      $self->change_macros(macros => ['warning_string', 'critical_string']);
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
      $self->{sql}->connect();
      $self->{sql}->query(query => $self->{option_results}->{sql_statement});
      $self->{rows} = {};
      my $row_count = 0;
  
      while (my $row = $self->{sql}->fetchrow_hashref()) {
          if (defined($self->{option_results}->{dual_table})) {
              $row->{$self->{option_results}->{value_column}} = delete $row->{keys %{$row}};
              foreach (keys %{$row}) {
                  $row->{$self->{option_results}->{value_column}} = $row->{$_};
              }
          }
          if (!defined($self->{option_results}->{key_column})) {
              $self->{rows}->{$self->{option_results}->{value_column} . $row_count} = { key_field => $row->{$self->{option_results}->{value_column}},
                                                                                        value_field => $row->{$self->{option_results}->{value_column}}};
              $row_count++;
          } else {
              $self->{rows}->{$self->{option_results}->{key_column} . $row_count} = { key_field => $row->{$self->{option_results}->{key_column}},
                                                                                      value_field => $row->{$self->{option_results}->{value_column}}};
              $row_count++;
          }
      }
  
      $self->{sql}->disconnect();
      if (scalar(keys %{$self->{rows}}) <= 0) {
          $self->{output}->add_option_msg(short_msg => $self->{option_results}->{empty_sql_string});
          $self->{output}->option_exit();
      }
  
  }
  
  1;
  
  
  =head1 MODE
  
  Check SQL statement to query string pattern (You cannot have more than to fiels in select)
  
  =over 8
  
  =item B<--sql-statement>
  
  SQL statement that returns a string.
  
  =item B<--key-column>
  
  Key column (must be one of the selected field). NOT mandatory if you select only one field
  
  =item B<--value-column>
  
  Value column (must be one of the selected field). MANDATORY
  
  =item B<--printf-format>
  
  Specify a custom output message relying on printf formatting
  
  =item B<--printf-value>
  
  Specify scalar used to replace in printf
  (Can be: $self->{result_values}->{key_field}, $self->{result_values}->{value_field})
  
  =item B<--warning-string>
  
  Set warning condition (if statement syntax) for status evaluation.
  (Can be: %{key_field}, %{value_field})
  e.g --warning-string '%{key_field} eq 'Central' && %{value_field} =~ /127.0.0.1/'
  
  =item B<--critical-string>
  
  Set critical condition (if statement syntax) for status evaluation.
  (Can be: %{key_field} or %{value_field})
  
  =item B<--dual-table>
  
  Set this option to ensure compatibility with dual table and Oracle.
  
  =item B<--empty-sql-string>
  
  Set this option to change the output message when the sql statement result is empty.
  (Default: 'No row returned or --key-column/--value-column do not correctly match selected field')
  
  =back
  
  =cut
CENTREON_COMMON_PROTOCOLS_SQL_MODE_SQLSTRING

$fatpacked{"centreon/plugins/alternative/FatPackerOptions.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_ALTERNATIVE_FATPACKEROPTIONS';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::alternative::FatPackerOptions;
  
  use base qw(centreon::plugins::options);
  
  use strict;
  use warnings;
  use Pod::Usage;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      return $self;
  }
  
  sub display_help {
      my ($self, %options) = @_;
      
      my $stdout;
      foreach (@{$self->{pod_package}}) {
          
          {
              my $pp = $_->{package} . ".pm";
              $pp =~ s{::}{/}g;
              my $content_class = $INC{$pp}->{$pp};
              open my $str_fh, '<', \$content_class;
              
              local *STDOUT;
              open STDOUT, '>', \$stdout;
              pod2usage(-exitval => 'NOEXIT', -input => $str_fh,
                        -verbose => 99, 
                        -sections => $_->{sections});
              
              close $str_fh;
          }
          
          $self->{output}->add_option_msg(long_msg => $stdout) if (defined($stdout));
      }
  }
  
  1;
  
CENTREON_PLUGINS_ALTERNATIVE_FATPACKEROPTIONS

$fatpacked{"centreon/plugins/alternative/Getopt.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_ALTERNATIVE_GETOPT';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::alternative::Getopt;
  
  use strict;
  use warnings;
  
  use Exporter;
  use vars qw(@ISA @EXPORT @EXPORT_OK);
  @ISA = qw(Exporter);
  
  BEGIN {
      @EXPORT    = qw(&GetOptions);
      @EXPORT_OK = qw();
  }
  
  use vars @EXPORT, @EXPORT_OK;
  
  our $warn_message = 0;
  
  sub get_assigned_value {
      my (%options) = @_;
      
      if (!defined($options{val}) || $options{val} eq '') {
          # Add defined also. Hardened code: already see: $ARGV[6] = undef for example
          if ($options{pos} + 1 < $options{num_args} && defined($ARGV[$options{pos} + 1]) && $ARGV[$options{pos} + 1] !~ /^--/) {
              my $val = $ARGV[$options{pos} + 1];
              splice @ARGV, $options{pos} + 1, 1;
              return ($options{num_args} - 1, $val);
          } else {
              return ($options{num_args}, '');
          }
      }
      
      return ($options{num_args}, $options{val});
  }
  
  sub GetOptions {
      my (%opts) = @_;
      
      my $search_str = ',' . join(',', keys %opts) . ',';
      my $num_args = scalar(@ARGV);
      for (my $i = 0; $i < $num_args;) {
          if (defined($ARGV[$i]) && $ARGV[$i] =~ /^--(.*?)(?:=|$)(.*)/) {
              my ($option, $value) = ($1, $2);
              
              # find type of option
              if ($search_str !~ /,((?:[^,]*?\|){0,}$option(?:\|.*?){0,}(:.*?){0,1}),/) {
                  warn "Unknown option: $option" if ($warn_message == 1);
                  $i++;
                  next;
              }
              
              my ($option_selected, $type_opt) = ($1, $2);
              if (!defined($type_opt)) {
                  ${$opts{$option_selected}} = 1;
              } elsif ($type_opt =~ /:s$/) {
                  ($num_args, my $assigned) = get_assigned_value(num_args => $num_args, pos => $i, val => $value);
                  ${$opts{$option_selected}} = $assigned;
              } elsif ($type_opt =~ /:s\@$/) {
                  ${$opts{$option . $type_opt}} = [] if (!defined(${$opts{$option . $type_opt}}));
                  ($num_args, my $assigned) = get_assigned_value(num_args => $num_args, pos => $i, val => $value);
                  push @{${$opts{$option_selected}}}, $assigned;
              } elsif ($type_opt =~ /:s\%$/) {
                  ${$opts{$option . $type_opt}} = {} if (!defined(${$opts{$option . $type_opt}}));
                  ($num_args, my $assigned) = get_assigned_value(num_args => $num_args, pos => $i, val => $value);
                  if ($assigned =~ /^(.*?)=(.*)/) {
                      ${$opts{$option_selected}}->{$1} = $2;
                  }
              } 
              
              splice @ARGV, $i, 1;
              $num_args--;
          } else {
              warn "argument $ARGV[$i] alone" if ($warn_message == 1 && $i != 0 && defined($ARGV[$i]));
              $i++;
          }
      }
  }
  
  1;
  
CENTREON_PLUGINS_ALTERNATIVE_GETOPT

$fatpacked{"centreon/plugins/dbi.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_DBI';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::dbi;
  
  use strict;
  use warnings;
  use DBI;
  use Digest::MD5 qw(md5_hex);
  
  my %handlers = ( ALRM => {} );
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
      # $options{options} = options object
      # $options{output} = output object
      # $options{exit_value} = integer
      # $options{noptions} = integer
  
      if (!defined($options{output})) {
          print "Class DBI: Need to specify 'output' argument.\n";
          exit 3;
      }
      if (!defined($options{options})) {
          $options{output}->add_option_msg(short_msg => "Class DBI: Need to specify 'options' argument.");
          $options{output}->option_exit();
      }
      
      if (!defined($options{noptions})) {
          $options{options}->add_options(arguments => {
              'datasource:s@'      => { name => 'data_source' },
              'username:s@'        => { name => 'username' },
              'password:s@'        => { name => 'password' },
              'connect-options:s@' => { name => 'connect_options' },
              'sql-errors-exit:s'  => { name => 'sql_errors_exit', default => 'unknown' },
              'timeout:s'          => { name => 'timeout' },
          });
      }
      $options{options}->add_help(package => __PACKAGE__, sections => 'DBI OPTIONS', once => 1);
  
      $self->{output} = $options{output};
      $self->{mode} = $options{mode};
      $self->{instance} = undef;
      $self->{statement_handle} = undef;
      $self->{version} = undef;
      
      $self->{data_source} = undef;
      $self->{username} = undef;
      $self->{password} = undef;
      $self->{connect_options} = undef;
      $self->{connect_options_hash} = {};
      
      # Sometimes, we need to set ENV
      $self->{env} = undef;
      
      $self->set_signal_handlers();
      
      return $self;
  }
  
  sub set_signal_handlers {
      my $self = shift;
  
      $SIG{ALRM} = \&class_handle_ALRM;
      $handlers{ALRM}->{$self} = sub { $self->handle_ALRM() };
  }
  
  sub class_handle_ALRM {
      foreach (keys %{$handlers{ALRM}}) {
          &{$handlers{ALRM}->{$_}}();
      }
  }
  
  sub handle_ALRM {
      my $self = shift;
  
      $self->disconnect();
      $self->{output}->output_add(severity => $self->{sql_errors_exit},
                                  short_msg => 'Timeout');
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  # Method to manage multiples
  sub set_options {
      my ($self, %options) = @_;
      # options{options_result}
  
      $self->{option_results} = $options{option_results};
  }
  
  # Method to manage multiples
  sub set_defaults {
      my ($self, %options) = @_;
      # options{default}
      
      # Manage default value
      foreach (keys %{$options{default}}) {
          if ($_ eq $self->{mode}) {
              for (my $i = 0; $i < scalar(@{$options{default}->{$_}}); $i++) {
                  foreach my $opt (keys %{$options{default}->{$_}[$i]}) {
                      if (!defined($self->{option_results}->{$opt}[$i])) {
                          $self->{option_results}->{$opt}[$i] = $options{default}->{$_}[$i]->{$opt};
                      }
                  }
              }
          }
      }
  }
  
  sub check_options {
      my ($self, %options) = @_;
      # return 1 = ok still data_source
      # return 0 = no data_source left
      
      $self->{data_source} = (defined($self->{option_results}->{data_source})) ? shift(@{$self->{option_results}->{data_source}}) : undef;
      $self->{username} = (defined($self->{option_results}->{username})) ? shift(@{$self->{option_results}->{username}}) : undef;
      $self->{password} = (defined($self->{option_results}->{password})) ? shift(@{$self->{option_results}->{password}}) : undef;
      $self->{connect_options} = (defined($self->{option_results}->{connect_options})) ? shift(@{$self->{option_results}->{connect_options}}) : undef;
      $self->{env} = (defined($self->{option_results}->{env})) ? shift(@{$self->{option_results}->{env}}) : undef;
      $self->{sql_errors_exit} = $self->{option_results}->{sql_errors_exit};
      
      $self->{timeout} = 10;
      if (defined($self->{option_results}->{timeout}) && $self->{option_results}->{timeout} =~ /^\d+$/ &&
          $self->{option_results}->{timeout} > 0) {
          $self->{timeout} = $self->{option_results}->{timeout};
      }
      
      if (!defined($self->{data_source}) || $self->{data_source} eq '') {
          $self->{output}->add_option_msg(short_msg => 'Need to specify data_source arguments.');
          $self->{output}->option_exit(exit_litteral => $self->{sql_errors_exit});
      }
      if (defined($self->{connect_options}) && $self->{connect_options} ne '') {
          foreach my $entry (split /,/, $self->{connect_options}) {
              if ($entry !~ /^\s*([^=]+)=([^=]+)\s*$/) {
                  $self->{output}->add_option_msg(short_msg => "Wrong format for --connect-options '" . $entry . "'.");
                  $self->{output}->option_exit(exit_litteral => $self->{sql_errors_exit});
              }
              $self->{connect_options_hash}->{$1} = $2;
          }
      }
      
      if (scalar(@{$self->{option_results}->{data_source}}) == 0) {
          return 0;
      }
      return 1;
  }
  
  sub quote {
      my $self = shift;
  
      if (defined($self->{instance})) {
          return $self->{instance}->quote($_[0]);
      }
      return undef;
  }
  
  sub is_version_minimum {
      my ($self, %options) = @_;
      # $options{version} = string version to check
      
      my @version_src = split /\./, $self->{version};
      my @versions = split /\./, $options{version};
      for (my $i = 0; $i < scalar(@versions); $i++) {
          return 1 if ($versions[$i] eq 'x');
          return 1 if (!defined($version_src[$i]));
          $version_src[$i] =~ /^([0-9]*)/;
          next if ($versions[$i] == int($1));
          return 0 if ($versions[$i] > int($1));
          return 1 if ($versions[$i] < int($1));
      }
      
      return 1;
  }
  
  sub set_version {
      my ($self) = @_;
      
      $self->{version} = $self->{instance}->get_info(18); # SQL_DBMS_VER
  }
  
  sub disconnect {
      my ($self) = @_;
      
      if (defined($self->{instance})) {
          $self->{statement_handle} = undef;
          $self->{instance}->disconnect();
      }
  }
      
  sub connect {
      my ($self, %options) = @_;
      my $dontquit = (defined($options{dontquit}) && $options{dontquit} == 1) ? 1 : 0;
  
      # Set ENV
      if (defined($self->{env})) {
          foreach (keys %{$self->{env}}) {
              $ENV{$_} = $self->{env}->{$_};
          }
      }
      
      alarm($self->{timeout}) if (defined($self->{timeout}));
      $self->{instance} = DBI->connect(
          "DBI:". $self->{data_source},
          $self->{username},
          $self->{password},
          { RaiseError => 0, PrintError => 0, AutoCommit => 1, %{$self->{connect_options_hash}} }
      );
      alarm(0) if (defined($self->{timeout}));
  
      if (!defined($self->{instance})) {
          my $err_msg = sprintf('Cannot connect: %s', defined($DBI::errstr) ? $DBI::errstr : '(no error string)');
          if ($dontquit == 0) {
              $self->{output}->add_option_msg(short_msg => $err_msg);
              $self->{output}->option_exit(exit_litteral => $self->{sql_errors_exit});
          }
          return (-1, $err_msg);
      }
      
      $self->set_version();
      return 0;
  }
  
  sub get_id {
      my ($self, %options) = @_;
      
      return $self->{data_source};
  }
  
  sub get_unique_id4save {
      my ($self, %options) = @_;
  
      return md5_hex($self->{data_source});
  }
  
  sub fetchall_arrayref {
      my ($self, %options) = @_;
      
      return $self->{statement_handle}->fetchall_arrayref();
  }
  
  sub fetchrow_array {
      my ($self, %options) = @_;
      
      return $self->{statement_handle}->fetchrow_array();
  }
  
  sub fetchrow_hashref {
      my ($self, %options) = @_;
      
      return $self->{statement_handle}->fetchrow_hashref();
  }
  
  sub query {
      my ($self, %options) = @_;
      my $continue_error = defined($options{continue_error}) && $options{continue_error} == 1 ? 1 : 0;
      
      $self->{statement_handle} = $self->{instance}->prepare($options{query});
      if (!defined($self->{statement_handle})) {
          return 1 if ($continue_error == 1);
          $self->{output}->add_option_msg(short_msg => 'Cannot execute query: ' . $self->{instance}->errstr);
          $self->disconnect();
          $self->{output}->option_exit(exit_litteral => $self->{sql_errors_exit});
      }
  
      my $rv = $self->{statement_handle}->execute;
      if (!$rv) {
          return 1 if ($continue_error == 1);
          $self->{output}->add_option_msg(short_msg => 'Cannot execute query: ' . $self->{statement_handle}->errstr);
          $self->disconnect();
          $self->{output}->option_exit(exit_litteral => $self->{sql_errors_exit});
      }
      
      return 0;
  }
  
  1;
  
  
  =head1 NAME
  
  DBI global
  
  =head1 SYNOPSIS
  
  dbi class
  
  =head1 DBI OPTIONS
  
  =over 8
  
  =item B<--datasource>
  
  Datasource (required. Depends of database server).
  
  =item B<--username>
  
  Database username.
  
  =item B<--password>
  
  Database password.
  
  =item B<--connect-options>
  
  Add options in database connect.
  Format: name=value,name2=value2,...
  
  =item B<--sql-errors-exit>
  
  Exit code for DB Errors (default: unknown)
  
  =item B<--timeout>
  
  Timeout in seconds for connection
  
  =back
  
  =head1 DESCRIPTION
  
  B<snmp>.
  
  =cut
CENTREON_PLUGINS_DBI

$fatpacked{"centreon/plugins/misc.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_MISC';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::misc;
  
  use strict;
  use warnings;
  use utf8;
  
  sub execute {
      my (%options) = @_;
      
      if ($^O eq 'MSWin32') {
          return windows_execute(%options, timeout => $options{options}->{timeout});
      } else {
          return unix_execute(%options);
      }
  }
  
  sub windows_execute {
      my (%options) = @_;
      my $result;
      my ($stdout, $pid, $ended) = ('');
      my ($exit_code, $cmd);
      
      $cmd = $options{command_path} . '/' if (defined($options{command_path}));
      $cmd .= $options{command} . ' ' if (defined($options{command}));
      $cmd .= $options{command_options} if (defined($options{command_options}));
      
      centreon::plugins::misc::mymodule_load(output => $options{output}, module => 'Win32::Job',
                                             error_msg => "Cannot load module 'Win32::Job'.");
      centreon::plugins::misc::mymodule_load(output => $options{output}, module => 'Time::HiRes',
                                             error_msg => "Cannot load module 'Time::HiRes'.");
      
      $| = 1;
      pipe FROM_CHILD, TO_PARENT or do {
          $options{output}->add_option_msg(short_msg => "Internal error: can't create pipe from child to parent: $!");
          $options{output}->option_exit();
      };
      my $job = Win32::Job->new;
      my $stderr = 'NUL';
      $stderr = \*TO_PARENT if ($options{output}->is_debug());
      if (!($pid = $job->spawn(undef, $cmd,
                         { stdin => 'NUL',
                           stdout => \*TO_PARENT,
                           stderr => $stderr }))) {
          $options{output}->add_option_msg(short_msg => "Internal error: execution issue: $^E");
          $options{output}->option_exit();
      }
      close TO_PARENT;
  
      my $ein = '';
      vec($ein, fileno(FROM_CHILD), 1) = 1;
      $job->watch(
          sub {            
              my ($buffer);
              my $time = $options{timeout};
              my $last_time = Time::HiRes::time();
              $ended = 0;
              while (select($ein, undef, undef, $options{timeout})) {
                  if (sysread(FROM_CHILD, $buffer, 16384)) {
                      $buffer =~ s/\r//g;
                      $stdout .= $buffer;
                  } else {
                      $ended = 1;
                      last;
                  }
                  $options{timeout} -= Time::HiRes::time() - $last_time;
                  last if ($options{timeout} <= 0);         
                  $last_time = Time::HiRes::time();
              }
              return 1 if ($ended == 0);
              return 0;
          },
          0.1
      );
          
      $result = $job->status;
      close FROM_CHILD;    
      
      if ($ended == 0) {
          $options{output}->add_option_msg(short_msg => 'Command too long to execute (timeout)...');
          $options{output}->option_exit();
      }
      chomp $stdout;
      
      if (defined($options{no_quit}) && $options{no_quit} == 1) {
          return ($stdout, $result->{$pid}->{exitcode});
      }
      
      if ($result->{$pid}->{exitcode} != 0) {
          $stdout =~ s/\n/ - /g;
          $options{output}->add_option_msg(short_msg => "Command error: $stdout");
          $options{output}->option_exit();
      }
      
      return ($stdout, $result->{$pid}->{exitcode});
  }
  
  sub unix_execute {
      my (%options) = @_;
      my $cmd = '';
      my $args = [];
      my ($lerror, $stdout, $exit_code);
  
      my $redirect_stderr = 1;
      $redirect_stderr = $options{redirect_stderr} if (defined($options{redirect_stderr}));
      my $wait_exit = 1;
      $wait_exit = $options{wait_exit} if (defined($options{wait_exit}));
      
      # Build command line
      # Can choose which command is done remotely (can filter and use local file)
      if (defined($options{options}->{remote}) && 
          ($options{options}->{remote} eq '' || !defined($options{label}) || $options{label} =~ /$options{options}->{remote}/)) {
          my $sub_cmd;
  
          $cmd = $options{options}->{ssh_path} . '/' if (defined($options{options}->{ssh_path}));
          $cmd .= $options{options}->{ssh_command} if (defined($options{options}->{ssh_command}));
          
          foreach (@{$options{options}->{ssh_option}}) {
              my ($lvalue, $rvalue) = split /=/;
              push @$args, $lvalue if (defined($lvalue));
              push @$args, $rvalue if (defined($rvalue));
          }
          
          if (defined($options{options}->{ssh_address}) && $options{options}->{ssh_address} ne '') {
              push @$args, $options{options}->{ssh_address};
          } else {
              push @$args, $options{options}->{hostname};
          }
  		
          $sub_cmd = 'sudo ' if (defined($options{sudo}));
          $sub_cmd .= $options{command_path} . '/' if (defined($options{command_path}));
          $sub_cmd .= $options{command} . ' ' if (defined($options{command}));
          $sub_cmd .= $options{command_options} if (defined($options{command_options}));
          # On some equipment. Cannot get a pseudo terminal
          if (defined($options{ssh_pipe}) && $options{ssh_pipe} == 1) {
              $cmd = "echo '" . $sub_cmd . "' | " . $cmd . ' ' . join(' ', @$args);
              ($lerror, $stdout, $exit_code) = backtick(
                  command => $cmd,
                  timeout => $options{options}->{timeout},
                  wait_exit => $wait_exit,
                  redirect_stderr => $redirect_stderr
              );
          } else {
              ($lerror, $stdout, $exit_code) = backtick(
                  command => $cmd,
                  arguments => [@$args, $sub_cmd],
                  timeout => $options{options}->{timeout},
                  wait_exit => $wait_exit,
                  redirect_stderr => $redirect_stderr
              );
          }
      } else {
          $cmd = 'sudo ' if (defined($options{sudo}));
          $cmd .= $options{command_path} . '/' if (defined($options{command_path}));
          $cmd .= $options{command} . ' ' if (defined($options{command}));
          $cmd .= $options{command_options} if (defined($options{command_options}));
          
          ($lerror, $stdout, $exit_code) = backtick(
              command => $cmd,
              timeout => $options{options}->{timeout},
              wait_exit => $wait_exit,
              redirect_stderr => $redirect_stderr
          );
      }
  
      if (defined($options{options}->{show_output}) && 
          ($options{options}->{show_output} eq '' || (defined($options{label}) && $options{label} eq $options{options}->{show_output}))) {
          print $stdout;
          exit $exit_code;
      }
      
      $stdout =~ s/\r//g;
      if ($lerror <= -1000) {
          $options{output}->add_option_msg(short_msg => $stdout);
          $options{output}->option_exit();
      }
      
      if (defined($options{no_quit}) && $options{no_quit} == 1) {
          return ($stdout, $exit_code);
      }
      
      if ($exit_code != 0 && (!defined($options{no_errors}) || !defined($options{no_errors}->{$exit_code}))) {
          $stdout =~ s/\n/ - /g;
          $options{output}->add_option_msg(short_msg => "Command error: $stdout");
          $options{output}->option_exit();
      }
      
      return $stdout;
  }
  
  sub mymodule_load {
      my (%options) = @_;
      my $file;
      ($file = ($options{module} =~ /\.pm$/ ? $options{module} : $options{module} . '.pm')) =~ s{::}{/}g;
      
      eval {
          local $SIG{__DIE__} = 'IGNORE';
          require $file;
          $file =~ s{/}{::}g;
          $file =~ s/\.pm$//;
      };
      if ($@) {
          return 1 if (defined($options{no_quit}) && $options{no_quit} == 1);
          $options{output}->add_option_msg(long_msg => $@);
          $options{output}->add_option_msg(short_msg => $options{error_msg});
          $options{output}->option_exit();
      }
      return wantarray ? (0, $file) : 0;
  }
  
  sub backtick {
      my %arg = (
          command => undef,
          arguments => [],
          timeout => 30,
          wait_exit => 0,
          redirect_stderr => 0,
          @_,
      );
      my @output;
      my $pid;
      my $return_code;
      
      my $sig_do;
      if ($arg{wait_exit} == 0) {
          $sig_do = 'IGNORE';
          $return_code = undef;
      } else {
          $sig_do = 'DEFAULT';
      }
      local $SIG{CHLD} = $sig_do;
      $SIG{TTOU} = 'IGNORE';
      $| = 1;
  
      if (!defined($pid = open( KID, "-|" ))) {
          return (-1001, "Cant fork: $!", -1);
      }
  
      if ($pid) {
          
          eval {
             local $SIG{ALRM} = sub { die "Timeout by signal ALARM\n"; };
             alarm( $arg{timeout} );
             while (<KID>) {
                 chomp;
                 push @output, $_;
             }
  
             alarm(0);
          };
  
          if ($@) {
              if ($pid != -1) {
                  kill -9, $pid;
              }
  
              alarm(0);
              return (-1000, 'Command too long to execute (timeout)...', -1);
          } else {
              if ($arg{wait_exit} == 1) {
                  # We're waiting the exit code                
                  waitpid($pid, 0);
                  $return_code = ($? >> 8);
              }
              close KID;
          }
      } else {
          # child
          # set the child process to be a group leader, so that
          # kill -9 will kill it and all its descendents
          # We have ignore SIGTTOU to let write background processes
          setpgrp( 0, 0 );
  
          if ($arg{redirect_stderr} == 1) {
              open STDERR, '>&STDOUT';
          }
          if (scalar(@{$arg{arguments}}) <= 0) {
              exec($arg{command});
          } else {
              exec($arg{command}, @{$arg{arguments}});
          }
          # Exec is in error. No such command maybe.
          exit(127);
      }
  
      return (0, join("\n", @output), $return_code);
  }
  
  sub trim {
      my ($value) = $_[0];
      
      # Sometimes there is a null character
      $value =~ s/\x00$//;
      $value =~ s/^[ \t\n]+//;
      $value =~ s/[ \t\n]+$//;
      return $value;
  }
  
  sub powershell_encoded {
      my ($value) = $_[0];
  
      require Encode;
      require MIME::Base64;
      my $bytes = Encode::encode('utf16LE', $value);
      my $script = MIME::Base64::encode_base64($bytes, "\n");
      $script =~ s/\n//g;
      return $script;
  }
  
  sub powershell_escape {
      my ($value) = $_[0];
      $value =~ s/`/``/g;
      $value =~ s/#/`#/g;
      $value =~ s/'/`'/g;
      $value =~ s/"/`"/g;
      return $value;
  }
  
  sub powershell_json_sanitizer {
      my (%options) = @_;
  
      centreon::plugins::misc::mymodule_load(output => $options{output}, module => 'JSON::XS',
                                             error_msg => "Cannot load module 'JSON::XS'.");
      foreach my $line (split /\n/, $options{string}) {
          eval { JSON::XS->new->utf8->decode($line) };
          return $line if (!$@);
      }
      return -1;
  }
  
  sub minimal_version {
      my ($version_src, $version_dst) = @_;
          
      # No Version. We skip   
      if (!defined($version_src) || !defined($version_dst) || 
          $version_src !~ /^[0-9]+(?:\.[0-9\.]+)*$/ || $version_dst !~ /^[0-9x]+(?:\.[0-9x]+)*$/) {
          return 1;
      }
    
      my @version_src = split /\./, $version_src;
      my @versions = split /\./, $version_dst;
      for (my $i = 0; $i < scalar(@versions); $i++) {
          return 1 if ($versions[$i] eq 'x');
          return 1 if (!defined($version_src[$i]));
          $version_src[$i] =~ /^([0-9]*)/;
          next if ($versions[$i] == int($1));
          return 0 if ($versions[$i] > int($1));
          return 1 if ($versions[$i] < int($1));
      }
      
      return 1;
  }
  
  sub change_seconds {
      my %options = @_;
      my ($str, $str_append) = ('', '');
      my $periods = [
          { unit => 'y', value => 31556926 },
          { unit => 'M', value => 2629743 },
          { unit => 'w', value => 604800 },
          { unit => 'd', value => 86400 },
          { unit => 'h', value => 3600 },
          { unit => 'm', value => 60 },
          { unit => 's', value => 1 },
      ];
      my %values = ('y' => 1, 'M' => 2, 'w' => 3, 'd' => 4, 'h' => 5, 'm' => 6, 's' => 7);
  
      foreach (@$periods) {
          next if (defined($options{start}) && $values{$_->{unit}} < $values{$options{start}});
          my $count = int($options{value} / $_->{value});
  
          next if ($count == 0);
          $str .= $str_append . $count . $_->{unit};
          $options{value} = $options{value} % $_->{value};
          $str_append = ' ';
      }
  
      return $str;
  }
  
  sub scale_bytesbit {
      my (%options) = @_;
      
      my $base = 1024;
      if (defined($options{dst_unit}) && defined($options{src_unit})) {
          $options{value} *= 8 if ($options{dst_unit} =~ /b/ && $options{src_unit} =~ /B/);
          $options{value} /= 8 if ($options{dst_unit} =~ /B/ && $options{src_unit} =~ /b/);
          if ($options{dst_unit} =~ /b/) {
              $base = 1000;
          }
      }
          
      my %expo = ('' => 0, k => 1, m => 2, g => 3, t => 4, p => 5, e => 6);
      my ($src_expo, $dst_expo) = (0, 0);
      $src_expo = $expo{lc($options{src_quantity})} if (defined($options{src_quantity}) && $options{src_quantity} =~ /[kmgtpe]/i);
      if ($options{dst_unit} eq 'auto') {
          my @auto = ('', 'k', 'm', 'g', 't', 'p', 'e');
          my $i = defined($options{src_quantity}) ? $expo{$options{src_quantity}} : 0;
          for (; $i < scalar(@auto); $i++) {
              last if ($options{value} < $base);
              $options{value} = $options{value} / $base;
          }
  
          return ($options{value}, $auto[$i], $options{src_unit});
      } elsif (defined($options{dst_quantity}) && ($options{dst_quantity} eq '' || $options{dst_quantity} =~ /[kmgtpe]/i )) {
          my $dst_expo = $expo{lc($options{dst_quantity})};
          if ($dst_expo - $src_expo > 0) {
              $options{value} = $options{value} / ($base ** ($dst_expo - $src_expo));
          } elsif ($dst_expo - $src_expo < 0) {
              $options{value} = $options{value} * ($base ** (($dst_expo - $src_expo) * -1));
          }
      }
      
      return $options{value};
  }
  
  sub convert_bytes {
      my (%options) = @_;
  
      my %expo = (k => 1, m => 2, g => 3, t => 4, p => 5);
      my $value = $options{value};
      my $base = defined($options{network}) ? 1000 : 1024;    
      if ($options{unit} =~ /([kmgt])b/i) {
          $value = $value * ($base ** $expo{lc($1)});
      }
  
      return $value;
  }
  
  sub expand_exponential {
      my (%options) = @_;
      
      return $options{value} unless ($options{value} =~ /^(.*)e([-+]?)(.*)$/);
      my ($num, $sign, $exp) = ($1, $2, $3);
      my $sig = $sign eq '-' ? "." . ($exp - 1 + length $num) : '';
      return sprintf("%${sig}f", $options{value});
  }
  
  sub parse_threshold {
      my (%options) = @_;
  
      my $perf = trim($options{threshold});
      my $perf_result = { arobase => 0, infinite_neg => 0, infinite_pos => 0, start => '', end => '' };
  
      my $global_status = 1;    
      if ($perf =~ /^(\@?)((?:~|(?:\+|-)?\d+(?:[\.,]\d+)?(?:[KMGTPE][bB])?|):)?((?:\+|-)?\d+(?:[\.,]\d+)?(?:[KMGTPE][bB])?)?$/) {
          $perf_result->{start} = $2 if (defined($2));
          $perf_result->{end} = $3 if (defined($3));
          $perf_result->{arobase} = 1 if (defined($1) && $1 eq '@');
          $perf_result->{start} =~ s/[\+:]//g;
          $perf_result->{end} =~ s/\+//;
          if ($perf_result->{start} =~ s/([KMGTPE])([bB])//) {
              $perf_result->{start} = scale_bytesbit(
                  value => $perf_result->{start},
                  src_unit => $2, dst_unit => $2,
                  src_quantity => $1, dst_quantity => '',
              );
          }
          if ($perf_result->{end} =~ s/([KMGTPE])([bB])//) {
              $perf_result->{end} = scale_bytesbit(
                  value => $perf_result->{end},
                  src_unit => $2, dst_unit => $2,
                  src_quantity => $1, dst_quantity => '',
              );
          }
          if ($perf_result->{end} eq '') {
              $perf_result->{end} = 1e500;
              $perf_result->{infinite_pos} = 1;
          }
          $perf_result->{start} = 0 if ($perf_result->{start} eq '');      
          $perf_result->{start} =~ s/,/\./;
          $perf_result->{end} =~ s/,/\./;
          
          if ($perf_result->{start} eq '~') {
              $perf_result->{start} = -1e500;
              $perf_result->{infinite_neg} = 1;
          }
      } else {
          $global_status = 0;
      }
  
      return ($global_status, $perf_result);
  }
  
  sub get_threshold_litteral {
      my (%options) = @_;
      
      my $perf_output = ($options{arobase} == 1 ? '@' : '') . 
                        (($options{infinite_neg} == 0) ? $options{start} : '~') . 
                        ':' . 
                        (($options{infinite_pos} == 0) ? $options{end} : '');
      return $perf_output;
  }
  
  sub set_timezone {
      my (%options) = @_;
      
      return {} if (!defined($options{name}) || $options{name} eq '');
       
      centreon::plugins::misc::mymodule_load(output => $options{output}, module => 'DateTime::TimeZone',
                                             error_msg => "Cannot load module 'DateTime::TimeZone'.");
      if (DateTime::TimeZone->is_valid_name($options{name})) {
          return { time_zone => DateTime::TimeZone->new(name => $options{name}) };
      }
      
      # try to manage syntax (:Pacific/Noumea for example)
      if ($options{name} =~ /^:(.*)$/ && DateTime::TimeZone->is_valid_name($1)) {
          return { time_zone => DateTime::TimeZone->new(name => $1) };
      }
  
      return {};
  }
  
  1;
  
  
CENTREON_PLUGINS_MISC

$fatpacked{"centreon/plugins/mode.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_MODE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::mode;
  
  use strict;
  use warnings;
  use centreon::plugins::perfdata;
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
  
      $self->{perfdata} = centreon::plugins::perfdata->new(output => $options{output});
      
      %{$self->{option_results}} = ();
      $self->{output} = $options{output};
      $self->{output}->use_new_perfdata(value => 1)
          if (defined($options{force_new_perfdata}) && $options{force_new_perfdata} == 1);
      $self->{mode} = $options{mode};
      $self->{version} = '1.0';
  
      return $self;
  }
  
  sub init {
      my ($self, %options) = @_;
      # options{default} = { mode_xxx => { option_name => option_value }, }
  
      %{$self->{option_results}} = %{$options{option_results}};
      # Manage default value
      return if (!defined($options{default}));
      foreach (keys %{$options{default}}) {
          if ($_ eq $self->{mode}) {
              foreach my $value (keys %{$options{default}->{$_}}) {
                  if (!defined($self->{option_results}->{$value})) {
                      $self->{option_results}->{$value} = $options{default}->{$_}->{$value};
                  }
              }
          }
      }
  }
  
  sub version {
      my ($self, %options) = @_;
      
      $self->{output}->add_option_msg(short_msg => "Mode Version: " . $self->{version});
  }
  
  sub disco_format {
      my ($self, %options) = @_;
  
  }
  
  sub disco_show {
      my ($self, %options) = @_;
  
  }
  
  1;
  
  
CENTREON_PLUGINS_MODE

$fatpacked{"centreon/plugins/options.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_OPTIONS';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::options;
  
  use Pod::Usage;
  use Pod::Find qw(pod_where);
  use strict;
  use warnings;
  
  my $alternative = 1;
  
  sub new {
      my ($class) = @_;
      my $self  = {};
      bless $self, $class;
  
      $self->{sanity} = 0;
      $self->{options_stored} = {};
      $self->{options} = {};
      @{$self->{pod_package}} = ();
      $self->{pod_packages_once} = {};
      
      if ($alternative == 0) {
          require Getopt::Long;
          Getopt::Long->import();
          Getopt::Long::Configure("pass_through");
          Getopt::Long::Configure('bundling');
          Getopt::Long::Configure('no_auto_abbrev');
      } else {
          require centreon::plugins::alternative::Getopt;
          $centreon::plugins::alternative::Getopt::warn_message = 0;
          centreon::plugins::alternative::Getopt->import();
      }
      
      return $self;
  }
  
  sub set_sanity {
      my ($self, %options) = @_;
      
      if ($alternative == 0) {
          Getopt::Long::Configure('no_pass_through');
      } else {
          $centreon::plugins::alternative::Getopt::warn_message = 1;
      }
  
      $self->{sanity} = 1;
  }
  
  sub set_output {
      my ($self, %options) = @_;
      
      $self->{output} = $options{output};
  }
  
  sub display_help {
      my ($self, %options) = @_;
      
      my $stdout;
      foreach (@{$self->{pod_package}}) {
          
          {
              local *STDOUT;
              open STDOUT, '>', \$stdout;
              my $where = pod_where({-inc => 1}, $_->{package});
              pod2usage(-exitval => 'NOEXIT', -input => $where,
                        -verbose => 99, 
                        -sections => $_->{sections}) if (defined($where));
          }
          
          $self->{output}->add_option_msg(long_msg => $stdout) if (defined($stdout));
      }
  }
  
  sub add_help {
      my ($self, %options) = @_;
      # $options{package} = string package
      # $options{sections} = string sections
      # $options{help_first} = put at the beginning
      # $options{once} = put help only one time for a package
      
      if (defined($options{once}) && defined($self->{pod_packages_once}->{$options{package}})) {
          return ;
      }
      
      if (defined($options{help_first})) {
          unshift @{$self->{pod_package}}, {package => $options{package}, sections => $options{sections}};
      } else {
          push @{$self->{pod_package}}, { package => $options{package}, sections => $options{sections} };
      }
      
      $self->{pod_packages_once}->{$options{package}} = 1;
  }
  
  sub add_options {
      my ($self, %options) = @_;
      # $options{arguments} = ref to hash table with string and name to store (example: { 'mode:s' => { name => 'mode', default => 'defaultvalue' )
      
      foreach (keys %{$options{arguments}}) {
          if (defined($options{arguments}->{$_}->{redirect})) {
              $self->{options}->{$_} = \$self->{options_stored}->{$options{arguments}->{$_}->{redirect}};
              next;
          }
          
          if (defined($options{arguments}->{$_}->{default})) {
              $self->{options_stored}->{$options{arguments}->{$_}->{name}} = $options{arguments}->{$_}->{default};
          } else {
              $self->{options_stored}->{$options{arguments}->{$_}->{name}} = undef;
          }
          
          $self->{options}->{$_} = \$self->{options_stored}->{$options{arguments}->{$_}->{name}};
      }
  }
  
  sub parse_options {
      my $self = shift;
      #%{$self->{options_stored}} = ();
  
      my $save_warn_handler;
      if ($self->{sanity} == 1) {
          $save_warn_handler = $SIG{__WARN__};
          $SIG{__WARN__} = sub {
              $self->{output}->add_option_msg(short_msg => $_[0]);
              $self->{output}->option_exit(nolabel => 1);
          };
      }
      
      GetOptions(
         %{$self->{options}}
      );
      %{$self->{options}} = ();
      
      $SIG{__WARN__} = $save_warn_handler if ($self->{sanity} == 1);
  }
  
  sub get_option {
      my ($self, %options) = @_;
  
      return $self->{options_stored}->{$options{argument}};
  }
  
  sub get_options {
      my $self = shift;
  
      return $self->{options_stored};
  }
  
  sub clean {
      my $self = shift;
      
      $self->{options_stored} = {};
  }
  
  1;
  
CENTREON_PLUGINS_OPTIONS

$fatpacked{"centreon/plugins/output.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_OUTPUT';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::output;
  
  use strict;
  use warnings;
  use centreon::plugins::misc;
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
      if (!defined($options{options})) {
          print "Class Output: Need to specify 'options' argument to load.\n";
          exit 3;
      }
  
      $options{options}->add_options(arguments => {
          'explode-perfdata-max:s@' => { name => 'explode_perfdata_max' },
          'range-perfdata:s'        => { name => 'range_perfdata' },
          'filter-perfdata:s'       => { name => 'filter_perfdata' },
          'change-perfdata:s@'      => { name => 'change_perfdata' },
          'extend-perfdata:s@'      => { name => 'extend_perfdata' },
          'extend-perfdata-group:s@'=> { name => 'extend_perfdata_group' },
          'change-short-output:s@'  => { name => 'change_short_output' },
          'use-new-perfdata'        => { name => 'use_new_perfdata' },
          'filter-uom:s'            => { name => 'filter_uom' },
          'verbose'                 => { name => 'verbose' },
          'debug'                   => { name => 'debug' },
          'opt-exit:s'              => { name => 'opt_exit', default => 'unknown' },
          'output-xml'              => { name => 'output_xml' },
          'output-json'             => { name => 'output_json' },
          'output-openmetrics'      => { name => 'output_openmetrics' },
          'output-file:s'           => { name => 'output_file' },
          'disco-format'            => { name => 'disco_format' },
          'disco-show'              => { name => 'disco_show' },
          'float-precision:s'       => { name => 'float_precision', default => 8 },
      });
      
      %{$self->{option_results}} = ();
  
      $self->{option_msg} = [];
      
      $self->{is_output_xml} = 0;
      $self->{is_output_json} = 0;
      $self->{errors} = {OK => 0, WARNING => 1, CRITICAL => 2, UNKNOWN => 3, PENDING => 4};
      $self->{errors_num} = {0 => 'OK', 1 => 'WARNING', 2 => 'CRITICAL', 3 => 'UNKNOWN', 4 => 'PENDING'};
      $self->{myerrors} = {0 => "OK", 1 => "WARNING", 3 => "UNKNOWN", 7 => "CRITICAL"};
      $self->{myerrors_mask} = {CRITICAL => 7, WARNING => 1, UNKNOWN => 3, OK => 0};
      $self->{global_short_concat_outputs} = {OK => undef, WARNING => undef, CRITICAL => undef, UNKNOWN => undef, UNQUALIFIED_YET => undef};
      $self->{global_short_outputs} = {OK => [], WARNING => [], CRITICAL => [], UNKNOWN => [], UNQUALIFIED_YET => []};
      $self->{global_long_output} = [];
      $self->{perfdatas} = [];
      $self->{explode_perfdatas} = {};
      $self->{change_perfdata} = {};
      $self->{explode_perfdata_total} = 0;
      $self->{range_perfdata} = 0;
      $self->{global_status} = 0;
      $self->{encode_utf8_import} = 0;
      $self->{perlqq} = 0;
  
      $self->{disco_elements} = [];
      $self->{disco_entries} = [];
  
      $self->{plugin} = '';
      $self->{mode} = '';
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      # $options{option_results} = ref to options result
  
      %{$self->{option_results}} = %{$options{option_results}};
      $self->{option_results}->{opt_exit} = lc($self->{option_results}->{opt_exit});
      if (!$self->is_litteral_status(status => $self->{option_results}->{opt_exit})) {
          $self->add_option_msg(short_msg => "Unknown value '" . $self->{option_results}->{opt_exit}  . "' for --opt-exit.");
          $self->option_exit(exit_litteral => 'unknown');
      }
      # Go in XML Mode
      if ($self->is_disco_show() || $self->is_disco_format()) {
          # By Default XML
          if (!defined($self->{option_results}->{output_json})) {
              $self->{option_results}->{output_xml} = 1;
          }
      }
      
      if (defined($self->{option_results}->{range_perfdata})) {
          $self->{range_perfdata} = $self->{option_results}->{range_perfdata};
          $self->{range_perfdata} = 1 if ($self->{range_perfdata} eq '');
          if ($self->{range_perfdata} !~ /^[012]$/) {
              $self->add_option_msg(short_msg => "Wrong range-perfdata option '" . $self->{range_perfdata} . "'");
              $self->option_exit();
          }
      }
      
      if (defined($self->{option_results}->{explode_perfdata_max})) {
          if (${$self->{option_results}->{explode_perfdata_max}}[0] eq '') {
              $self->{explode_perfdata_total} = 2;
          } else {
              $self->{explode_perfdata_total} = 1;
              foreach (@{$self->{option_results}->{explode_perfdata_max}}) {
                  my ($perf_match, $perf_result) = split /,/;
                  if (!defined($perf_result)) {
                      $self->add_option_msg(short_msg => "Wrong explode-perfdata-max option '" . $_ . "' (syntax: match,value)");
                      $self->option_exit();
                  }
                  $self->{explode_perfdatas}->{$perf_match} = $perf_result;
              }
          }
      }
      
      $self->load_perfdata_extend_args();
      $self->{option_results}->{use_new_perfdata} = 1 if (defined($self->{option_results}->{output_openmetrics}));
  }
  
  sub add_option_msg {
      my ($self, %options) = @_;
      # $options{short_msg} = string msg
      # $options{long_msg} = string msg
      $options{severity} = 'UNQUALIFIED_YET';
      
      $self->output_add(%options);
  }
  
  sub set_status {
      my ($self, %options) = @_;
      # $options{exit_litteral} = string litteral exit
  
      # Nothing to do for 'UNQUALIFIED_YET'
      if (!$self->{myerrors_mask}->{uc($options{exit_litteral})}) {
          return ;
      }
      $self->{global_status} |= $self->{myerrors_mask}->{uc($options{exit_litteral})};
  }
  
  sub output_add {
      my ($self, %params) = @_;
      my %args = (
          severity => 'OK',
          separator => ' - ',
          debug => 0,
          short_msg => undef,
          long_msg => undef,
      );
      my $options = {%args, %params};
      
      if (defined($options->{short_msg})) {
          chomp $options->{short_msg};
          if (defined($self->{global_short_concat_outputs}->{uc($options->{severity})})) {
              $self->{global_short_concat_outputs}->{uc($options->{severity})} .= $options->{separator} . $options->{short_msg};
          } else {
              $self->{global_short_concat_outputs}->{uc($options->{severity})} = $options->{short_msg};
          }
          
          push @{$self->{global_short_outputs}->{uc($options->{severity})}}, $options->{short_msg};
          $self->set_status(exit_litteral => $options->{severity});
      }
      if (defined($options->{long_msg}) && 
          ($options->{debug} == 0 || defined($self->{option_results}->{debug}))) {
          chomp $options->{long_msg};
          push @{$self->{global_long_output}}, $options->{long_msg};
      }
  }
  
  sub perfdata_add {
      my ($self, %options) = @_;
      my $perfdata = {
          label => '', value => '', unit => '', warning => '', critical => '', min => '', max => ''
      };
      foreach (keys %options) {
          next if (!defined($options{$_}));
          $perfdata->{$_} = $options{$_};
      }
      
      if (defined($self->{option_results}->{use_new_perfdata}) && defined($options{nlabel})) {
          $perfdata->{label} = $options{nlabel};
      }
      if (defined($options{instances})) {
          $options{instances} = [$options{instances}] if (!ref($options{instances}));
          my ($external_instance_separator, $internal_instance_separator) = ('#', '~');
          if (defined($self->{option_results}->{use_new_perfdata})) {
              $perfdata->{label} = join('~', @{$options{instances}}) . '#' . $perfdata->{label};
          } else {
              $perfdata->{label} .= '_' . join('_', @{$options{instances}});
          }
      }
      
      $perfdata->{label} =~ s/'/''/g;
      push @{$self->{perfdatas}}, $perfdata;
  }
  
  sub range_perfdata {
      my ($self, %options) = @_;
      
      return if ($self->{range_perfdata} == 0);
      if ($self->{range_perfdata} == 1) {
          for (my $i = 0; $i < scalar(@{$options{ranges}}); $i++) {
              ${${$options{ranges}}[$i]} =~ s/^(@?)-?[0\.]+:/$1/;
          }
      } else {
          for (my $i = 0; $i < scalar(@{$options{ranges}}); $i++) {
              ${${$options{ranges}}[$i]} = '';
          }
      }
  }
  
  sub output_json {
      my ($self, %options) = @_;
      my $force_ignore_perfdata = (defined($options{force_ignore_perfdata}) && $options{force_ignore_perfdata} == 1) ? 1 : 0;
      my $force_long_output = (defined($options{force_long_output}) && $options{force_long_output} == 1) ? 1 : 0;
      my $json_content = {
          plugin => {
              name => $self->{plugin},
              mode => $self->{mode},
              exit => $options{exit_litteral},
              outputs => [],
              perfdatas => []
          }
      };    
  
      foreach my $code_litteral (keys %{$self->{global_short_outputs}}) {
          foreach (@{$self->{global_short_outputs}->{$code_litteral}}) {
              my ($child_output, $child_type, $child_msg, $child_exit);
              my $lcode_litteral = ($code_litteral eq 'UNQUALIFIED_YET' ? uc($options{exit_litteral}) : $code_litteral);
  
              push @{$json_content->{plugin}->{outputs}}, {
                  type => 1,
                  msg => ($options{nolabel} == 0 ? ($lcode_litteral . ': ') : '') . $_,
                  exit => $lcode_litteral
              };
          }
      }
  
      if (defined($self->{option_results}->{verbose}) || $force_long_output == 1) {
          foreach (@{$self->{global_long_output}}) {
              push @{$json_content->{plugin}->{outputs}}, {
                  type => 2,
                  msg => $_,
              };
          }
      }
  
      if ($options{force_ignore_perfdata} == 0) {
          $self->change_perfdata();
          foreach my $perf (@{$self->{perfdatas}}) {
              next if (defined($self->{option_results}->{filter_perfdata}) &&
                       $perf->{label} !~ /$self->{option_results}->{filter_perfdata}/);
              $self->range_perfdata(ranges => [\$perf->{warning}, \$perf->{critical}]);
              
              my %values = ();
              foreach my $key (keys %$perf) {
                  $perf->{$key} = '' if (defined($self->{option_results}->{filter_uom}) && $key eq 'unit' &&
                      $perf->{$key} !~ /$self->{option_results}->{filter_uom}/);
                  $values{$key} = $perf->{$key};
              }
              
              push @{$json_content->{plugin}->{perfdatas}}, {
                  %values
              };
          }
      }
  
      print $self->{json_output}->encode($json_content);
  }
  
  sub output_xml {
      my ($self, %options) = @_;
      my $force_ignore_perfdata = (defined($options{force_ignore_perfdata}) && $options{force_ignore_perfdata} == 1) ? 1 : 0;
      my $force_long_output = (defined($options{force_long_output}) && $options{force_long_output} == 1) ? 1 : 0;
      my ($child_plugin_name, $child_plugin_mode, $child_plugin_exit, $child_plugin_output, $child_plugin_perfdata); 
  
      my $root = $self->{xml_output}->createElement('plugin');
      $self->{xml_output}->setDocumentElement($root);
  
      $child_plugin_name = $self->{xml_output}->createElement('name');
      $child_plugin_name->appendText($self->{plugin});
  
      $child_plugin_mode = $self->{xml_output}->createElement('mode');
      $child_plugin_mode->appendText($self->{mode});
  
      $child_plugin_exit = $self->{xml_output}->createElement('exit');
      $child_plugin_exit->appendText($options{exit_litteral});
  
      $child_plugin_output = $self->{xml_output}->createElement('outputs');
      $child_plugin_perfdata = $self->{xml_output}->createElement('perfdatas');
  
      $root->addChild($child_plugin_name);
      $root->addChild($child_plugin_mode);
      $root->addChild($child_plugin_exit);
      $root->addChild($child_plugin_output);
      $root->addChild($child_plugin_perfdata);
  
      foreach my $code_litteral (keys %{$self->{global_short_outputs}}) {
          foreach (@{$self->{global_short_outputs}->{$code_litteral}}) {
              my ($child_output, $child_type, $child_msg, $child_exit);
              my $lcode_litteral = ($code_litteral eq 'UNQUALIFIED_YET' ? uc($options{exit_litteral}) : $code_litteral);
  
              $child_output = $self->{xml_output}->createElement('output');
              $child_plugin_output->addChild($child_output);
  
              $child_type = $self->{xml_output}->createElement('type');
              $child_type->appendText(1); # short
  
              $child_msg = $self->{xml_output}->createElement('msg');
              $child_msg->appendText(($options{nolabel} == 0 ? ($lcode_litteral . ': ') : '') . $_);
              $child_exit = $self->{xml_output}->createElement('exit');
              $child_exit->appendText($lcode_litteral);
  
              $child_output->addChild($child_type);
              $child_output->addChild($child_exit);
              $child_output->addChild($child_msg);
          }
      }
  
      if (defined($self->{option_results}->{verbose}) || $force_long_output == 1) {
          foreach (@{$self->{global_long_output}}) {
              my ($child_output, $child_type, $child_msg);
          
              $child_output = $self->{xml_output}->createElement('output');
              $child_plugin_output->addChild($child_output);
  
              $child_type = $self->{xml_output}->createElement('type');
              $child_type->appendText(2); # long
  
              $child_msg = $self->{xml_output}->createElement('msg');
              $child_msg->appendText($_);
  
              $child_output->addChild($child_type);
              $child_output->addChild($child_msg);
          }
      }
  
      if ($options{force_ignore_perfdata} == 0) {
          $self->change_perfdata();
          foreach my $perf (@{$self->{perfdatas}}) {
              next if (defined($self->{option_results}->{filter_perfdata}) &&
                       $perf->{label} !~ /$self->{option_results}->{filter_perfdata}/);
              $self->range_perfdata(ranges => [\$perf->{warning}, \$perf->{critical}]);
          
              my ($child_perfdata);
              $child_perfdata = $self->{xml_output}->createElement('perfdata');
              $child_plugin_perfdata->addChild($child_perfdata);
              foreach my $key (keys %$perf) {
                  $perf->{$key} = '' if (defined($self->{option_results}->{filter_uom}) && $key eq 'unit' &&
                      $perf->{$key} !~ /$self->{option_results}->{filter_uom}/);
                  my $child = $self->{xml_output}->createElement($key);
                  $child->appendText($perf->{$key});
                  $child_perfdata->addChild($child);
              }
          }
      }
  
      print $self->{xml_output}->toString(1);
  }
  
  sub output_openmetrics {
      my ($self, %options) = @_;
  
      $self->change_perfdata();
      foreach my $perf (@{$self->{perfdatas}}) {
          next if (defined($self->{option_results}->{filter_perfdata}) &&
                   $perf->{label} !~ /$self->{option_results}->{filter_perfdata}/);
          $perf->{unit} = '' if (defined($self->{option_results}->{filter_uom}) &&
              $perf->{unit} !~ /$self->{option_results}->{filter_uom}/);
          $self->range_perfdata(ranges => [\$perf->{warning}, \$perf->{critical}]);
          my $label = $perf->{label};
          my $instance;
          if ($label =~ /^(.*?)#(.*)$/) {
              ($perf->{instance}, $label) = ($1, $2);
          }
          my ($bucket, $append) = ('{plugin="' . $self->{plugin} . '",mode="' . $self->{mode} . '"', '');
          foreach ('unit', 'warning', 'critical', 'min', 'max', 'instance') {
              if (defined($perf->{$_}) && $perf->{$_} ne '') {
                  $bucket .= ',' . $_ . '="' . $perf->{$_} . '"';
              }
          }
          $bucket .= '}';
          
          print $label . $bucket . ' ' . $perf->{value} . "\n";
      }
  }
  
  sub output_txt_short_display {
      my ($self, %options) = @_;
      
      if (defined($self->{global_short_concat_outputs}->{CRITICAL})) {
          print (($options{nolabel} == 0 ? 'CRITICAL: ' : '') . $self->{global_short_concat_outputs}->{CRITICAL} . " ");
      }
      if (defined($self->{global_short_concat_outputs}->{WARNING})) {
          print (($options{nolabel} == 0 ? 'WARNING: ' : '') . $self->{global_short_concat_outputs}->{WARNING} . " ");
      }
      if (defined($self->{global_short_concat_outputs}->{UNKNOWN})) {
          print (($options{nolabel} == 0 ? 'UNKNOWN: ' : '') . $self->{global_short_concat_outputs}->{UNKNOWN} . " ");
      }
      if (uc($options{exit_litteral}) eq 'OK') {
          print (($options{nolabel} == 0 ? 'OK: ' : '') . (defined($self->{global_short_concat_outputs}->{OK}) ? $self->{global_short_concat_outputs}->{OK} : '') . " ");
      }
  }
  
  sub output_txt_short {
      my ($self, %options) = @_;
      
      if (!defined($self->{option_results}->{change_short_output})) {
          $self->output_txt_short_display(%options);
          return ;
      }
      
      my $stdout = '';
      {
          local *STDOUT;
          open STDOUT, '>', \$stdout;
          $self->output_txt_short_display(%options);
      }
      
      foreach (@{$self->{option_results}->{change_short_output}}) {
           my ($pattern, $replace, $modifier) = split /~/;
           next if (!defined($pattern));
           $replace = '' if (!defined($replace));
           $modifier = '' if (!defined($modifier));
           eval "\$stdout =~ s{$pattern}{$replace}$modifier";
      }
      
      print $stdout;
  }
  
  sub output_txt {
      my ($self, %options) = @_;
      my $force_ignore_perfdata = (defined($options{force_ignore_perfdata}) && $options{force_ignore_perfdata} == 1) ? 1 : 0;
      my $force_long_output = (defined($options{force_long_output}) && $options{force_long_output} == 1) ? 1 : 0;
  
      if (defined($self->{global_short_concat_outputs}->{UNQUALIFIED_YET})) {
          $self->output_add(severity => uc($options{exit_litteral}), short_msg => $self->{global_short_concat_outputs}->{UNQUALIFIED_YET});
      }
  
      $self->output_txt_short(%options);
  
      if ($force_ignore_perfdata == 1) {
          print "\n";
      } else {
          print '|';
          $self->change_perfdata();
          foreach my $perf (@{$self->{perfdatas}}) {
              next if (defined($self->{option_results}->{filter_perfdata}) &&
                       $perf->{label} !~ /$self->{option_results}->{filter_perfdata}/);
              $perf->{unit} = '' if (defined($self->{option_results}->{filter_uom}) &&
                  $perf->{unit} !~ /$self->{option_results}->{filter_uom}/);
              $self->range_perfdata(ranges => [\$perf->{warning}, \$perf->{critical}]);
              print " '" . $perf->{label} . "'=" . $perf->{value} . $perf->{unit} . ';' . $perf->{warning} . ';' . $perf->{critical} . ';' . $perf->{min} . ';' . $perf->{max};
          }
          print "\n";
      }
      
      if (defined($self->{option_results}->{verbose}) || $force_long_output == 1) {
          if (scalar(@{$self->{global_long_output}})) {
              print join("\n", @{$self->{global_long_output}});
              print "\n";
          }
      }
  }
  
  sub display {
      my ($self, %options) = @_;
      my $nolabel = defined($options{nolabel}) ? 1 : 0;
      my $force_ignore_perfdata = (defined($options{force_ignore_perfdata}) && $options{force_ignore_perfdata} == 1) ? 1 : 0;
      my $force_long_output = (defined($options{force_long_output}) && $options{force_long_output} == 1) ? 1 : 0;
      $force_long_output = 1 if (defined($self->{option_results}->{debug}));
  
      if (defined($self->{option_results}->{output_file})) {
          if (!open (STDOUT, '>', $self->{option_results}->{output_file})) {
              $self->output_add(severity => 'UNKNOWN',
                                short_msg => "cannot open file  '" . $self->{option_results}->{output_file} . "': $!");
          }
      }
      if (defined($self->{option_results}->{output_xml})) {
          $self->create_xml_document();
          if ($self->{is_output_xml}) {
              $self->output_xml(exit_litteral => $self->get_litteral_status(), 
                                nolabel => $nolabel, 
                                force_ignore_perfdata => $force_ignore_perfdata, force_long_output => $force_long_output);
              return ;
          }
      } elsif (defined($self->{option_results}->{output_json})) {
          $self->create_json_document();
          if ($self->{is_output_json}) {
              $self->output_json(exit_litteral => $self->get_litteral_status(), 
                                 nolabel => $nolabel,
                                 force_ignore_perfdata => $force_ignore_perfdata, force_long_output => $force_long_output);
              return ;
          }
      } elsif (defined($self->{option_results}->{output_openmetrics})) {
          $self->output_openmetrics();
          return ;
      }
      
      $self->output_txt(
          exit_litteral => $self->get_litteral_status(), 
          nolabel => $nolabel,
          force_ignore_perfdata => $force_ignore_perfdata, force_long_output => $force_long_output
      );
  }
  
  sub die_exit {
      my ($self, %options) = @_;
      # $options{exit_litteral} = string litteral exit
      # $options{nolabel} = interger label display
      my $exit_litteral = defined($options{exit_litteral}) ? $options{exit_litteral} : $self->{option_results}->{opt_exit};
      my $nolabel = defined($options{nolabel}) ? 1 : 0;
      # ignore long output in the following case
      $self->{option_results}->{verbose} = undef;
  
      if (defined($self->{option_results}->{output_xml})) {
          $self->create_xml_document();
          if ($self->{is_output_xml}) {
              $self->output_xml(exit_litteral => $exit_litteral, nolabel => $nolabel, force_ignore_perfdata => 1);
              $self->exit(exit_litteral => $exit_litteral);
          }
      } elsif (defined($self->{option_results}->{output_json})) {
          $self->create_json_document();
          if ($self->{is_output_json}) {
              $self->output_json(exit_litteral => $exit_litteral, nolabel => $nolabel, force_ignore_perfdata => 1);
              $self->exit(exit_litteral => $exit_litteral);
          }
      } 
  
      $self->output_txt(exit_litteral => $exit_litteral, nolabel => $nolabel, force_ignore_perfdata => 1);
      $self->exit(exit_litteral => $exit_litteral);
  }
  
  sub option_exit {
      my ($self, %options) = @_;
      # $options{exit_litteral} = string litteral exit
      # $options{nolabel} = interger label display
      my $exit_litteral = defined($options{exit_litteral}) ? $options{exit_litteral} : $self->{option_results}->{opt_exit};
      my $nolabel = defined($options{nolabel}) ? 1 : 0;
  
      if (defined($self->{option_results}->{output_xml})) {
          $self->create_xml_document();
          if ($self->{is_output_xml}) {
              $self->output_xml(exit_litteral => $exit_litteral, nolabel => $nolabel, force_ignore_perfdata => 1, force_long_output => 1);
              $self->exit(exit_litteral => $exit_litteral);
          }
      } elsif (defined($self->{option_results}->{output_json})) {
          $self->create_json_document();
          if ($self->{is_output_json}) {
              $self->output_json(exit_litteral => $exit_litteral, nolabel => $nolabel, force_ignore_perfdata => 1, force_long_output => 1);
              $self->exit(exit_litteral => $exit_litteral);
          }
      }
  
      $self->output_txt(exit_litteral => $exit_litteral, nolabel => $nolabel, force_ignore_perfdata => 1, force_long_output => 1);
      $self->exit(exit_litteral => $exit_litteral);
  }
  
  sub exit {
      my ($self, %options) = @_;
      # $options{exit_litteral} = exit
      
      if (defined($options{exit_litteral})) {
          exit $self->{errors}->{uc($options{exit_litteral})};
      }
      exit $self->{errors}->{$self->{myerrors}->{$self->{global_status}}};
  }
  
  sub get_most_critical {
      my ($self, %options) = @_;
      my $current_status = 0; # For 'OK'
  
      foreach (@{$options{status}}) {
          if ($self->{myerrors_mask}->{uc($_)} > $current_status) {
              $current_status = $self->{myerrors_mask}->{uc($_)};
          }
      }
      return $self->{myerrors}->{$current_status};
  }
  
  sub get_litteral_status {
      my ($self, %options) = @_;
      
      if (defined($options{status})) {
          if (defined($self->{errors_num}->{$options{status}})) {
              return $self->{errors_num}->{$options{status}};
          }
          return $options{status};
      } else {
          return $self->{myerrors}->{$self->{global_status}};
      }
  }
  
  sub is_status {
      my ($self, %options) = @_;
      # $options{value} = string status 
      # $options{litteral} = value is litteral
      # $options{compare} = string status 
  
      if (defined($options{litteral})) {
          my $value = defined($options{value}) ? $options{value} : $self->get_litteral_status();
      
          if (uc($value) eq uc($options{compare})) {
              return 1;
          }
          return 0;
      }
  
      my $value = defined($options{value}) ? $options{value} : $self->{global_status};
      my $dec_val = $self->{myerrors_mask}->{$value};
      my $lresult = $value & $dec_val;
      # Need to manage 0
      if ($lresult > 0 || ($dec_val == 0 && $value == 0)) {
          return 1;
      }
      return 0;
  }
  
  sub is_litteral_status {
      my ($self, %options) = @_;
      # $options{status} = string status
  
      if (defined($self->{errors}->{uc($options{status})})) {
          return 1;
      }
  
      return 0;
  }
  
  sub create_json_document {
      my ($self) = @_;
  
      if (centreon::plugins::misc::mymodule_load(no_quit => 1, module => 'JSON',
                                             error_msg => "Cannot load module 'JSON'.")) {
          print "Cannot load module 'JSON'\n";
          $self->exit(exit_litteral => 'unknown');
      }
      $self->{is_output_json} = 1;
      $self->{json_output} = JSON->new->utf8();
  }
  
  sub create_xml_document {
      my ($self) = @_;
  
      if (centreon::plugins::misc::mymodule_load(no_quit => 1, module => 'XML::LibXML',
                                             error_msg => "Cannot load module 'XML::LibXML'.")) {
          print "Cannot load module 'XML::LibXML'\n";
          $self->exit(exit_litteral => 'unknown');
      }
      $self->{is_output_xml} = 1;
      $self->{xml_output} = XML::LibXML::Document->new('1.0', 'utf-8');
  }
  
  sub plugin {
      my ($self, %options) = @_;
      # $options{name} = string name
      
      if (defined($options{name})) {
          $self->{plugin} = $options{name};
      }
      return $self->{plugin};
  }
  
  sub mode {
      my ($self, %options) = @_;
      # $options{name} = string name
  
      if (defined($options{name})) {
          $self->{mode} = $options{name};
      }
      return $self->{mode};
  }
  
  sub add_disco_format {
      my ($self, %options) = @_;
  
      push @{$self->{disco_elements}}, @{$options{elements}};
  }
  
  sub display_disco_format {
      my ($self, %options) = @_;
      
      if (defined($self->{option_results}->{output_xml})) {
          $self->create_xml_document();
      
          my $root = $self->{xml_output}->createElement('data');
          $self->{xml_output}->setDocumentElement($root);
  
          foreach (@{$self->{disco_elements}}) {
              my $child = $self->{xml_output}->createElement("element");
              $child->appendText($_);
              $root->addChild($child);
          }
  
          print $self->{xml_output}->toString(1);
      } elsif (defined($self->{option_results}->{output_json})) {
          $self->create_json_document();
          my $json_content = {data => [] };
          foreach (@{$self->{disco_elements}}) {
              push @{$json_content->{data}}, $_;
          }
          
          print $self->{json_output}->encode($json_content);
      }
  }
  
  sub display_disco_show {
      my ($self, %options) = @_;
      
       if (defined($self->{option_results}->{output_xml})) {
          $self->create_xml_document();
          
          my $root = $self->{xml_output}->createElement('data');
          $self->{xml_output}->setDocumentElement($root);
  
          foreach (@{$self->{disco_entries}}) {
              my $child = $self->{xml_output}->createElement('label');
              foreach my $key (keys %$_) {
                  $child->setAttribute($key, $_->{$key});
              }
              $root->addChild($child);
          }
  
          print $self->{xml_output}->toString(1);
      } elsif (defined($self->{option_results}->{output_json})) {
          $self->create_json_document();
          my $json_content = {data => [] };
          foreach (@{$self->{disco_entries}}) {
              my %values = ();
              foreach my $key (keys %$_) {
                  $values{$key} = $_->{$key};
              }
              push @{$json_content->{data}}, {%values};
          }
          
          print $self->{json_output}->encode($json_content);
      }
  }
  
  sub to_utf8 {
      my ($self, $value) = @_;
      
      if ($self->{encode_utf8_import} == 0) {
          # Some Perl version dont have the following module (like Perl 5.6.x)
          if (centreon::plugins::misc::mymodule_load(no_quit => 1, module => 'Encode',
                                                     error_msg => "Cannot load module 'Encode'.")) {
              print "Cannot load module 'Encode'\n";
              $self->exit(exit_litteral => 'unknown');
          }
          
          $self->{encode_utf8_import} = 1;
          eval '$self->{perlqq} = Encode::PERLQQ';
      }
      
      return centreon::plugins::misc::trim(Encode::decode('UTF-8', $value, $self->{perlqq}));
  }
  
  sub add_disco_entry {
      my ($self, %options) = @_;
      
      push @{$self->{disco_entries}}, {%options};
  }
  
  sub is_disco_format {
      my ($self) = @_;
  
      if (defined($self->{option_results}->{disco_format})) {
          return 1;
      }
      return 0;
  }
  
  sub is_disco_show {
      my ($self) = @_;
  
      if (defined($self->{option_results}->{disco_show})) {
          return 1;
      }
      return 0;
  }
  
  sub is_verbose {
      my ($self) = @_;
  
      if (defined($self->{option_results}->{verbose})) {
          return 1;
      }
      return 0;
  }
  
  sub is_debug {
      my ($self) = @_;
  
      if (defined($self->{option_results}->{debug})) {
          return 1;
      }
      return 0;
  }
  
  sub use_new_perfdata {
      my ($self, %options) = @_;
  
      $self->{option_results}->{use_new_perfdata} = $options{value}
          if (defined($options{value}));
      if (defined($self->{option_results}->{use_new_perfdata})) {
          return 1;
      }
      return 0;
  }
  
  sub get_instance_perfdata_separator {
      my ($self) = @_;
  
      if (defined($self->{option_results}->{use_new_perfdata})) {
          return '~';
      }
      return '_';
  }
  
  sub parse_pfdata_scale {
      my ($self, %options) = @_;
      
      # --extend-perfdata=traffic_in,,scale(Mbps),mbps
      my $args = { unit => 'auto' };
      if ($options{args} =~ /^([KMGTPEkmgtpe])?(B|b|bps|Bps|b\/s|auto)$/) {
          $args->{quantity} = defined($1) ? $1 : '';
          $args->{unit} = $2;
      } elsif ($options{args} ne '') {
          return 1;
      }
      
      return (0, $args);
  }
  
  sub parse_pfdata_math {
      my ($self, %options) = @_;
  
      # --extend-perfdata=perfx,,math(current + 10 - 100, 1)
      my $args = { math => undef, apply_threshold => 0 };
      my ($math, $apply_threshold) = split /\|/, $options{args};
      if ($math =~ /^((?:[\s\.\-\+\*\/0-9\(\)]|current)+)$/) {
          $args->{math} = $1;
      } elsif ($options{args} ne '') {
          return 1;
      }
      
      if (defined($apply_threshold) && $apply_threshold =~ /^\s*(0|1)\s*$/ ) {
          $args->{apply_threshold} = $1;
      }
      
      return (0, $args);
  }
  
  sub parse_group_pfdata {
      my ($self, %options) = @_;
      
      $options{args} =~ s/^\s+//;
      $options{args} =~ s/\s+$//;
      my $args = { pattern_pf => $options{args} };
      return $args;
  }
  
  sub parse_pfdata_min {
      my ($self, %options) = @_;
      
      my $args = $self->parse_group_pfdata(%options);
      return (0, $args);
  }
  
  sub parse_pfdata_max {
      my ($self, %options) = @_;
      
      my $args = $self->parse_group_pfdata(%options);
      return (0, $args);
  }
  
  sub parse_pfdata_average {
      my ($self, %options) = @_;
      
      my $args = $self->parse_group_pfdata(%options);
      return (0, $args);
  }
  
  sub parse_pfdata_sum {
      my ($self, %options) = @_;
      
      my $args = $self->parse_group_pfdata(%options);
      return (0, $args);
  }
  
  sub apply_pfdata_scale {
      my ($self, %options) = @_;
      
      return if (${$options{perf}}->{unit} !~ /^([KMGTPEkmgtpe])?(B|b|bps|Bps|b\/s)$/);
      
      my ($src_quantity, $src_unit) = ($1, $2);
      my ($value, $dst_quantity, $dst_unit) = centreon::plugins::misc::scale_bytesbit(value => ${$options{perf}}->{value},
          src_quantity => $src_quantity, src_unit => $src_unit, dst_quantity => $options{args}->{quantity}, dst_unit => $options{args}->{unit});
      ${$options{perf}}->{value} = sprintf("%.2f", $value);
      if (defined($dst_unit)) {
         ${$options{perf}}->{unit} = $dst_quantity . $dst_unit;
      } else {
          ${$options{perf}}->{unit} = $options{args}->{quantity} . $options{args}->{unit};
      }
      
      if (defined(${$options{perf}}->{max}) && ${$options{perf}}->{max} ne '') {
          ($value) = centreon::plugins::misc::scale_bytesbit(value => ${$options{perf}}->{max},
              src_quantity => $src_quantity, src_unit => $src_unit, 
              dst_quantity => defined($dst_unit) ? $dst_quantity : $options{args}->{quantity}, 
              dst_unit => defined($dst_unit) ? $dst_unit : $options{args}->{unit});
          ${$options{perf}}->{max} = sprintf('%.2f', $value);
      }
      
      foreach my $threshold ('warning', 'critical') {
          next if (${$options{perf}}->{$threshold} eq '');
          my ($status, $result) = centreon::plugins::misc::parse_threshold(threshold => ${$options{perf}}->{$threshold});
          next if ($status == 0);
  
          if ($result->{start} ne '' && $result->{infinite_neg} == 0) {
              ($result->{start}) = centreon::plugins::misc::scale_bytesbit(value => $result->{start},
                  src_quantity => $src_quantity, src_unit => $src_unit, 
                  dst_quantity => defined($dst_unit) ? $dst_quantity : $options{args}->{quantity}, 
                  dst_unit => defined($dst_unit) ? $dst_unit : $options{args}->{unit});
          }
          if ($result->{end} ne '' && $result->{infinite_pos} == 0) {
              ($result->{end}) = centreon::plugins::misc::scale_bytesbit(value => $result->{end},
                  src_quantity => $src_quantity, src_unit => $src_unit, 
                  dst_quantity => defined($dst_unit) ? $dst_quantity : $options{args}->{quantity}, 
                  dst_unit => defined($dst_unit) ? $dst_unit : $options{args}->{unit});
          }
          
          ${$options{perf}}->{$threshold} = centreon::plugins::misc::get_threshold_litteral(%$result);
      }
  }
  
  sub apply_pfdata_invert {
      my ($self, %options) = @_;
      
      return if (!defined(${$options{perf}}->{max}) || ${$options{perf}}->{max} eq '');
      
      ${$options{perf}}->{value} = ${$options{perf}}->{max} - ${$options{perf}}->{value};
      foreach my $threshold ('warning', 'critical') {
          next if (${$options{perf}}->{$threshold} eq '');
          my ($status, $result) = centreon::plugins::misc::parse_threshold(threshold => ${$options{perf}}->{$threshold});
          next if ($status == 0);
          
          my $tmp = { arobase => $result->{arobase}, infinite_pos => 0, infinite_neg => 0, start => $result->{start}, end => $result->{end} };
          $tmp->{infinite_neg} = 1 if ($result->{infinite_pos} == 1);
          $tmp->{infinite_pos} = 1 if ($result->{infinite_neg} == 1);
  
          if ($result->{start} ne '' && $result->{infinite_neg} == 0) {
              $tmp->{end} = ${$options{perf}}->{max} - $result->{start};
          }
          if ($result->{end} ne '' && $result->{infinite_pos} == 0) {
              $tmp->{start} = ${$options{perf}}->{max} - $result->{end};
          }
          
          ${$options{perf}}->{$threshold} = centreon::plugins::misc::get_threshold_litteral(%$tmp);
      }
  }
  
  sub apply_pfdata_percent {
      my ($self, %options) = @_;
  
      return if (!defined(${$options{perf}}->{max}) || ${$options{perf}}->{max} eq '');
      
      ${$options{perf}}->{value} = sprintf('%.2f', ${$options{perf}}->{value} * 100 / ${$options{perf}}->{max});
      ${$options{perf}}->{unit} = '%';
      foreach my $threshold ('warning', 'critical') {
          next if (${$options{perf}}->{$threshold} eq '');
          my ($status, $result) = centreon::plugins::misc::parse_threshold(threshold => ${$options{perf}}->{$threshold});
          next if ($status == 0);
  
          if ($result->{start} ne '' && $result->{infinite_neg} == 0) {
              $result->{start} = sprintf('%.2f', $result->{start} * 100 / ${$options{perf}}->{max});
          }
          if ($result->{end} ne '' && $result->{infinite_pos} == 0) {
              $result->{end} = sprintf('%.2f', $result->{end} * 100 / ${$options{perf}}->{max});
          }
          
          ${$options{perf}}->{$threshold} = centreon::plugins::misc::get_threshold_litteral(%$result);
      }
      
      ${$options{perf}}->{max} = 100; 
  }
  
  sub apply_pfdata_math {
      my ($self, %options) = @_;
      
      my $math = $options{args}->{math};
      $math =~ s/current/\$value/g;
      
      my $value = ${$options{perf}}->{value};
      eval "\${\$options{perf}}->{value} = $math";
      
      return if ($options{args}->{apply_threshold} == 0);
      
      foreach my $threshold ('warning', 'critical') {
          next if (${$options{perf}}->{$threshold} eq '');
          my ($status, $result) = centreon::plugins::misc::parse_threshold(threshold => ${$options{perf}}->{$threshold});
          next if ($status == 0);
  
          if ($result->{start} ne '' && $result->{infinite_neg} == 0) {
              $value = $result->{start};
              eval "\$result->{start} = $math";
          }
          if ($result->{end} ne '' && $result->{infinite_pos} == 0) {
              $value = $result->{end};
              eval "\$result->{end} = $math";
          }
          
          ${$options{perf}}->{$threshold} = centreon::plugins::misc::get_threshold_litteral(%$result);
      }
      
      ${$options{perf}}->{max} = 100;
  }
  
  sub apply_pfdata_min {
      my ($self, %options) = @_;
  
      my $pattern_pf;
      eval "\$pattern_pf = \"$options{args}->{pattern_pf}\"";
      my $min;
      for (my $i = 0; $i < scalar(@{$self->{perfdatas}}); $i++) {
          next if ($self->{perfdatas}->[$i]->{label} !~ /$pattern_pf/);
          next if ($self->{perfdatas}->[$i]->{value} !~ /\d+/);
          $min = $self->{perfdatas}->[$i]->{value}
              if (!defined($min) || $min > $self->{perfdatas}->[$i]->{value});
      }
  
      ${$options{perf}}->{value} = $min
          if (defined($min));
  }
  
  sub apply_pfdata_max {
      my ($self, %options) = @_;
  
      my $pattern_pf;
      eval "\$pattern_pf = \"$options{args}->{pattern_pf}\"";
      my $max;
      for (my $i = 0; $i < scalar(@{$self->{perfdatas}}); $i++) {
          next if ($self->{perfdatas}->[$i]->{label} !~ /$pattern_pf/);
          next if ($self->{perfdatas}->[$i]->{value} !~ /\d+/);
          $max = $self->{perfdatas}->[$i]->{value}
              if (!defined($max) || $max < $self->{perfdatas}->[$i]->{value});
      }
  
      ${$options{perf}}->{value} = $max
          if (defined($max));
  }
  
  sub apply_pfdata_sum {
      my ($self, %options) = @_;
  
      my $pattern_pf;
      eval "\$pattern_pf = \"$options{args}->{pattern_pf}\"";
      my ($sum, $num) = (0, 0);
      for (my $i = 0; $i < scalar(@{$self->{perfdatas}}); $i++) {
          next if ($self->{perfdatas}->[$i]->{label} !~ /$pattern_pf/);
          next if ($self->{perfdatas}->[$i]->{value} !~ /\d+/);
          $sum += $self->{perfdatas}->[$i]->{value};
          $num++;
      }
  
      ${$options{perf}}->{value} = $sum
          if ($num > 0);
  }
  
  sub apply_pfdata_average {
      my ($self, %options) = @_;
  
      my $pattern_pf;
      eval "\$pattern_pf = \"$options{args}->{pattern_pf}\"";
      my ($sum, $num) = (0, 0);
      for (my $i = 0; $i < scalar(@{$self->{perfdatas}}); $i++) {
          next if ($self->{perfdatas}->[$i]->{label} !~ /$pattern_pf/);
          next if ($self->{perfdatas}->[$i]->{value} !~ /\d+/);
          $sum += $self->{perfdatas}->[$i]->{value};
          $num++;
      }
  
      ${$options{perf}}->{value} = sprintf("%.2f", ($sum / $num))
          if ($num > 0);
  }
  
  sub load_perfdata_extend_args {
      my ($self, %options) = @_;
  
      foreach (
          [$self->{option_results}->{change_perfdata}, 1],
          [$self->{option_results}->{extend_perfdata}, 2],
          [$self->{option_results}->{extend_perfdata_group}, 3],
      ) {
          next if (!defined($_->[0]));
          foreach my $arg (@{$_->[0]}) {
              $self->parse_perfdata_extend_args(arg => $arg, type => $_->[1]);
          }
      }
  }
  
  sub parse_perfdata_extend_args {
      my ($self, %options) = @_;
      
      # --extend-perfdata=searchlabel,newlabel,method[,[newuom],[min],[max]]
      my ($pfdata_match, $pfdata_substitute, $method, $uom_sub, $min_sub, $max_sub) = 
          split /,/, $options{arg};
      return if ((!defined($pfdata_match) || $pfdata_match eq '') && $options{type} != 3);
      
      $self->{pfdata_extends} = [] if (!defined($self->{pfdata_extends}));
      my $pfdata_extends = {
          pfdata_match => defined($pfdata_match) && $pfdata_match ne '' ? $pfdata_match : undef,
          pfdata_substitute => defined($pfdata_substitute) && $pfdata_substitute ne '' ? $pfdata_substitute : undef,
          uom_sub => defined($uom_sub) && $uom_sub ne '' ? $uom_sub : undef,
          min_sub => defined($min_sub) && $min_sub ne '' ? $min_sub : undef,
          max_sub => defined($max_sub) && $max_sub ne '' ? $max_sub : undef,
          type => $options{type}
      };
  
      if (defined($method) && $method ne '') {
          if ($method !~ /^\s*(invert|percent|scale|math|min|max|average|sum)\s*\(\s*(.*?)\s*\)\s*$/) {
              $self->output_add(long_msg => "method in argument '$options{arg}' is unknown", debug => 1);
              return ;
          }
          
          $pfdata_extends->{method_name} = $1;
          my $args = $2;
          if (my $func = $self->can('parse_pfdata_' . $pfdata_extends->{method_name})) {
              (my $status, $pfdata_extends->{method_args}) = $func->($self, args => $args);
              if ($status == 1) {
                  $self->output_add(long_msg => "argument in method '$options{arg}' is unknown", debug => 1);
                  return ;
              }
          }
      }
  
      push  @{$self->{pfdata_extends}}, $pfdata_extends;
  }
  
  sub apply_perfdata_explode {
      my ($self, %options) = @_;
      
      return if ($self->{explode_perfdata_total} == 0);
      foreach (@{$self->{perfdatas}}) {
          next if ($_->{max} eq '');
          if ($self->{explode_perfdata_total} == 2) {
              $self->perfdata_add(label => $_->{label} . '_max', value => $_->{max});
              next;
          }
          foreach my $regexp (keys %{$self->{explode_perfdatas}}) {
              if ($_->{label} =~ /$regexp/) {
                  $self->perfdata_add(label => $self->{explode_perfdatas}->{$regexp}, value => $_->{max});
                  last;
              }
          }
      }
  }
  
  sub apply_perfdata_extend {
      my ($self, %options) = @_;
  
      foreach my $extend (@{$self->{pfdata_extends}}) {
          my $new_pfdata = [];
          
          # Manage special case when type group and pfdata_match empty
          if ($extend->{type} == 3 && (!defined($extend->{pfdata_match}) || $extend->{pfdata_match} eq '')) {
              next if (!defined($extend->{pfdata_substitute}) || $extend->{pfdata_substitute} eq '');
              my $new_perf = {
                  label => $extend->{pfdata_substitute}, value => '',
                  unit => defined($extend->{uom_sub}) ? $extend->{uom_sub} : '',
                  warning => '', critical => '',
                  min => defined($extend->{min_sub}) ? $extend->{min_sub} : '',
                  max => defined($extend->{max_sub}) ? $extend->{max_sub} : ''
              };
  
              if (defined($extend->{method_name})) {
                  my $func = $self->can('apply_pfdata_' . $extend->{method_name});
                  $func->($self, perf => \$new_perf, args => $extend->{method_args});
              }
  
              if (length($new_perf->{value})) {
                  push @{$self->{perfdatas}}, $new_perf;
              }
              next;
          }
          
          for (my $i = 0; $i < scalar(@{$self->{perfdatas}}); $i++) {
              next if ($self->{perfdatas}->[$i]->{label} !~ /$extend->{pfdata_match}/);
              
              my $new_perf = { %{$self->{perfdatas}->[$i]} };
              if ($extend->{type} == 3) {
                  $new_perf = { label => $self->{perfdatas}->[$i]->{label}, value => '', unit => '', warning => '', critical => '', min => '', max => '' };
              }
              
              if (defined($extend->{pfdata_substitute})) {
                  eval "\$new_perf->{label} =~ s{$extend->{pfdata_match}}{$extend->{pfdata_substitute}}";
              }
  
              if (defined($extend->{method_name})) {
                  my $func = $self->can('apply_pfdata_' . $extend->{method_name});
                  $func->($self, perf => \$new_perf, args => $extend->{method_args});
              }
              
              $new_perf->{unit} = $extend->{uom_sub} if (defined($extend->{uom_sub}));
              $new_perf->{min} = $extend->{min_sub} if (defined($extend->{min_sub}));
              $new_perf->{max} = $extend->{max_sub} if (defined($extend->{max_sub}));
  
              if ($extend->{type} == 1) {
                  $self->{perfdatas}->[$i] = $new_perf;
              } else {
                  push @$new_pfdata, $new_perf if (length($new_perf->{value}));
              }
          }
  
          push @{$self->{perfdatas}}, @$new_pfdata;
      }
  }
  
  sub change_perfdata {
      my ($self, %options) = @_;
      
      $self->apply_perfdata_extend();
      $self->apply_perfdata_explode();
  }
  
  1;
  
  
  =head1 NAME
  
  Output class
  
  =head1 SYNOPSIS
  
  -
  
  =head1 OUTPUT OPTIONS
  
  =over 8
  
  =item B<--verbose>
  
  Display long output.
  
  =item B<--debug>
  
  Display also debug messages.
  
  =item B<--filter-perfdata>
  
  Filter perfdata that match the regexp.
  
  =item B<--explode-perfdata-max>
  
  Put max perfdata (if it exist) in a specific perfdata 
  (without values: same with '_max' suffix) (Multiple options)
  
  =item B<--change-perfdata> B<--extend-perfdata> 
  
  Change or extend perfdata. 
  Syntax: --extend-perfdata=searchlabel,newlabel,target[,[newuom],[min],[max]]
  
  Common examples:
  
  =over 4
  
  Change storage free perfdata in used: --change-perfdata=free,used,invert()
  
  Change storage free perfdata in used: --change-perfdata=used,free,invert()
  
  Scale traffic values automaticaly: --change-perfdata=traffic,,scale(auto)
  
  Scale traffic values in Mbps: --change-perfdata=traffic_in,,scale(Mbps),mbps
  
  Change traffic values in percent: --change-perfdata=traffic_in,,percent()
  
  =back
  
  =item B<--extend-perfdata-group> 
  
  Extend perfdata from multiple perfdatas (methods in target are: min, max, average, sum)
  Syntax: --extend-perfdata-group=searchlabel,newlabel,target[,newuom]
  
  Common examples:
  
  =over 4
  
  Sum wrong packets from all interfaces (with interface need  --units-errors=absolute): --extend-perfdata-group=',packets_wrong,sum(packets_(discard|error)_(in|out))'
  
  Sum traffic by interface: --extend-perfdata-group='traffic_in_(.*),traffic_$1,sum(traffic_(in|out)_$1)'
  
  =back
  
  =item B<--change-short-output>
  
  Change short output display. --change-short-output=pattern~replace~modifier
  
  =item B<--range-perfdata>
  
  Change perfdata range thresholds display: 
  1 = start value equals to '0' is removed, 2 = threshold range is not display.
  
  =item B<--filter-uom>
  
  Filter UOM that match the regexp.
  
  =item B<--opt-exit>
  
  Optional exit code for an execution error (i.e. wrong option provided,
  SSH connection refused, timeout, etc)
  (Default: unknown).
  
  =item B<--output-xml>
  
  Display output in XML format.
  
  =item B<--output-json>
  
  Display output in JSON format.
  
  =item B<--output-openmetrics>
  
  Display metrics in OpenMetrics format.
  
  =item B<--output-file>
  
  Write output in file (can be used with json and xml options)
  
  =item B<--disco-format>
  
  Display discovery arguments (if the mode manages it).
  
  =item B<--disco-show>
  
  Display discovery values (if the mode manages it).
  
  =item B<--float-precision>
  
  Set the float precision for thresholds (Default: 8).
  
  =head1 DESCRIPTION
  
  B<output>.
  
  =cut
CENTREON_PLUGINS_OUTPUT

$fatpacked{"centreon/plugins/perfdata.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_PERFDATA';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::perfdata;
  
  use strict;
  use warnings;
  use centreon::plugins::misc;
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
  
      $self->{output} = $options{output};
      # Typical Nagios Perfdata 'with ~ @ ..'
      $self->{threshold_label} = {};
      $self->{float_precision} = defined($self->{output}->{option_results}->{float_precision}) && $self->{output}->{option_results}->{float_precision} =~ /\d+/ ?  
          int($self->{output}->{option_results}->{float_precision}) : 8;
  
      return $self;
  }
  
  sub get_perfdata_for_output {
      my ($self, %options) = @_;
      # $options{label} : threshold label
      # $options{total} : percent threshold to transform in global
      # $options{cast_int} : cast absolute to int
      # $options{op} : operator to apply to start/end value (uses with 'value'})
      # $options{value} : value to apply with 'op' option
      
      if (!defined($self->{threshold_label}->{$options{label}}->{value}) || $self->{threshold_label}->{$options{label}}->{value} eq '') {
          return '';
      }
      
      my %perf_value = %{$self->{threshold_label}->{$options{label}}};
      
      if (defined($options{op}) && defined($options{value})) {
          eval "\$perf_value{start} = \$perf_value{start} $options{op} \$options{value}" if ($perf_value{infinite_neg} == 0);
          eval "\$perf_value{end} = \$perf_value{end} $options{op} \$options{value}" if ($perf_value{infinite_pos} == 0);
      }
      if (defined($options{total})) {
          $perf_value{start} = $perf_value{start} * $options{total} / 100 if ($perf_value{infinite_neg} == 0);
          $perf_value{end} = $perf_value{end} * $options{total} / 100 if ($perf_value{infinite_pos} == 0);
          $perf_value{start} = sprintf("%.2f", $perf_value{start}) if ($perf_value{infinite_neg} == 0 && (!defined($options{cast_int}) || $options{cast_int} != 1));
          $perf_value{end} = sprintf("%.2f", $perf_value{end}) if ($perf_value{infinite_pos} == 0 && (!defined($options{cast_int}) || $options{cast_int} != 1));
      }
      
      $perf_value{start} = int($perf_value{start}) if ($perf_value{infinite_neg} == 0 && defined($options{cast_int}) && $options{cast_int} == 1);
      $perf_value{end} = int($perf_value{end}) if ($perf_value{infinite_pos} == 0 && defined($options{cast_int}) && $options{cast_int} == 1);
      
      my $perf_output = ($perf_value{arobase} == 1 ? '@' : '') . 
                        (($perf_value{infinite_neg} == 0) ? $perf_value{start} : '~') . 
                        ':' . 
                        (($perf_value{infinite_pos} == 0) ? $perf_value{end} : '');
  
      return $perf_output;
  }
  
  sub threshold_validate {
      my ($self, %options) = @_;
      # $options{label} : threshold label
      # $options{value} : threshold value
  
      my $status = 1;
      $self->{threshold_label}->{$options{label}} = { value => $options{value}, start => undef, end => undef, arobase => undef, infinite_neg => undef, infinite_pos => undef };
      if (!defined($options{value}) || $options{value} eq '') {
          return $status;
      }
  
      ($status, my $result_perf) = 
          centreon::plugins::misc::parse_threshold(threshold => $options{value});
      $self->{threshold_label}->{$options{label}} = { %{$self->{threshold_label}->{$options{label}}}, %$result_perf };
      
      $self->{threshold_label}->{$options{label}}->{start_precision} = $self->{threshold_label}->{$options{label}}->{start};
      if ($self->{threshold_label}->{$options{label}}->{start} =~ /[.,]/) {
          $self->{threshold_label}->{$options{label}}->{start_precision} = sprintf("%.$self->{output}->{option_results}->{float_precision}f", $self->{threshold_label}->{$options{label}}->{start});
      }
      
      $self->{threshold_label}->{$options{label}}->{end_precision} = $self->{threshold_label}->{$options{label}}->{end};
      if ($self->{threshold_label}->{$options{label}}->{end} =~ /[.,]/) {
          $self->{threshold_label}->{$options{label}}->{end_precision} = sprintf("%.$self->{output}->{option_results}->{float_precision}f", $self->{threshold_label}->{$options{label}}->{end});
      }
      
      return $status;
  }
  
  sub threshold_check {
      my ($self, %options) = @_;
      # Can check multiple threshold. First match: out. Order is important
      # options{value}: value to compare
      # options{threshold}: ref to an array (example: [ {label => 'warning', exit_litteral => 'warning' }, {label => 'critical', exit_litteral => 'critical'} ]
      if ($options{value} =~ /[.,]/) {
          $options{value} = sprintf("%.$self->{output}->{option_results}->{float_precision}f", $options{value});
      }
      
      foreach (@{$options{threshold}}) {
          next if (!defined($self->{threshold_label}->{$_->{label}}));
          next if (!defined($self->{threshold_label}->{$_->{label}}->{value}) || $self->{threshold_label}->{$_->{label}}->{value} eq '');
          if ($self->{threshold_label}->{$_->{label}}->{arobase} == 0 && ($options{value} < $self->{threshold_label}->{$_->{label}}->{start_precision} || $options{value} > $self->{threshold_label}->{$_->{label}}->{end_precision})) {
              return $_->{exit_litteral};
          } elsif ($self->{threshold_label}->{$_->{label}}->{arobase}  == 1 && ($options{value} >= $self->{threshold_label}->{$_->{label}}->{start_precision} && $options{value} <= $self->{threshold_label}->{$_->{label}}->{end_precision})) {
              return $_->{exit_litteral};
          }
      }
  
      return 'ok';
  }
  
  sub trim {
      my ($self, $value) = @_;
      
      $value =~ s/^[ \t]+//;
      $value =~ s/[ \t]+$//;
      return $value;
  }
  
  sub change_bytes {
      my ($self, %options) = @_;
  
      my $value = $options{value};
      my $divide = defined($options{network}) ? 1000 : 1024;
      my @units = ('K', 'M', 'G', 'T');
      my $unit = '';
      my $sign = '';
  
      $sign = '-' if ($value != abs($value));
      $value = abs($value);
      
      for (my $i = 0; $i < scalar(@units); $i++) {
          last if (($value / $divide) < 1);
          $unit = $units[$i];
          $value = $value / $divide;
      }
  
      return (sprintf('%.2f', $sign . $value), $unit . (defined($options{network}) ? 'b' : 'B'));
  }
  
  1;
  
  
  =head1 NAME
  
  Perfdata class
  
  =head1 SYNOPSIS
  
  -
  
  =head1 DESCRIPTION
  
  B<perfdata>.
  
  =cut
CENTREON_PLUGINS_PERFDATA

$fatpacked{"centreon/plugins/script.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_SCRIPT';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::script;
  
  use strict;
  use warnings;
  use centreon::plugins::output;
  use centreon::plugins::misc;
  use FindBin;
  use Pod::Usage;
  use Pod::Find qw(pod_where);
  
  my %handlers = (DIE => {});
  
  my $global_version = '20190704 (727d0077)';
  my $alternative_fatpacker = 1;
  
  sub new {
      my ($class) = @_;
      my $self  = {};
      bless $self, $class;
  
      $self->{options} = undef;
      $self->{plugin} = undef;
      $self->{help} = undef;
  
      # Avoid to destroy because it keeps a ref on the object. 
      # A problem if we execute it multiple times in the same perl execution
      # Use prepare_destroy
      $self->set_signal_handlers;
      return $self;
  }
  
  sub prepare_destroy {
      my ($self) = @_;
  
      delete $handlers{DIE}->{$self};
  }
  
  sub set_signal_handlers {
      my $self = shift;
  
      $SIG{__DIE__} = \&class_handle_DIE;
      $handlers{DIE}->{$self} = sub { $self->handle_DIE($_[0]) };
  }
  
  sub class_handle_DIE {
      my ($msg) = @_;
  
      foreach (keys %{$handlers{DIE}}) {
          &{$handlers{DIE}->{$_}}($msg);
      }
  }
  
  sub handle_DIE {
      my ($self, $msg) = @_;
  
      return unless defined $^S and $^S == 0; # Ignore errors in eval
      $self->{output}->add_option_msg(short_msg => $msg);
      $self->{output}->die_exit();
  }
  
  sub get_global_version {
      return $global_version;
  }
  
  sub get_plugin {
      my ($self) = @_;
      
      ######
      # Need to load global 'Output' and 'Options'
      ######
      if ($alternative_fatpacker == 0) {
          require centreon::plugins::options;
          $self->{options} = centreon::plugins::options->new();
      } else {
          require centreon::plugins::alternative::FatPackerOptions;
          $self->{options} = centreon::plugins::alternative::FatPackerOptions->new();
      }
      $self->{output} = centreon::plugins::output->new(options => $self->{options});
      $self->{options}->set_output(output => $self->{output});
  
      $self->{options}->add_options(arguments => {
          'plugin:s'          => { name => 'plugin' },
          'list-plugin'       => { name => 'list_plugin' }, 
          'help'              => { name => 'help' },
          'ignore-warn-msg'   => { name => 'ignore_warn_msg' },
          'version'           => { name => 'version' },
          'runas:s'           => { name => 'runas' },
          'environment:s%'    => { name => 'environment' },
          'convert-args:s'    => { name => 'convert_args' },
      });
  
      $self->{options}->parse_options();
  
      $self->{plugin} = $self->{options}->get_option(argument => 'plugin' );
      $self->{list_plugin} = $self->{options}->get_option(argument => 'list_plugin' );
      $self->{help} = $self->{options}->get_option(argument => 'help' );
      $self->{version} = $self->{options}->get_option(argument => 'version' );
      $self->{runas} = $self->{options}->get_option(argument => 'runas' );
      $self->{environment} = $self->{options}->get_option(argument => 'environment' );
      $self->{ignore_warn_msg} = $self->{options}->get_option(argument => 'ignore_warn_msg' );
      $self->{convert_args} = $self->{options}->get_option(argument => 'convert_args' );
  
      $self->{output}->plugin(name => $self->{plugin});
      $self->{output}->check_options(option_results => $self->{options}->get_options());
  
      $self->{options}->clean();
  }
  
  sub convert_args {
      my ($self) = @_;
      
      if ($self->{convert_args} =~ /^(.+?),(.*)/) {
          my ($search, $replace) = ($1, $2);
          for (my $i = 0; $i <= $#ARGV; $i++) {
              eval "\$ARGV[\$i] =~ s/$search/$replace/g";
          }
      }
  }
  
  sub display_local_help {
      my ($self) = @_;
  
      my $stdout;
      if ($self->{help}) {
          local *STDOUT;
          open STDOUT, '>', \$stdout;
          
          if ($alternative_fatpacker == 0) {
              pod2usage(-exitval => 'NOEXIT', -input => pod_where({-inc => 1}, __PACKAGE__));
          } else {
              my $pp = __PACKAGE__ . '.pm';
              $pp =~ s{::}{/}g;
              my $content_class = $INC{$pp}->{$pp};
              open my $str_fh, '<', \$content_class;
              pod2usage(-exitval => 'NOEXIT', -input => $str_fh);
              close $str_fh;
          }
      }
      
      $self->{output}->add_option_msg(long_msg => $stdout) if (defined($stdout));
  }
  
  sub check_directory {
      my ($self, $directory) = @_;
      
      opendir(my $dh, $directory) || return ;
      while (my $filename = readdir $dh) {
          $self->check_directory($directory . '/' . $filename) if ($filename !~ /^\./ && -d $directory . '/' . $filename);
          if ($filename eq 'plugin.pm') {
              my $stdout = '';
              
              {
                  local *STDOUT;
                  open STDOUT, '>', \$stdout;
                  pod2usage(-exitval => 'NOEXIT', -input => $directory . "/" . $filename,
                            -verbose => 99, 
                            -sections => "PLUGIN DESCRIPTION");
              }
              $self->{plugins_result}->{$directory . "/" . $filename} = $stdout;
          }
      }
      closedir $dh;
  }
  
  sub fatpacker_find_plugin {
      my ($self) = @_;
      
      my $plugins = [];
      foreach (@INC) {
          next if (ref($_) !~ /FatPacked/);
          foreach my $name (keys %$_) {
              if ($name =~ /plugin.pm$/) {
                  push @$plugins, $name;
              }
          }
      }
      
      return $plugins;
  }
  
  sub check_plugin_option {
      my ($self) = @_;
      
      if (defined($self->{version})) {
          $self->{output}->add_option_msg(short_msg => 'Global Version: ' . $global_version);
          $self->{output}->option_exit(nolabel => 1);
      }
      
      my $no_plugin = 1;
      if ($alternative_fatpacker == 1) {
          my $integrated_plugins = $self->fatpacker_find_plugin();
          if (scalar(@$integrated_plugins) == 1) {
              $self->{plugin} = $integrated_plugins->[0];
              $no_plugin = 0;
          }
      }
      
      if ($no_plugin == 1) {
          $self->{output}->add_option_msg(short_msg => "Need to specify '--plugin' option.");
          $self->{output}->option_exit();
      }
  }
  
  sub display_list_plugin {
      my ($self) = @_;
      $self->{plugins_result} = {};
      
      if ($alternative_fatpacker == 1) {
          my $integrated_plugins = $self->fatpacker_find_plugin();
          
          foreach my $key (@$integrated_plugins) {
              # Need to load it to get the description
              centreon::plugins::misc::mymodule_load(output => $self->{output}, module => $key, 
                                                     error_msg => 'Cannot load module --plugin.');
                                                 
              my $name = $key;
              $name =~ s/\.pm//g;
              $name =~ s/\//::/g;
              $self->{output}->add_option_msg(long_msg => '-----------------');
              $self->{output}->add_option_msg(long_msg => 'PLUGIN: ' . $name);
              {
                  my $stdout = '';
                  local *STDOUT;
                  open STDOUT, '>', \$stdout;
                  my $content_class = $INC{$key}->{$key};
                  open my $str_fh, '<', \$content_class;
                  pod2usage(-exitval => 'NOEXIT', -input => $str_fh, -verbose => 99, -sections => 'PLUGIN DESCRIPTION');
                  close $str_fh;
                  $self->{output}->add_option_msg(long_msg => $stdout);
              }
          }
          return ;
      }
      
      # Search file 'plugin.pm'
      $self->check_directory($FindBin::Bin);
      foreach my $key (keys %{$self->{plugins_result}}) {
          my $name = $key;
          $name =~ s/^$FindBin::Bin\/(.*)\.pm/$1/;
          $name =~ s/\//::/g;
          $self->{plugins_result}->{$key} =~ s/^Plugin Description/DESCRIPTION/i;
          
          $self->{output}->add_option_msg(long_msg => '-----------------');
          $self->{output}->add_option_msg(long_msg => 'PLUGIN: ' . $name);
          $self->{output}->add_option_msg(long_msg => $self->{plugins_result}->{$key});
      }
  }
  
  sub check_relaunch {
      my $self = shift;
      my $need_restart = 0;
      my $cmd = $FindBin::Bin . "/" . $FindBin::Script;
      my @args = ();
      
      if (defined($self->{environment})) {
          foreach (keys %{$self->{environment}}) {
              if ($_ ne '' && (!defined($ENV{$_}) || $ENV{$_} ne $self->{environment}->{$_})) {
                  $ENV{$_} = $self->{environment}->{$_};
                  $need_restart = 1;
              }
          }
      }
      
      if (defined($self->{runas}) && $self->{runas} ne '') {
          # Check if it's already me and user exist ;)
          my ($name, $passwd, $uid) = getpwnam($self->{runas});
          if (!defined($uid)) {
              $self->{output}->add_option_msg(short_msg => "Runas user '" . $self->{runas} . "' not exist.");
              $self->{output}->option_exit();
          }
          if ($uid != $>) {
              if ($> == 0) {
                  unshift @args, "-s", "/bin/bash", "-l", $self->{runas}, "-c", join(" ", $cmd, "--plugin=" . $self->{plugin}, @ARGV);
                  $cmd = "su";
              } else {
                  unshift @args, "-S", "-u", $self->{runas}, $cmd, "--plugin=" . $self->{plugin}, @ARGV;
                  $cmd = "sudo";
              }
              $need_restart = 1;
          }
      }
  
      if ($need_restart == 1) {
          if (scalar(@args) <= 0) {
              unshift @args, @ARGV, '--plugin=' . $self->{plugin}
          }
  
          my ($lerror, $stdout, $exit_code) = centreon::plugins::misc::backtick(
              command => $cmd,
              arguments => [@args],
              timeout => 30,
              wait_exit => 1
          );
  
          if ($exit_code <= -1000) {
              if ($exit_code == -1000) {
                  $self->{output}->output_add(severity => 'UNKNOWN', 
                                              short_msg => $stdout);
              }
              $self->{output}->display();
              $self->{output}->exit();
          }
          print $stdout;
          # We put unknown
          if (!($exit_code >= 0 && $exit_code <= 4)) {
              exit 3;
          }
          exit $exit_code;
      }
  }
  
  sub run {
      my ($self) = @_;
  
      $self->get_plugin();
  
      if (defined($self->{help}) && !defined($self->{plugin})) {
          $self->display_local_help();
          $self->{output}->option_exit();
      }
      if (defined($self->{list_plugin})) {
          $self->display_list_plugin();
          $self->{output}->option_exit();
      }
      $self->check_plugin_option() if (!defined($self->{plugin}) || $self->{plugin} eq '');
      if (defined($self->{ignore_warn_msg})) {
          $SIG{__WARN__} = sub {};
      }
      $self->convert_args() if (defined($self->{convert_args}));
  
      $self->check_relaunch();
      
      (undef, $self->{plugin}) = 
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => $self->{plugin}, 
                                                 error_msg => 'Cannot load module --plugin.');
      my $plugin = $self->{plugin}->new(options => $self->{options}, output => $self->{output});
      $plugin->init(help => $self->{help},
                    version => $self->{version});
      $plugin->run();
  }
  
  1;
  
  
  =head1 NAME
  
  centreon_plugins.pl - main program to call Centreon plugins.
  
  =head1 SYNOPSIS
  
  centreon_plugins.pl [options]
  
  =head1 OPTIONS
  
  =over 8
  
  =item B<--plugin>
  
  Specify the path to the plugin.
  
  =item B<--list-plugin>
  
  Print available plugins.
  
  =item B<--version>
  
  Print global version.
  
  =item B<--help>
  
  Print a brief help message and exits.
  
  =item B<--ignore-warn-msg>
  
  Perl warn messages are ignored (not displayed).
  
  =item B<--runas>
  
  Run the script as a different user (prefer to use directly the good user).
  
  =item B<--environment>
  
  Set environment variables for the script (prefer to set it before running it for better performance).
  
  =item B<--convert-args>
  
  Change strings of arguments. Useful to use '!' in nrpe protocol.
  Example: --convert-args='##,\x21'
  
  =back
  
  =head1 DESCRIPTION
  
  B<centreon_plugins.pl> .
  
  =cut
CENTREON_PLUGINS_SCRIPT

$fatpacked{"centreon/plugins/script_sql.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_SCRIPT_SQL';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::script_sql;
  
  use strict;
  use warnings;
  use centreon::plugins::misc;
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
      # $options{package} = parent package caller
      # $options{options} = options object
      # $options{output} = output object
      $self->{options} = $options{options};
      $self->{output} = $options{output};
      
      $self->{options}->add_options(
      arguments => {
              'mode:s'         => { name => 'mode_name' },
              'dyn-mode:s'     => { name => 'dynmode_name' },
              'list-mode'      => { name => 'list_mode' },
              'mode-version:s' => { name => 'mode_version' },
              'sqlmode:s'      => { name => 'sqlmode_name', default => 'dbi' },
              'list-sqlmode'   => { name => 'list_sqlmode' },
              'multiple'       => { name => 'multiple' },
              'sanity-options' => { name => 'sanity_options' }, # keep it for 6 month before remove it
          }
      );
      $self->{version} = '1.0';
      %{$self->{modes}} = ();
      %{$self->{sql_modes}} = ('dbi' => 'centreon::plugins::dbi');
      $self->{default} = undef;
      $self->{sqldefault} = {};
      $self->{sqlmode_current} = undef;
      $self->{sqlmode_stored} = [];
      
      $self->{options}->parse_options();
      $self->{option_results} = $self->{options}->get_options();
      foreach (keys %{$self->{option_results}}) {
          $self->{$_} = $self->{option_results}->{$_};
      }
      $self->{options}->clean();
  
      $self->{options}->add_help(package => $options{package}, sections => 'PLUGIN DESCRIPTION');
      $self->{options}->add_help(package => __PACKAGE__, sections => 'GLOBAL OPTIONS');
      $self->{output}->mode(name => $self->{mode_name});
  
      return $self;
  }
  
  sub init {
      my ($self, %options) = @_;
      # $options{version} = string version
      # $options{help} = string help
  
      if (defined($options{help}) && !defined($self->{mode_name}) && !defined($self->{dynmode_name})) {
          $self->{options}->display_help();
          $self->{output}->option_exit();
      }
      if (defined($options{version}) && !defined($self->{mode_name})&& !defined($self->{dynmode_name})) {
          $self->version();
      }
      if (defined($self->{list_mode})) {
          $self->list_mode();
      }
      if (defined($self->{list_sqlmode})) {
          $self->list_sqlmode();
      }
      $self->{options}->set_sanity();
  
      # Output HELP
      $self->{options}->add_help(package => 'centreon::plugins::output', sections => 'OUTPUT OPTIONS');
      
      $self->load_password_mgr();
  
      if (defined($self->{sqlmode_name}) && $self->{sqlmode_name} ne '') {
          $self->is_sqlmode(sqlmode => $self->{sqlmode_name});
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => $self->{sql_modes}{$self->{sqlmode_name}}, 
                                                 error_msg => "Cannot load module --sqlmode.");
          $self->{sqlmode_current} = $self->{sql_modes}{$self->{sqlmode_name}}->new(options => $self->{options}, output => $self->{output}, mode => $self->{sqlmode_name});
      } else {
          $self->{output}->add_option_msg(short_msg => "Need to specify '--sqlmode'.");
          $self->{output}->option_exit();
      }
      
      # Load mode
      if (defined($self->{mode_name}) && $self->{mode_name} ne '') {
          $self->is_mode(mode => $self->{mode_name});
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => $self->{modes}{$self->{mode_name}}, 
                                                 error_msg => "Cannot load module --mode.");
          $self->{mode} = $self->{modes}{$self->{mode_name}}->new(options => $self->{options}, output => $self->{output}, mode => $self->{mode_name});
      } elsif (defined($self->{dynmode_name}) && $self->{dynmode_name} ne '') {
          (undef, $self->{dynmode_name}) = centreon::plugins::misc::mymodule_load(output => $self->{output}, module => $self->{dynmode_name}, 
                                                                                  error_msg => "Cannot load module --dyn-mode.");
          $self->{mode} = $self->{dynmode_name}->new(options => $self->{options}, output => $self->{output}, mode => $self->{dynmode_name});
      } else {
          $self->{output}->add_option_msg(short_msg => "Need to specify '--mode' or '--dyn-mode' option.");
          $self->{output}->option_exit();
      }
  
      if (defined($options{help})) {
          if (defined($self->{mode_name}) && $self->{mode_name} ne '') {
              $self->{options}->add_help(package => $self->{modes}{$self->{mode_name}}, sections => 'MODE');
          } else {
              $self->{options}->add_help(package => $self->{dynmode_name}, sections => 'MODE');
          }
          $self->{options}->display_help();
          $self->{output}->option_exit();
      }
      if (defined($options{version})) {
          $self->{mode}->version();
          $self->{output}->option_exit(nolabel => 1);
      }
      if (centreon::plugins::misc::minimal_version($self->{mode}->{version}, $self->{mode_version}) == 0) {
          $self->{output}->add_option_msg(short_msg => "Not good version for plugin mode. Excepted at least: " . $self->{mode_version} . ". Get: ".  $self->{mode}->{version});
          $self->{output}->option_exit();
      }
      
      $self->{options}->parse_options();
      $self->{option_results} = $self->{options}->get_options();
      $self->{pass_mgr}->manage_options(option_results => $self->{option_results}) if (defined($self->{pass_mgr}));
  
      push @{$self->{sqlmode_stored}}, $self->{sqlmode_current};
      $self->{sqlmode_current}->set_options(option_results => $self->{option_results});
      $self->{sqlmode_current}->set_defaults(default => $self->{sqldefault});
  
      while ($self->{sqlmode_current}->check_options()) {
          $self->{sqlmode_current} = $self->{sql_modes}{$self->{sqlmode_name}}->new(noptions => 1, options => $self->{options}, output => $self->{output}, mode => $self->{sqlmode_name});
          $self->{sqlmode_current}->set_options(option_results => $self->{option_results});
          push @{$self->{sqlmode_stored}}, $self->{sqlmode_current};
      }
      $self->{mode}->check_options(option_results => $self->{option_results}, default => $self->{default});
  }
  
  sub load_password_mgr {
      my ($self, %options) = @_;
      
      return if (!defined($self->{option_results}->{pass_manager}) || $self->{option_results}->{pass_manager} eq '');
  
      (undef, my $pass_mgr_name) = centreon::plugins::misc::mymodule_load(
          output => $self->{output}, module => "centreon::plugins::passwordmgr::" . $self->{option_results}->{pass_manager}, 
          error_msg => "Cannot load module 'centreon::plugins::passwordmgr::" . $self->{option_results}->{pass_manager} . "'"
      );
      $self->{pass_mgr} = $pass_mgr_name->new(options => $self->{options}, output => $self->{output});
  }
  
  sub run {
      my $self = shift;
  
      if ($self->{output}->is_disco_format()) {
          $self->{mode}->disco_format();
          $self->{output}->display_disco_format();
          $self->{output}->exit(exit_litteral => 'ok');
      }
  
      if ($self->{output}->is_disco_show()) {
          if (defined($self->{multiple})) {
              $self->{mode}->disco_show(sql => $self->{sqlmode});
          } else {
              $self->{mode}->disco_show(sql => $self->{sqlmode_stored}[0]);
          }
          $self->{output}->display_disco_show();
          $self->{output}->exit(exit_litteral => 'ok');
      } else {
          if (defined($self->{multiple})) {
              $self->{mode}->run(sql => $self->{sqlmode_stored});
          } else {
              $self->{mode}->run(sql => $self->{sqlmode_stored}[0]);
          }
      }
  }
  
  sub is_mode {
      my ($self, %options) = @_;
      
      # $options->{mode} = mode
      if (!defined($self->{modes}{$options{mode}})) {
          $self->{output}->add_option_msg(short_msg => "mode '" . $options{mode} . "' doesn't exist (use --list-mode option to show available modes).");
          $self->{output}->option_exit();
      }
  }
  
  sub is_sqlmode {
      my ($self, %options) = @_;
      
      # $options->{sqlmode} = mode
      if (!defined($self->{sql_modes}{$options{sqlmode}})) {
          $self->{output}->add_option_msg(short_msg => "mode '" . $options{sqlmode} . "' doesn't exist (use --list-sqlmode option to show available modes).");
          $self->{output}->option_exit();
      }
  }
  
  
  sub version {
      my $self = shift;    
      $self->{output}->add_option_msg(short_msg => "Plugin Version: " . $self->{version});
      $self->{output}->option_exit(nolabel => 1);
  }
  
  sub list_mode {
      my $self = shift;
      $self->{options}->display_help();
      
      $self->{output}->add_option_msg(long_msg => "Modes Available:");
      foreach (sort keys %{$self->{modes}}) {
          $self->{output}->add_option_msg(long_msg => "   " . $_);
      }
      $self->{output}->option_exit(nolabel => 1);
  }
  
  sub list_sqlmode {
      my $self = shift;
      $self->{options}->display_help();
      
      $self->{output}->add_option_msg(long_msg => "SQL Modes Available:");
      foreach (keys %{$self->{sql_modes}}) {
          $self->{output}->add_option_msg(long_msg => "   " . $_);
      }
      $self->{output}->option_exit(nolabel => 1);
  }
  
  1;
  
  
  =head1 NAME
  
  -
  
  =head1 SYNOPSIS
  
  -
  
  =head1 GLOBAL OPTIONS
  
  =over 8
  
  =item B<--mode>
  
  Choose a mode.
  
  =item B<--dyn-mode>
  
  Specify a mode with the path (separated by '::').
  
  =item B<--list-mode>
  
  List available modes.
  
  =item B<--mode-version>
  
  Check minimal version of mode. If not, unknown error.
  
  =item B<--version>
  
  Display plugin version.
  
  =item B<--sqlmode>
  
  Choose a sql mode (Default: "dbi").
  
  =item B<--list-sqlmode>
  
  List available sql modes.
  
  =item B<--multiple>
  
  Multiple database connections (some mode needs it).
  
  =back
  
  =head1 DESCRIPTION
  
  B<>.
  
  =cut
CENTREON_PLUGINS_SCRIPT_SQL

$fatpacked{"centreon/plugins/statefile.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_STATEFILE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::statefile;
  
  use strict;
  use warnings;
  use Data::Dumper;
  use vars qw($datas);
  use centreon::plugins::misc;
  
  my $default_dir = '/var/lib/centreon/centplugins';
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
  
      if (defined($options{options})) {
          $options{options}->add_options(arguments => {
              'memcached:s'           => { name => 'memcached' },
              'redis-server:s'        => { name => 'redis_server' },
              'redis-attribute:s%'    => { name => 'redis_attribute' },
              'redis-db:s'            => { name => 'redis_db' },
              'memexpiration:s'       => { name => 'memexpiration', default => 86400 },
              'statefile-dir:s'       => { name => 'statefile_dir', default => $default_dir },
              'statefile-suffix:s'    => { name => 'statefile_suffix', default => '' },
              'statefile-concat-cwd'  => { name => 'statefile_concat_cwd' },
              'statefile-storable'    => { name => 'statefile_storable' },
          });
          $options{options}->add_help(package => __PACKAGE__, sections => 'RETENTION OPTIONS', once => 1);
      }
      
      $self->{error} = 0;
      $self->{output} = $options{output};
      $self->{datas} = {};
      $self->{storable} = 0;
      $self->{memcached_ok} = 0;
      $self->{memcached} = undef;
      
      $self->{statefile_dir} = undef;
      $self->{statefile_suffix} = undef;
      
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
  
      if (defined($options{option_results}) && defined($options{option_results}->{memcached})) {
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => 'Memcached::libmemcached',
                                                 error_msg => "Cannot load module 'Memcached::libmemcached'.");
          $self->{memcached} = Memcached::libmemcached->new();
          Memcached::libmemcached::memcached_server_add($self->{memcached}, $options{option_results}->{memcached});
      }
      
      # Check redis
      if (defined($options{option_results}->{redis_server})) {
          $self->{redis_attributes} = '';
          if (defined($options{option_results}->{redis_attribute})) {
              foreach (keys %{$options{option_results}->{redis_attribute}}) {
                  $self->{redis_attributes} .= "$_ => " . $options{option_results}->{redis_attribute}->{$_} . ', ';
              }
          }
          
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => 'Redis',
                                                 error_msg => "Cannot load module 'Redis'.");
          eval {
              $self->{redis_cnx} = Redis->new(server => $options{option_results}->{redis_server}, 
                                              eval $self->{redis_attributes});
              if (defined($self->{redis_cnx}) && 
                  defined($options{option_results}->{redis_db}) &&
                  $options{option_results}->{redis_db} ne ''
                  ) {
                  $self->{redis_cnx}->select($options{option_results}->{redis_db});
              }
          };
      }
      
      $self->{statefile_dir} = $options{option_results}->{statefile_dir};
      if ($self->{statefile_dir} ne $default_dir && defined($options{option_results}->{statefile_concat_cwd})) {
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => 'Cwd',
                                                 error_msg => "Cannot load module 'Cwd'.");
          $self->{statefile_dir} = Cwd::cwd() . '/' . $self->{statefile_dir};
      }
      if (defined($options{option_results}->{statefile_storable})) {
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => 'Storable',
                                                 error_msg => "Cannot load module 'Storable'.");
          $self->{storable} = 1;
      }
      $self->{statefile_suffix} = $options{option_results}->{statefile_suffix};
      $self->{memexpiration} = $options{option_results}->{memexpiration};
  }
  
  sub error {
      my ($self) = shift;
       
      if (@_) {
          $self->{error} = $_[0];
      }
      return $self->{error};
  }
  
  sub read {
      my ($self, %options) = @_;
      $self->{statefile_suffix} = defined($options{statefile_suffix}) ? $options{statefile_suffix} : $self->{statefile_suffix};
      $self->{statefile_dir} = defined($options{statefile_dir}) ? $options{statefile_dir} : $self->{statefile_dir};
      $self->{statefile} = defined($options{statefile}) ? $options{statefile} . $self->{statefile_suffix} : 
                              $self->{statefile};
      $self->{no_quit} = defined($options{no_quit}) && $options{no_quit} == 1 ? 1 : 0;
  
      if (defined($self->{memcached})) {
          # if "SUCCESS" or "NOT FOUND" is ok. Other with use the file
          my $val = Memcached::libmemcached::memcached_get($self->{memcached}, $self->{statefile_dir} . "/" . $self->{statefile});
          if (defined($self->{memcached}->errstr) && $self->{memcached}->errstr =~ /^SUCCESS|NOT FOUND$/i) {
              $self->{memcached_ok} = 1;
              if (defined($val)) {
                  eval( $val );
                  $self->{datas} = $datas;
                  $datas = {};
                  return 1;
              }
              return 0;
          }
      }
      
      if (defined($self->{redis_cnx})) {
          my $val = $self->{redis_cnx}->get($self->{statefile_dir} . "/" . $self->{statefile});
          if (defined($val)) {
              eval($val);
              $self->{datas} = $datas;
              $datas = {};
              return 1;
          }
          
          return 0;
      }
      
      if (! -e $self->{statefile_dir} . '/' . $self->{statefile}) {
          if (! -w $self->{statefile_dir} || ! -x $self->{statefile_dir}) {
              $self->error(1);
              $self->{output}->add_option_msg(short_msg =>  "Cannot write statefile '" . $self->{statefile_dir} . "/" . $self->{statefile} . "'. Need write/exec permissions on directory.");
              if ($self->{no_quit} == 0) {
                  $self->{output}->option_exit();
              }
          }
          return 0;
      } elsif (! -w $self->{statefile_dir} . '/' . $self->{statefile}) {
          $self->error(1);
          $self->{output}->add_option_msg(short_msg => "Cannot write statefile '" . $self->{statefile_dir} . "/" . $self->{statefile} . "'. Need write permissions on file.");
          if ($self->{no_quit} == 0) {
              $self->{output}->option_exit();
          }
          return 1;
      } elsif (! -s $self->{statefile_dir} . '/' . $self->{statefile}) {
          # Empty file. Not a problem. Maybe plugin not manage not values
          return 0;
      }
      
      if ($self->{storable} == 1) {
          open FILE, $self->{statefile_dir} . '/' . $self->{statefile};
          eval {
              $self->{datas} = Storable::fd_retrieve(*FILE);
          };
          # File is corrupted surely. We'll reset it
          if ($@) {
              close FILE;
              return 0;
          }
          close FILE;
      } else {
          unless (my $return = do $self->{statefile_dir} . '/' . $self->{statefile}) {
              # File is corrupted surely. We'll reset it
              return 0;
              #if ($@) {
              #    $self->{output}->add_option_msg(short_msg => "Couldn't parse '" . $self->{statefile_dir} . "/" . $self->{statefile} . "': $@");
              #    $self->{output}->option_exit();
              #}
              #unless (defined($return)) {
              #    $self->{output}->add_option_msg(short_msg => "Couldn't do '" . $self->{statefile_dir} . "/" . $self->{statefile} . "': $!");
              #    $self->{output}->option_exit();
              #}
              #unless ($return) {
              #    $self->{output}->add_option_msg(short_msg => "Couldn't run '" . $self->{statefile_dir} . "/" . $self->{statefile} . "': $!");
              #    $self->{output}->option_exit();
          }
          $self->{datas} = $datas;
          $datas = {};
      }
  
      return 1;
  }
  
  sub get_string_content {
      my ($self, %options) = @_;
  
      return Data::Dumper::Dumper($self->{datas});
  }
  
  sub get {
      my ($self, %options) = @_;
  
      if (defined($self->{datas}->{$options{name}})) {
          return $self->{datas}->{$options{name}};
      }
      return undef;
  }
  
  sub write {
      my ($self, %options) = @_;
  
      if ($self->{memcached_ok} == 1) {
          Memcached::libmemcached::memcached_set($self->{memcached}, $self->{statefile_dir} . '/' . $self->{statefile}, 
                                                 Data::Dumper->Dump([$options{data}], ['datas']), $self->{memexpiration});
          if (defined($self->{memcached}->errstr) && $self->{memcached}->errstr =~ /^SUCCESS$/i) {
              return ;
          }
      }
      if (defined($self->{redis_cnx})) {
          return if (defined($self->{redis_cnx}->set($self->{statefile_dir} . '/' . $self->{statefile}, Data::Dumper->Dump([$options{data}], ['datas']),
                                                    'EX', $self->{memexpiration})));
      }
      open FILE, '>', $self->{statefile_dir} . '/' . $self->{statefile};
      if ($self->{storable} == 1) {
          Storable::store_fd($options{data}, *FILE);
      } else {
          print FILE Data::Dumper->Dump([$options{data}], ['datas']);
      }
      close FILE;
  }
  
  1;
  
  
  =head1 NAME
  
  Statefile class
  
  =head1 SYNOPSIS
  
  -
  
  =head1 RETENTION OPTIONS
  
  =over 8
  
  =item B<--memcached>
  
  Memcached server to use (only one server).
  
  =item B<--redis-server>
  
  Redis server to use (only one server).
  
  =item B<--redis-attribute>
  
  Set Redis Options (--redis-attribute="cnx_timeout=5").
  
  =item B<--redis-db>
  
  Set Redis database index.
  
  =item B<--memexpiration>
  
  Time to keep data in seconds (Default: 86400).
  
  =item B<--statefile-dir>
  
  Directory for statefile (Default: '/var/lib/centreon/centplugins').
  
  =item B<--statefile-suffix>
  
  Add a suffix for the statefile name (Default: '').
  
  =item B<--statefile-concat-cwd>
  
  Concat current working directory with option '--statefile-dir'.
  Useful on Windows when plugin is compiled.
  
  =item B<--statefile-storable>
  
  Use Perl Module 'Storable' (instead Data::Dumper) to store datas.
  
  =back
  
  =head1 DESCRIPTION
  
  B<statefile>.
  
  =cut
CENTREON_PLUGINS_STATEFILE

$fatpacked{"centreon/plugins/templates/catalog_functions.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_TEMPLATES_CATALOG_FUNCTIONS';
  #
  # Copyright 2018 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::templates::catalog_functions;
  
  use strict;
  use warnings;
  use Exporter;
  
  our @ISA = qw(Exporter);
  our @EXPORT_OK = qw(catalog_status_threshold catalog_status_calc);
  
  sub catalog_status_threshold {
      my ($self, %options) = @_;
      my $status = 'ok';
      my $message;
  
      eval {
          local $SIG{__WARN__} = sub { $message = $_[0]; };
          local $SIG{__DIE__} = sub { $message = $_[0]; };
  
          my $label = $self->{label};
          $label =~ s/-/_/g;
          if (defined($self->{instance_mode}->{option_results}->{'ok_' . $label}) && $self->{instance_mode}->{option_results}->{'ok_' . $label} ne '' &&
              eval "$self->{instance_mode}->{option_results}->{'ok_' . $label}") {
              $status = 'ok';
          } elsif (defined($self->{instance_mode}->{option_results}->{'critical_' . $label}) && $self->{instance_mode}->{option_results}->{'critical_' . $label} ne '' &&
              eval "$self->{instance_mode}->{option_results}->{'critical_' . $label}") {
              $status = 'critical';
          } elsif (defined($self->{instance_mode}->{option_results}->{'warning_' . $label}) && $self->{instance_mode}->{option_results}->{'warning_' . $label} ne '' &&
              eval "$self->{instance_mode}->{option_results}->{'warning_' . $label}") {
              $status = 'warning';
          } elsif (defined($self->{instance_mode}->{option_results}->{'unknown_' . $label}) && $self->{instance_mode}->{option_results}->{'unknown_' . $label} ne '' &&
              eval "$self->{instance_mode}->{option_results}->{'unknown_' . $label}") {
              $status = 'unknown';
          }
      };
      if (defined($message)) {
          $self->{output}->output_add(long_msg => 'filter status issue: ' . $message);
      }
  
      return $status;
  }
  
  sub catalog_status_calc {
      my ($self, %options) = @_;
  
      foreach (keys %{$options{new_datas}}) {
          if (/^\Q$self->{instance}\E_(.*)/) {
              $self->{result_values}->{$1} = $options{new_datas}->{$_};
          }
      }
  }
  
  1;
  
  
CENTREON_PLUGINS_TEMPLATES_CATALOG_FUNCTIONS

$fatpacked{"centreon/plugins/templates/counter.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_TEMPLATES_COUNTER';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::templates::counter;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  use centreon::plugins::values;
  use centreon::plugins::misc;
  
  my $sort_subs = {
      num => sub { $a <=> $b },
      cmp => sub { $a cmp $b },
  };
  
  sub set_counters {
      my ($self, %options) = @_;
      
      if (!defined($self->{maps_counters})) {
          $self->{maps_counters} = {};
      }
      
      $self->{maps_counters_type} = [];
      
      # 0 = mode total
      # 1 = mode instances
      #push @{$self->{maps_counters_type}}, { 
      #    name => 'global', type => 0, message_separator => ', ', cb_prefix_output => undef, cb_init => undef,
      #};
  
      #$self->{maps_counters}->{global} = [
      #    { label => 'client', set => {
      #           key_values => [ { name => 'client' } ],
      #           output_template => 'Current client connections : %s',
      #           perfdatas => [
      #               { label => 'Client', value => 'client_absolute', template => '%s', 
      #                 min => 0, unit => 'con' },
      #           ],
      #       }
      #    },
      #];
      
      # Example for instances
      #push @{$self->{maps_counters_type}}, { 
      #    name => 'cpu', type => 1, message_separator => ', ', cb_prefix_output => undef, cb_init => undef,
      #    message_multiple => 'All CPU usages are ok',
      #};    
  }
  
  sub get_callback {
      my ($self, %options) = @_;
  
      if (defined($options{method_name})) {
          return $self->can($options{method_name});
      }
      
      return undef;
  }
  
  sub call_object_callback {
      my ($self, %options) = @_;
      
      if (defined($options{method_name})) {
          my $method = $self->can($options{method_name});
          if ($method) {
              return $self->$method(%options);
          }
      }
      
      return undef;
  }
  
  sub get_threshold_prefix {
      my ($self, %options) = @_;
      
      my $prefix = '';
      END_LOOP: foreach (@{$self->{maps_counters_type}}) {
          if ($_->{name} eq $options{name}) {
              $prefix = 'instance-' if ($_->{type} == 1);
              last;
          }
          
          if ($_->{type} == 3) {
              foreach (@{$_->{group}}) {
                  if ($_->{name} eq $options{name}) {
                      $prefix = 'instance-' if ($_->{type} == 0);
                      $prefix = 'subinstance-' if ($_->{type} == 1);
                      last END_LOOP;
                  }
              }
          }
      }
  
      return $prefix;
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $self->{version} = '1.0';
      $options{options}->add_options(arguments => {
          'filter-counters:s'     => { name => 'filter_counters' },
          'display-ok-counters:s' => { name => 'display_ok_counters' },
          'list-counters'         => { name => 'list_counters' },
      });
      $self->{statefile_value} = undef;
      if (defined($options{statefile}) && $options{statefile}) {
          centreon::plugins::misc::mymodule_load(output => $self->{output}, module => 'centreon::plugins::statefile',
                                                 error_msg => "Cannot load module 'centreon::plugins::statefile'.");
          $self->{statefile_value} = centreon::plugins::statefile->new(%options);
      }
      
      $self->{maps_counters} = {} if (!defined($self->{maps_counters}));
      $self->set_counters(%options);
      
      foreach my $key (keys %{$self->{maps_counters}}) {
          foreach (@{$self->{maps_counters}->{$key}}) {
              my $label = $_->{label};
              my $thlabel = $label;
              if ($self->{output}->use_new_perfdata() && defined($_->{nlabel})) {
                  $label = $_->{nlabel};
                  $thlabel = $self->get_threshold_prefix(name => $key) . $label;
              }
              $thlabel =~ s/\./-/g;
              
              if (!defined($_->{threshold}) || $_->{threshold} != 0) {
                  $options{options}->add_options(arguments => {
                      'warning-' . $thlabel . ':s'     => { name => 'warning-' . $thlabel },
                      'critical-' . $thlabel . ':s'    => { name => 'critical-' . $thlabel },
                  });
  
                  if (defined($_->{nlabel})) {
                      $options{options}->add_options(arguments => {
                          'warning-' . $_->{label} . ':s'     => { name => 'warning-' . $_->{label}, redirect => 'warning-' . $thlabel },
                          'critical-' . $_->{label} . ':s'    => { name => 'critical-' . $_->{label}, redirect => 'critical-' . $thlabel },
                      });
                  }
              }
              $_->{obj} = centreon::plugins::values->new(
                  statefile => $self->{statefile_value},
                  output => $self->{output}, perfdata => $self->{perfdata},
                  label => $_->{label}, nlabel => $_->{nlabel}, thlabel => $thlabel,
              );
              $_->{obj}->set(%{$_->{set}});
          }
      }
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
      
      if (defined($self->{option_results}->{list_counters})) {
          my $list_counter = 'counter list:';
          my $th_counter = '';
          foreach my $key (keys %{$self->{maps_counters}}) {
              foreach (@{$self->{maps_counters}->{$key}}) {
                  my $label = $_->{label};
                  $label =~ s/-//g;
                  $list_counter .= " " . $_->{label};
                  $th_counter .= " --warning-$_->{label}='\$_SERVICEWARNING" . uc($label) . "\$' --critical-$_->{label}='\$_SERVICECRITICAL" . uc($label) . "\$'";  
              }
          }
          $self->{output}->output_add(short_msg => $list_counter);
          $self->{output}->output_add(long_msg => 'configuration: ' . $th_counter); 
          $self->{output}->display(nolabel => 1, force_ignore_perfdata => 1);
          $self->{output}->exit();
      }
      foreach my $key (keys %{$self->{maps_counters}}) {
          foreach (@{$self->{maps_counters}->{$key}}) {
              $_->{obj}->{instance_mode} = $self;
              $_->{obj}->init(option_results => $self->{option_results});
          }
      }
      
      if (defined($self->{statefile_value})) {
          $self->{statefile_value}->check_options(%options);
      }
  }
  
  sub run_global {
      my ($self, %options) = @_;
      
      return undef if (defined($options{config}->{cb_init}) && $self->call_object_callback(method_name => $options{config}->{cb_init}) == 1);
      my $resume = defined($options{resume}) && $options{resume} == 1 ? 1 : 0;
      # Can be set when it comes from type 3 counters
      my $called_multiple = defined($options{called_multiple}) && $options{called_multiple} == 1 ? 1 : 0;
      my $multiple_parent = defined($options{multiple_parent}) && $options{multiple_parent} == 1 ? 1 : 0;
      my $force_instance = defined($options{force_instance}) ? $options{force_instance} : undef;
      
      my $message_separator = defined($options{config}->{message_separator}) ? 
          $options{config}->{message_separator}: ', ';
      my ($short_msg, $short_msg_append, $long_msg, $long_msg_append) = ('', '', '', '');
      my @exits;
      foreach (@{$self->{maps_counters}->{$options{config}->{name}}}) {
          my $obj = $_->{obj};
  
          next if (defined($self->{option_results}->{filter_counters}) && $self->{option_results}->{filter_counters} ne '' &&
              $_->{label} !~ /$self->{option_results}->{filter_counters}/);
      
          $obj->set(instance => defined($force_instance) ? $force_instance : $options{config}->{name});
      
          my ($value_check) = $obj->execute(new_datas => $self->{new_datas}, values => $self->{$options{config}->{name}});
  
          next if (defined($options{config}->{skipped_code}) && defined($options{config}->{skipped_code}->{$value_check}));
          if ($value_check != 0) {
              $long_msg .= $long_msg_append . $obj->output_error();
              $long_msg_append = $message_separator;
              next;
          }
          my $exit2 = $obj->threshold_check();
          push @exits, $exit2;
  
          my $output = $obj->output();
          if (!defined($_->{display_ok}) || $_->{display_ok} != 0 ||
              (defined($self->{option_results}->{display_ok_counters}) && $self->{option_results}->{display_ok_counters} ne '' &&
               $_->{label} =~ /$self->{option_results}->{display_ok_counters}/)) {
              $long_msg .= $long_msg_append . $output;
              $long_msg_append = $message_separator;
          }
  
          if (!$self->{output}->is_status(litteral => 1, value => $exit2, compare => 'ok')) {
              $short_msg .= $short_msg_append . $output;
              $short_msg_append = $message_separator;
          }
          
          $obj->perfdata(extra_instance => $multiple_parent);
      }
  
      my ($prefix_output, $suffix_output);
      $prefix_output = $self->call_object_callback(method_name => $options{config}->{cb_prefix_output}) 
          if (defined($options{config}->{cb_prefix_output}));
      $prefix_output = '' if (!defined($prefix_output));
      
      $suffix_output = $self->call_object_callback(method_name => $options{config}->{cb_suffix_output}) 
          if (defined($options{config}->{cb_suffix_output}));
      $suffix_output = '' if (!defined($suffix_output));
      
      if ($called_multiple == 1 && $long_msg ne '') {
          $self->{output}->output_add(long_msg => $options{indent_long_output} . $prefix_output. $long_msg . $suffix_output);
      }
      
      my $exit = $self->{output}->get_most_critical(status => [ @exits ]);
      if (!$self->{output}->is_status(litteral => 1, value => $exit, compare => 'ok')) {
          if ($called_multiple == 0) {
              $self->{output}->output_add(severity => $exit,
                                          short_msg => $prefix_output . $short_msg . $suffix_output);
          } else {
              $self->run_multiple_prefix_output(severity => $exit,
                                                short_msg => $prefix_output . $short_msg . $suffix_output);
          }
      } else {
          if ($long_msg ne '' && $multiple_parent == 0) {
              if ($called_multiple == 0) {
                  $self->{output}->output_add(short_msg => $prefix_output . $long_msg . $suffix_output) ;
              } else {
                  $self->run_multiple_prefix_output(severity => 'ok',
                                                    short_msg => $prefix_output . $long_msg . $suffix_output);
              }
          }
      }
  }
  
  sub run_instances {
      my ($self, %options) = @_;
      
      return undef if (defined($options{config}->{cb_init}) && $self->call_object_callback(method_name => $options{config}->{cb_init}) == 1);
      my $cb_init_counters = $self->get_callback(method_name => $options{config}->{cb_init_counters});
      my $display_status_lo = defined($options{display_status_long_output}) && $options{display_status_long_output} == 1 ? 1 : 0;
      my $resume = defined($options{resume}) && $options{resume} == 1 ? 1 : 0;
      my $no_message_multiple = 1;
      
      $self->{lproblems} = 0;
      $self->{multiple} = 1;
      if (scalar(keys %{$self->{$options{config}->{name}}}) == 1) {
          $self->{multiple} = 0;
      }
      
      my $message_separator = defined($options{config}->{message_separator}) ? 
          $options{config}->{message_separator}: ', ';
  
      my $sort_method = 'cmp';
      $sort_method = $options{config}->{sort_method}
          if (defined($options{config}->{sort_method}));
      foreach my $id (sort { $sort_subs->{$sort_method}->() } keys %{$self->{$options{config}->{name}}}) {
          my ($short_msg, $short_msg_append, $long_msg, $long_msg_append) = ('', '', '', '');
          my @exits = ();
          foreach (@{$self->{maps_counters}->{$options{config}->{name}}}) {
              my $obj = $_->{obj};
  
              next if (defined($self->{option_results}->{filter_counters}) && $self->{option_results}->{filter_counters} ne '' &&
                  $_->{label} !~ /$self->{option_results}->{filter_counters}/);
              next if ($cb_init_counters && $self->$cb_init_counters(%$_) == 1);
  
              $no_message_multiple = 0;
              $obj->set(instance => $id);
          
              my ($value_check) = $obj->execute(new_datas => $self->{new_datas},
                                                values => $self->{$options{config}->{name}}->{$id});
              next if (defined($options{config}->{skipped_code}) && defined($options{config}->{skipped_code}->{$value_check}));
              if ($value_check != 0) {
                  $long_msg .= $long_msg_append . $obj->output_error();
                  $long_msg_append = $message_separator;
                  next;
              }
              my $exit2 = $obj->threshold_check();
              push @exits, $exit2;
  
              my $output = $obj->output();
              if (!defined($_->{display_ok}) || $_->{display_ok} != 0 ||
                  (defined($self->{option_results}->{display_ok_counters}) && $self->{option_results}->{display_ok_counters} ne '' &&
                   $_->{label} =~ /$self->{option_results}->{display_ok_counters}/)) {
                  $long_msg .= $long_msg_append . $output;
                  $long_msg_append = $message_separator;
              }
              
              if (!$self->{output}->is_status(litteral => 1, value => $exit2, compare => 'ok')) {
                  $self->{lproblems}++;
                  $short_msg .= $short_msg_append . $output;
                  $short_msg_append = $message_separator;
              }
              
              $obj->perfdata(extra_instance => $self->{multiple});
          }
  
          my ($prefix_output, $suffix_output);
          $prefix_output = $self->call_object_callback(method_name => $options{config}->{cb_prefix_output}, instance_value => $self->{$options{config}->{name}}->{$id})
              if (defined($options{config}->{cb_prefix_output}));
          $prefix_output = '' if (!defined($prefix_output));
          
          $suffix_output = $self->call_object_callback(method_name => $options{config}->{cb_suffix_output}) 
          if (defined($options{config}->{cb_suffix_output}));
          $suffix_output = '' if (!defined($suffix_output));
  
          my $exit = $self->{output}->get_most_critical(status => [ @exits ]);
          # in mode grouped, we don't display 'ok'
          my $debug = 0;
          $debug = 1 if ($display_status_lo == 1 && $self->{output}->is_status(value => $exit, compare => 'OK', litteral => 1));
          if (scalar @{$self->{maps_counters}->{$options{config}->{name}}} > 0 && $long_msg ne '') {
              $self->{output}->output_add(long_msg => ($display_status_lo == 1 ? lc($exit) . ': ' : '') . $prefix_output . $long_msg . $suffix_output, debug => $debug);
          }
          if ($resume == 1) {
              $self->{most_critical_instance} = $self->{output}->get_most_critical(status => [ $self->{most_critical_instance},  $exit ]);  
              next;
          }
          
          if (!$self->{output}->is_status(litteral => 1, value => $exit, compare => 'ok')) {
              $self->{output}->output_add(severity => $exit,
                                          short_msg => $prefix_output . $short_msg . $suffix_output);
          }
          
          if ($self->{multiple} == 0)  {
              $self->{output}->output_add(short_msg => $prefix_output . $long_msg . $suffix_output);
          }
      }
      
      if ($no_message_multiple == 0 && $self->{multiple} == 1 && $resume == 0) {
          $self->{output}->output_add(short_msg => $options{config}->{message_multiple});
      }
  }
  
  sub run_group {
      my ($self, %options) = @_;
  
      my $multiple = 1;
      return if (scalar(keys %{$self->{$options{config}->{name}}}) <= 0);
      if (scalar(keys %{$self->{$options{config}->{name}}}) == 1) {
          $multiple = 0;
      }
      
      if ($multiple == 1) {
          $self->{output}->output_add(severity => 'OK',
                                      short_msg => $options{config}->{message_multiple});
      }
      
      my $format_output = defined($options{config}->{format_output}) ? $options{config}->{format_output} : '%s problem(s) detected';
      
      my ($global_exit, $total_problems) = ([], 0);
      foreach my $id (sort keys %{$self->{$options{config}->{name}}}) {
          $self->{most_critical_instance} = 'ok';
          if (defined($options{config}->{cb_long_output})) {
              $self->{output}->output_add(long_msg => $self->call_object_callback(method_name => $options{config}->{cb_long_output},
                                                                                  instance_value => $self->{$options{config}->{name}}->{$id}));
          }
          
          foreach my $group (@{$options{config}->{group}}) {
              $self->{$group->{name}} = $self->{$options{config}->{name}}->{$id}->{$group->{name}};
              
              # we resume datas
              $self->run_instances(config => $group, display_status_long_output => 1, resume => 1);
              
              push @{$global_exit}, $self->{most_critical_instance};
              $total_problems += $self->{lproblems};
              
              my $prefix_output;
              $prefix_output = $self->call_object_callback(method_name => $options{config}->{cb_prefix_output}, instance_value => $self->{$options{config}->{name}}->{$id})
              if (defined($options{config}->{cb_prefix_output}));
              $prefix_output = '' if (!defined($prefix_output));
              
              if ($multiple == 0 && (!defined($group->{display}) || $group->{display} != 0)) {
                  $self->{output}->output_add(severity => $self->{most_critical_instance},
                                              short_msg => sprintf("${prefix_output}" . $format_output, $self->{lproblems}));
              }
          }
      }
      
      if ($multiple == 1) {
          my $exit = $self->{output}->get_most_critical(status => [ @{$global_exit} ]);
          if (!$self->{output}->is_status(litteral => 1, value => $exit, compare => 'ok')) {
              $self->{output}->output_add(severity => $exit,
                                          short_msg => sprintf($format_output, $total_problems));
          }
      }
      
      if (defined($options{config}->{display_counter_problem})) {
          $self->{output}->perfdata_add(
              label => $options{config}->{display_counter_problem}->{label},
              nlabel => $options{config}->{display_counter_problem}->{nlabel},
              unit => $options{config}->{display_counter_problem}->{unit},
              value => $total_problems,
              min => $options{config}->{display_counter_problem}->{min}, max => $options{config}->{display_counter_problem}->{max}
          );
      }
  }
  
  sub run_multiple_instances {
      my ($self, %options) = @_;
      
      return undef if (defined($options{config}->{cb_init}) && $self->call_object_callback(method_name => $options{config}->{cb_init}) == 1);
      my $use_new_perfdata = $self->{output}->use_new_perfdata();
      my $multiple_parent = defined($options{multiple_parent}) && $options{multiple_parent} == 1 ? $options{multiple_parent} : 0;
      my $indent_long_output = defined($options{indent_long_output}) ? $options{indent_long_output} : '';
      my $no_message_multiple = 1;
      
      my $multiple = 1;
      if (scalar(keys %{$self->{$options{config}->{name}}}) == 1) {
          $multiple = 0;
      }
      
      my $message_separator = defined($options{config}->{message_separator}) ? 
          $options{config}->{message_separator} : ', ';
      my $sort_method = 'cmp';
      $sort_method = $options{config}->{sort_method}
          if (defined($options{config}->{sort_method}));
      foreach my $id (sort { $sort_subs->{$sort_method}->() } keys %{$self->{$options{config}->{name}}}) {
          my ($short_msg, $short_msg_append, $long_msg, $long_msg_append) = ('', '', '', '');
          my @exits = ();
          foreach (@{$self->{maps_counters}->{$options{config}->{name}}}) {
              my $obj = $_->{obj};
              
              next if (defined($self->{option_results}->{filter_counters}) && $self->{option_results}->{filter_counters} ne '' &&
                  $_->{label} !~ /$self->{option_results}->{filter_counters}/);
              
              my $instance = $id;
              if ($use_new_perfdata || ($multiple_parent == 1 && $multiple == 1)) {
                  $instance = $options{instance_parent} . ($self->{output}->get_instance_perfdata_separator()) . $id;
              } elsif ($multiple_parent == 1 && $multiple == 0) {
                  $instance = $options{instance_parent};
              }
              
              $no_message_multiple = 0;
              $obj->set(instance => $instance);
          
              my ($value_check) = $obj->execute(new_datas => $self->{new_datas},
                                                values => $self->{$options{config}->{name}}->{$id});
              next if (defined($options{config}->{skipped_code}) && defined($options{config}->{skipped_code}->{$value_check}));
              if ($value_check != 0) {
                  $long_msg .= $long_msg_append . $obj->output_error();
                  $long_msg_append = $message_separator;
                  next;
              }
              my $exit2 = $obj->threshold_check();
              push @exits, $exit2;
  
              my $output = $obj->output();
              $long_msg .= $long_msg_append . $output;
              $long_msg_append = $message_separator;
              
              if (!$self->{output}->is_status(litteral => 1, value => $exit2, compare => 'ok')) {
                  $short_msg .= $short_msg_append . $output;
                  $short_msg_append = $message_separator;
              }
              
              if ($multiple_parent == 1 && $multiple == 0) {
                  $obj->perfdata(extra_instance => 1);
              } else {
                  $obj->perfdata(extra_instance => $multiple);
              }
          }
  
          my ($prefix_output, $suffix_output);
          $prefix_output = $self->call_object_callback(method_name => $options{config}->{cb_prefix_output}, instance_value => $self->{$options{config}->{name}}->{$id})
              if (defined($options{config}->{cb_prefix_output}));
          $prefix_output = '' if (!defined($prefix_output));
          
          $suffix_output = $self->call_object_callback(method_name => $options{config}->{cb_suffix_output}) 
          if (defined($options{config}->{cb_suffix_output}));
          $suffix_output = '' if (!defined($suffix_output));
  
          my $exit = $self->{output}->get_most_critical(status => [ @exits ]);
          if (scalar @{$self->{maps_counters}->{$options{config}->{name}}} > 0 && $long_msg ne '') {
              $self->{output}->output_add(long_msg => $indent_long_output . $prefix_output . $long_msg . $suffix_output)
                  if (!defined($options{config}->{display_long}) || $options{config}->{display_long} != 0);
          }
          
          if (!$self->{output}->is_status(litteral => 1, value => $exit, compare => 'ok')) {
              $self->run_multiple_prefix_output(severity => $exit,
                  short_msg => $prefix_output . $short_msg . $suffix_output);
          }
          
          if ($multiple == 0 && $multiple_parent == 0) {
              $self->run_multiple_prefix_output(severity => 'ok', short_msg => $prefix_output . $long_msg . $suffix_output);            
          }
      }
      
      if ($no_message_multiple == 0 && $multiple == 1 && $multiple_parent == 0) {
          $self->{output}->output_add(short_msg => $options{config}->{message_multiple});
      }
  }
  
  sub run_multiple_prefix_output {
      my ($self, %options) = @_;
      
      my %separator;
      if ($self->{prefix_multiple_output_done}->{lc($options{severity})} == 0) {
          $self->{output}->output_add(severity => $options{severity}, short_msg => $self->{prefix_multiple_output});
          $self->{prefix_multiple_output_done}->{lc($options{severity})} = 1;
          $separator{separator} = '';
      }
      
      $self->{output}->output_add(severity => $options{severity}, short_msg => "$options{short_msg}", %separator);
  }
  
  sub run_multiple {
      my ($self, %options) = @_;
  
      my $multiple = 1;
      if (scalar(keys %{$self->{$options{config}->{name}}}) == 1) {
          $multiple = 0;
      }
      
      if ($multiple == 1) {
          $self->{output}->output_add(severity => 'OK',
                                      short_msg => $options{config}->{message_multiple});
      }
      
      foreach my $instance (sort keys %{$self->{$options{config}->{name}}}) {
          if (defined($options{config}->{cb_long_output})) {
              $self->{output}->output_add(long_msg => $self->call_object_callback(method_name => $options{config}->{cb_long_output},
                                                                                  instance_value => $self->{$options{config}->{name}}->{$instance}));
          }
          
          $self->{prefix_multiple_output} = '';
          $self->{prefix_multiple_output_done} = { ok => 0, warning => 0, critical => 0, unknown => 0 };
          $self->{prefix_multiple_output} = $self->call_object_callback(method_name => $options{config}->{cb_prefix_output}, instance_value => $self->{$options{config}->{name}}->{$instance})
               if (defined($options{config}->{cb_prefix_output}));
          my $indent_long_output = '';
          $indent_long_output = $options{config}->{indent_long_output}
              if (defined($options{config}->{indent_long_output}));
          
          foreach my $group (@{$options{config}->{group}}) {
              next if (!defined($self->{$options{config}->{name}}->{$instance}->{$group->{name}}));
              $self->{$group->{name}} = $self->{$options{config}->{name}}->{$instance}->{$group->{name}};
              
              if ($group->{type} == 1) {
                  $self->run_multiple_instances(config => $group, multiple_parent => $multiple, instance_parent => $instance, indent_long_output => $indent_long_output);
              } elsif ($group->{type} == 0) {
                  $self->run_global(config => $group, multiple_parent => $multiple, called_multiple => 1, force_instance => $instance, indent_long_output => $indent_long_output);
              }
          }
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      
      $self->manage_selection(%options);
      
      $self->{new_datas} = undef;
      if (defined($self->{statefile_value})) {
          $self->{new_datas} = {};
          $self->{statefile_value}->read(statefile => $self->{cache_name}) if (defined($self->{cache_name}));
          $self->{new_datas}->{last_timestamp} = time();
      }
      
      foreach my $entry (@{$self->{maps_counters_type}}) {
          if ($entry->{type} == 0) {
              $self->run_global(config => $entry);
          } elsif ($entry->{type} == 1) {
              $self->run_instances(config => $entry);
          } elsif ($entry->{type} == 2) {
              $self->run_group(config => $entry);
          } elsif ($entry->{type} == 3) {
              $self->run_multiple(config => $entry);
          }
      }
          
      if (defined($self->{statefile_value})) {
          $self->{statefile_value}->write(data => $self->{new_datas});
      }
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
  
      # example for snmp
      #use Digest::MD5 qw(md5_hex);
      #$self->{cache_name} = "choose_name_" . $options{snmp}->get_hostname()  . '_' . $options{snmp}->get_port() . '_' . $self->{mode} . '_' . 
      #    (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all'));
  }
  
  sub change_macros {
      my ($self, %options) = @_;
  
      foreach (@{$options{macros}}) {
          if (defined($self->{option_results}->{$_})) {
              $self->{option_results}->{$_} =~ s/%\{(.*?)\}/\$self->{result_values}->{$1}/g;
          }
      }
  }
      
  1;
  
  
  =head1 MODE
  
  Default template for counters. Should be extended.
  
  =over 8
  
  =item B<--filter-counters>
  
  Only display some counters (regexp can be used).
  Example to check SSL connections only : --filter-counters='^xxxx|yyyy$'
  
  =item B<--warning-*>
  
  Threshold warning.
  Can be: 'xxx', 'xxx'.
  
  =item B<--critical-*>
  
  Threshold critical.
  Can be: 'xxx', 'xxx'.
  
  =back
  
  =cut
CENTREON_PLUGINS_TEMPLATES_COUNTER

$fatpacked{"centreon/plugins/templates/hardware.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_TEMPLATES_HARDWARE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::templates::hardware;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  
  sub set_system {
      my ($self, %options) = @_;
      
      # To check with a regexp
      #$self->{regexp_threshold_overload_check_section_option} = '';
      #$self->{cb_threshold_overload_check_section_option} = 'callbackname';
      
      #$self->{regexp_threshold_numeric_check_section_option} = '';
      #$self->{cb_threshold_numeric_check_section_option} = 'callbackname';
      
      # Some callbacks 
      #$self->{cb_hook1} = 'callbackname'; # before the loads
      #$self->{cb_hook2} = 'callbackname'; # between loads and requests
      #$self->{cb_hook3} = 'callbackname'; # after requests
      #$self->{cb_hook4} = 'callbackname'; # after output
      
      # Example for threshold:
      #$self->{thresholds} = {
      #    fan => [
      #        ['bad', 'CRITICAL'],
      #        ['good', 'OK'],
      #        ['notPresent', 'OK'],
      #    ],
      #};
      
      # Unset the call to load components
      #$self->{components_exec_load} = 0;
      
      # Set the path_info
      #$self->{components_path} = 'network::xxxx::mode::components';
      
      # Set the components
      #$self->{components_module} = ['cpu', 'memory', ...];
  }
  
  sub call_object_callback {
      my ($self, %options) = @_;
      
      if (defined($options{method_name})) {
          my $method = $self->can($options{method_name});
          if ($method) {
              return $self->$method(%options);
          }
      }
      
      return undef;
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $self->{version} = '1.0';
      $options{options}->add_options(arguments => {
          'component:s'             => { name => 'component', default => '.*' },
          'no-component:s'          => { name => 'no_component' },
          'threshold-overload:s@'   => { name => 'threshold_overload' },
          'add-name-instance'       => { name => 'add_name_instance' },
      });
      
      $self->{performance} = (defined($options{no_performance}) && $options{no_performance} == 1) ?
          0 : 1;
      if ($self->{performance} == 1) {
          $options{options}->add_options(arguments => {
              'warning:s@'     => { name => 'warning' },
              'critical:s@'   => { name => 'critical' },
          });
      }
      
      $self->{filter_exclude} = (defined($options{no_filter_exclude}) && $options{no_filter_exclude} == 1) ?
          0 : 1;
      if ($self->{filter_exclude} == 1) {
          $options{options}->add_options(arguments => {
              'exclude:s'     => { name => 'exclude' },
              'filter:s@'     => { name => 'filter' },
          });
      }
      $self->{absent} = (defined($options{no_absent}) && $options{no_absent} == 1) ?
          0 : 1;
      if ($self->{absent} == 1) {
          $options{options}->add_options(arguments => {
              'absent-problem:s@'       => { name => 'absent_problem' },
          });
      }
      
      $self->{load_components} = (defined($options{no_load_components}) && $options{no_load_components} == 1) ?
          0 : 1;
      $self->{components} = {};
      $self->{no_components} = undef;
      
      $self->{components_module} = [];
      $self->{components_exec_load} = 1;
      $self->set_system();
  
      $self->{count} = (defined($options{no_count}) && $options{no_count} == 1) ?
          0 : 1;
      if ($self->{count} == 1) {
          foreach my $component (@{$self->{components_module}}) {
              $options{options}->add_options(arguments => {
                  'warning-count-' . $component . ':s'    => { name => 'warning_count_' . $component },
                  'critical-count-' . $component . ':s'    => { name => 'critical_count_' . $component },
              });
          }
      }
  
      $self->{request} = [];
      
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
      
      if (defined($self->{option_results}->{no_component})) {
          if ($self->{option_results}->{no_component} ne '') {
              $self->{no_components} = $self->{option_results}->{no_component};
          } else {
              $self->{no_components} = 'critical';
          }
      }
      
      if ($self->{filter_exclude} == 1) {
          $self->{filter} = [];
          foreach my $val (@{$self->{option_results}->{filter}}) {
              next if (!defined($val) || $val eq '');
              my @values = split (/,/, $val);
              push @{$self->{filter}}, { filter => $values[0], instance => $values[1] }; 
          }
      }
      
      if ($self->{absent} == 1) {
          $self->{absent_problem} = [];
          foreach my $val (@{$self->{option_results}->{absent_problem}}) {
              next if (!defined($val) || $val eq '');
              my @values = split (/,/, $val);
              push @{$self->{absent_problem}}, { filter => $values[0], instance => $values[1] }; 
          }
      }
      
      $self->{overload_th} = {};
      foreach my $val (@{$self->{option_results}->{threshold_overload}}) {
          next if (!defined($val) || $val eq '');
          my @values = split (/,/, $val);
          if (scalar(@values) < 3) {
              $self->{output}->add_option_msg(short_msg => "Wrong threshold-overload option '" . $val . "'.");
              $self->{output}->option_exit();
          }
          my ($section, $instance, $status, $filter);
          if (scalar(@values) == 3) {
              ($section, $status, $filter) = @values;
              $instance = '.*';
          } else {
               ($section, $instance, $status, $filter) = @values;
          }
          if (defined($self->{regexp_threshold_overload_check_section_option}) && 
              $section !~ /$self->{regexp_threshold_overload_check_section_option}/) {
              $self->{output}->add_option_msg(short_msg => "Wrong threshold-overload section '" . $val . "'.");
              $self->{output}->option_exit();
          }
          $self->call_object_callback(method_name => $self->{cb_threshold_overload_check_section_option}, 
                                      section => $section, option_value => $val);
  
          if ($self->{output}->is_litteral_status(status => $status) == 0) {
              $self->{output}->add_option_msg(short_msg => "Wrong threshold-overload status '" . $val . "'.");
              $self->{output}->option_exit();
          }
          $self->{overload_th}->{$section} = [] if (!defined($self->{overload_th}->{$section}));
          push @{$self->{overload_th}->{$section}}, {filter => $filter, status => $status, instance => $instance };
      }
      
      if ($self->{performance} == 1) {
          $self->{numeric_threshold} = {};
          foreach my $option (('warning', 'critical')) {
              foreach my $val (@{$self->{option_results}->{$option}}) {
                  next if (!defined($val) || $val eq '');
                  if ($val !~ /^(.*?),(.*?),(.*)$/) {
                      $self->{output}->add_option_msg(short_msg => "Wrong $option option '" . $val . "'.");
                      $self->{output}->option_exit();
                  }
                  my ($section, $instance, $value) = ($1, $2, $3);                
                  if (defined($self->{regexp_threshold_numeric_check_section_option}) && 
                      $section !~ /$self->{regexp_threshold_numeric_check_section_option}/) {
                      $self->{output}->add_option_msg(short_msg => "Wrong $option option '" . $val . "'.");
                      $self->{output}->option_exit();
                  }   
                  $self->call_object_callback(method_name => $self->{cb_threshold_numeric_check_section_option}, 
                                              section => $section, option_name => $option, option_value => $val);
  
                  my $position = 0;
                  if (defined($self->{numeric_threshold}->{$section})) {
                      $position = scalar(@{$self->{numeric_threshold}->{$section}});
                  }
                  if (($self->{perfdata}->threshold_validate(label => $option . '-' . $section . '-' . $position, value => $value)) == 0) {
                      $self->{output}->add_option_msg(short_msg => "Wrong $option threshold '" . $value . "'.");
                      $self->{output}->option_exit();
                  }
                  $self->{numeric_threshold}->{$section} = [] if (!defined($self->{numeric_threshold}->{$section}));
                  push @{$self->{numeric_threshold}->{$section}}, { label => $option . '-' . $section . '-' . $position, threshold => $option, instance => $instance };
              }
          }
      }
      
      if ($self->{count} == 1) {
          foreach my $comp (@{$self->{components_module}}) {
              foreach my $threshold (('warning', 'critical')) {
                  if (($self->{perfdata}->threshold_validate(label => $threshold . '-count-' . $comp, value => $self->{option_results}->{$threshold . '_count_' . $comp})) == 0) {
                      $self->{output}->add_option_msg(short_msg => "Wrong " . $threshold . " threshold '" . $self->{option_results}->{$threshold . '_count_' . $comp} . "'.");
                      $self->{output}->option_exit();
                  }
              }
          }
      }
  }
  
  sub load_components {
      my ($self, %options) = @_;
      
      foreach (@{$self->{components_module}}) {
          if (/$self->{option_results}->{component}/) {
              my $mod_name = $self->{components_path} . "::$_";
              centreon::plugins::misc::mymodule_load(output => $self->{output}, module => $mod_name,
                                                     error_msg => "Cannot load module '$mod_name'.") if ($self->{load_components} == 1);
              $self->{loaded} = 1;
              if ($self->{components_exec_load} == 1) {
                  my $func = $mod_name->can('load');
                  $func->($self);
              }
          }
      }
  }
  
  sub exec_components {
      my ($self, %options) = @_;
      
      foreach (@{$self->{components_module}}) {
          if (/$self->{option_results}->{component}/) {
              my $mod_name = $self->{components_path} . "::$_";
              my $func = $mod_name->can('check');
              $func->($self); 
          }
      }
  }
  
  sub display {
      my ($self, %options) = @_;
      
      my $total_components = 0;
      my $display_by_component = '';
      my $display_by_component_append = '';
      my $exit = 'OK';
      my $exits = [];
      my ($warn, $crit);
  
      foreach my $comp (sort(keys %{$self->{components}})) {
          # Skipping short msg when no components
          next if ($self->{components}->{$comp}->{total} == 0 && $self->{components}->{$comp}->{skip} == 0);
  
          if ($self->{count} == 1) {
              ($exit, $warn, $crit) = $self->get_severity_count(label => $comp, value => $self->{components}->{$comp}->{total});
              if (!$self->{output}->is_status(value => $exit, compare => 'ok', litteral => 1)) {
                  $self->{output}->output_add(severity => $exit,
                                              short_msg => sprintf("'%s' components '%s' checked",
                                                              $self->{components}->{$comp}->{total},
                                                              $comp));
              }
              $self->{output}->perfdata_add(
                  label => 'count_' . $comp,
                  nlabel => 'hardware.' . $comp . '.count',
                  value => $self->{components}->{$comp}->{total},
                  warning => $warn,
                  critical => $crit
              );
              push @{$exits}, $exit;
          }
  
          $total_components += $self->{components}->{$comp}->{total} + $self->{components}->{$comp}->{skip};
          my $count_by_components = $self->{components}->{$comp}->{total} + $self->{components}->{$comp}->{skip}; 
          $display_by_component .= $display_by_component_append . $self->{components}->{$comp}->{total} . '/' . $count_by_components . ' ' . $self->{components}->{$comp}->{name};
          $display_by_component_append = ', ';
      }
  
      $exit = $self->{output}->get_most_critical(status => $exits) if (scalar(@{$exits}) > 0);
      
      if ($self->{output}->is_status(value => $exit, compare => 'ok', litteral => 1)) {
          $self->{output}->output_add(short_msg => sprintf('All %s components are ok [%s].', 
                                                          $total_components,
                                                          $display_by_component)
                                      );
      }
  
      if (defined($self->{option_results}->{no_component}) && $total_components == 0) {
          $self->{output}->output_add(severity => $self->{no_components},
                                      short_msg => 'No components are checked.');
      }
  }
  
  sub run {
      my ($self, %options) = @_;
  
      $self->{loaded} = 0;  
      $self->call_object_callback(method_name => $self->{cb_hook1}, %options);
  
      $self->load_components(%options);
      if ($self->{loaded} == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong option. Cannot find component '" . $self->{option_results}->{component} . "'.");
          $self->{output}->option_exit();
      }
      
      $self->call_object_callback(method_name => $self->{cb_hook2}, %options);
      $self->exec_components(%options);
      $self->call_object_callback(method_name => $self->{cb_hook3}, %options);
      
      $self->display();
  
      $self->call_object_callback(method_name => $self->{cb_hook4}, %options);
      
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  sub check_filter {
      my ($self, %options) = @_;
      
      # Old compatibility variable. We'll be deleted
      if (defined($self->{option_results}->{exclude})) {
          if (defined($options{instance})) {
              if ($self->{option_results}->{exclude} =~ /(^|\s|,)${options{section}}[^,]*#\Q$options{instance}\E#/) {
                  $self->{components}->{$options{section}}->{skip}++;
                  $self->{output}->output_add(long_msg => sprintf("skipping $options{section} section $options{instance} instance."));
                  return 1;
              }
          } elsif (defined($self->{option_results}->{exclude}) && $self->{option_results}->{exclude} =~ /(^|\s|,)$options{section}(\s|,|$)/) {
              $self->{output}->output_add(long_msg => sprintf("skipping $options{section} section."));
              return 1;
          }
      }
  
      $options{instance} .= '#' . $options{name} if (defined($self->{option_results}->{add_name_instance}) && defined($options{name}));   
      foreach (@{$self->{filter}}) {
          if ($options{section} =~ /$_->{filter}/) {
              if (!defined($options{instance}) && !defined($_->{instance})) {
                  $self->{output}->output_add(long_msg => sprintf("skipping $options{section} section."));
                  return 1;
              } elsif (defined($options{instance}) && $options{instance} =~ /$_->{instance}/) {
                  $self->{output}->output_add(long_msg => sprintf("skipping $options{section} section $options{instance} instance."));
                  return 1;
              }
          }
      }
      
      return 0;
  }
  
  sub absent_problem {
      my ($self, %options) = @_;
  
      $options{instance} .= '#' . $options{name} if (defined($self->{option_results}->{add_name_instance}) && defined($options{name}));
      foreach (@{$self->{absent_problem}}) {
          if ($options{section} =~ /$_->{filter}/) {
              if (!defined($_->{instance}) || $options{instance} =~ /$_->{instance}/) {
                  $self->{output}->output_add(severity => 'CRITICAL',
                                              short_msg => sprintf("Component '%s' instance '%s' is not present", 
                                                                   $options{section}, $options{instance}));
                  $self->{output}->output_add(long_msg => sprintf("Skipping $options{section} section $options{instance} instance (not present)"));
                  $self->{components}->{$options{section}}->{skip}++;
                  return 1;
              }
          }
      }
      
      return 0;
  }
  
  sub get_severity_count {
      my ($self, %options) = @_;
      my $status = 'OK'; # default
      my $thresholds = { warning => undef, critical => undef };
      
      $status = $self->{perfdata}->threshold_check(value => $options{value},
                                                   threshold => [ { label => 'critical-count-' . $options{label}, 'exit_litteral' => 'critical' }, 
                                                                  { label => 'warning-count-' . $options{label}, 'exit_litteral' => 'warning' } ]);
      $thresholds->{critical} = $self->{perfdata}->get_perfdata_for_output(label => 'critical-count-' . $options{label});
      $thresholds->{warning} = $self->{perfdata}->get_perfdata_for_output(label => 'warning-count-' . $options{label});
  
      return ($status, $thresholds->{warning}, $thresholds->{critical});
  }
  
  sub get_severity_numeric {
      my ($self, %options) = @_;
      my $status = 'OK'; # default
      my $thresholds = { warning => undef, critical => undef };
      my $checked = 0;
  
      $options{instance} .= '#' . $options{name} if (defined($self->{option_results}->{add_name_instance}) && defined($options{name}));
      if (defined($self->{numeric_threshold}->{$options{section}})) {
          my $exits = [];
          foreach (@{$self->{numeric_threshold}->{$options{section}}}) {
              if ($options{instance} =~ /$_->{instance}/) {
                  push @{$exits}, $self->{perfdata}->threshold_check(value => $options{value}, threshold => [ { label => $_->{label}, exit_litteral => $_->{threshold} } ]);
                  $thresholds->{$_->{threshold}} = $self->{perfdata}->get_perfdata_for_output(label => $_->{label});
                  $checked = 1;
              }
          }
          $status = $self->{output}->get_most_critical(status => $exits) if (scalar(@{$exits}) > 0);
      }
      
      return ($status, $thresholds->{warning}, $thresholds->{critical}, $checked);
  }
  
  sub get_severity {
      my ($self, %options) = @_;
      my $status = 'UNKNOWN'; # default 
      
      if (defined($self->{overload_th}->{$options{section}})) {
          foreach (@{$self->{overload_th}->{$options{section}}}) {            
              if ($options{value} =~ /$_->{filter}/i && 
                  (!defined($options{instance}) || $options{instance} =~ /$_->{instance}/)) {
                  $status = $_->{status};
                  return $status;
              }
          }
      }
      my $label = defined($options{label}) ? $options{label} : $options{section};
      foreach (@{$self->{thresholds}->{$label}}) {
          if ($options{value} =~ /$$_[0]/i) {
              $status = $$_[1];
              return $status;
          }
      }
      
      return $status;
  }
      
  1;
  
  
  =head1 MODE
  
  Default template for hardware. Should be extended.
  
  =over 8
  
  =item B<--component>
  
  Which component to check (Default: '.*').
  Can be: 'xxx', 'yyy'.
  
  =item B<--filter>
  
  Exclude some parts (comma seperated list) (Example: --filter=xxx --filter=yyyy)
  Can also exclude specific instance: --filter=xxxxx,instancevalue
  
  =item B<--absent-problem>
  
  Return an error if an entity is not 'present' (default is skipping) (comma seperated list)
  Can be specific or global: --absent-problem=xxxx,instancevalue
  
  =item B<--no-component>
  
  Return an error if no compenents are checked.
  If total (with skipped) is 0. (Default: 'critical' returns).
  
  =item B<--threshold-overload>
  
  Set to overload default threshold values (syntax: section,[instance,]status,regexp)
  It used before default thresholds (order stays).
  Example: --threshold-overload='xxxxx,CRITICAL,^(?!(normal)$)'
  
  =item B<--warning>
  
  Set warning threshold for temperatures (syntax: type,instance,threshold)
  Example: --warning='xxxxx,.*,30'
  
  =item B<--critical>
  
  Set critical threshold for temperatures (syntax: type,instance,threshold)
  Example: --critical='xxxxx,.*,40'
  
  =item B<--warning-count-xxxx>
  
  Set warning threshold for component count.
  
  =item B<--critical-count-xxxx>
  
  Set critical threshold for component count.
  
  =back
  
  =cut
CENTREON_PLUGINS_TEMPLATES_HARDWARE

$fatpacked{"centreon/plugins/values.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'CENTREON_PLUGINS_VALUES';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package centreon::plugins::values;
  
  use strict;
  use warnings;
  # Warning message with sprintf and too much arguments.
  # Really annoying. Need to disable that warning
  no if ($^V gt v5.22.0), 'warnings' => 'redundant';
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
  
      $self->{statefile} = $options{statefile};
      $self->{output} = $options{output};
      $self->{perfdata} = $options{perfdata};
      $self->{label} = $options{label};
      $self->{nlabel} = $options{nlabel};
      $self->{thlabel} = defined($options{thlabel}) ? $options{thlabel} : $self->{label};
  
      $self->{perfdatas} = [];
      
      $self->{output_template} = $self->{label} . ' : %s';
      $self->{output_use} = undef;
      $self->{output_change_bytes} = 0;
      $self->{output_absolute_unit} = '';
      $self->{output_per_second_unit} = '';
      
      $self->{output_error_template} = $self->{label} . ' : %s';
      
      $self->{threshold_use} = undef;
      $self->{threshold_warn} = undef;
      $self->{threshold_crit} = undef;
  
      $self->{per_second} = 0;
      $self->{manual_keys} = 0;
      $self->{last_timestamp} = undef;
  
      $self->{result_values} = {};
      
      return $self;
  }
  
  sub init {
      my ($self, %options) = @_;
      my $warn = defined($self->{threshold_warn}) ? $self->{threshold_warn} : 'warning-' . $self->{thlabel};
      my $crit = defined($self->{threshold_crit}) ? $self->{threshold_crit} : 'critical-' . $self->{thlabel}; 
      
      if (($self->{perfdata}->threshold_validate(label => $warn, value => $options{option_results}->{$warn})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong $warn threshold '" . $options{option_results}->{$warn} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => $crit, value => $options{option_results}->{$crit})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong $crit threshold '" . $options{option_results}->{$crit} . "'.");
          $self->{output}->option_exit();
      }
  }
  
  sub set {
      my ($self, %options) = @_;
  
      foreach (keys %options) {
          $self->{$_} = $options{$_};
      }
  }
  
  sub calc {
      my ($self, %options) = @_;
  
      # manage only one value ;)
      foreach my $value (@{$self->{key_values}}) {
          if (defined($value->{diff}) && $value->{diff} == 1) { 
              if (defined($self->{per_second}) && $self->{per_second} == 1) {
                  $self->{result_values}->{$value->{name} . '_per_second'} = ($options{new_datas}->{$self->{instance} . '_' . $value->{name}} - $options{old_datas}->{$self->{instance} . '_' . $value->{name}}) / $options{delta_time};
              }
              $self->{result_values}->{$value->{name} . '_absolute'} = $options{new_datas}->{$self->{instance} . '_' . $value->{name}} - $options{old_datas}->{$self->{instance} . '_' . $value->{name}};
          } else {
              # absolute one. nothing to do. Can be used for values.
              $self->{result_values}->{$value->{name} . '_absolute'} = $options{new_datas}->{$self->{instance} . '_' . $value->{name}};
          }
      }
  
      return 0;
  }
  
  sub threshold_check {
      my ($self, %options) = @_;
      
      if (defined($self->{closure_custom_threshold_check})) {
          return &{$self->{closure_custom_threshold_check}}($self, %options);
      }
      
      my $warn = defined($self->{threshold_warn}) ? $self->{threshold_warn} : 'warning-' . $self->{thlabel};
      my $crit = defined($self->{threshold_crit}) ? $self->{threshold_crit} : 'critical-' . $self->{thlabel};
      
      my $first = defined($self->{key_values}->[0]) ? $self->{key_values}->[0]->{name} : '';
      my $value;
  
      if (!defined($self->{threshold_use})) {
          $value = $self->{result_values}->{$first . '_absolute'};
          if (defined($self->{per_second}) && $self->{per_second} == 1) {
              $value = $self->{result_values}->{$first . '_per_second'};
          }
      } else {
          $value = $self->{result_values}->{$self->{threshold_use}};
      }
  
      return $self->{perfdata}->threshold_check(value => $value, threshold => [ { label => $crit, 'exit_litteral' => 'critical' },
                                                                                { label => $warn, 'exit_litteral' => 'warning' }]);
  }
  
  sub output_error {
      my ($self, %options) = @_;
      
      return sprintf($self->{output_error_template}, $self->{error_msg});
  }
  
  sub output {
      my ($self, %options) = @_;
       
      if (defined($self->{closure_custom_output})) {
          return $self->{closure_custom_output}->($self);
      }
      my $first = $self->{key_values}->[0]->{name};
      my ($value, $unit) = (defined($first) ? $self->{result_values}->{$first . '_absolute'} : '', $self->{output_absolute_unit});
      
      if (!defined($self->{output_use})) {
          if ($self->{per_second} == 1) {
              $value = $self->{result_values}->{$first . '_per_second'};
              $unit = $self->{output_per_second_unit};
          }
      } else {
          $value = $self->{result_values}->{$self->{output_use}};
      }
  
      if ($self->{output_change_bytes} == 1) {
          ($value, $unit) = $self->{perfdata}->change_bytes(value => $value);
      } elsif ($self->{output_change_bytes} == 2) {
          ($value, $unit) = $self->{perfdata}->change_bytes(value => $value, network => 1);
      }
      
      return sprintf($self->{output_template}, $value, $unit);
  }
  
  sub use_instances {
      my ($self, %options) = @_;
  
      if (!defined($options{extra_instance}) || $options{extra_instance} != 0 || $self->{output}->use_new_perfdata()) {
          return 1;
      }
      
      return 0;
  }
  
  sub perfdata {
      my ($self, %options) = @_;
      
      if (defined($self->{closure_custom_perfdata})) {
          return &{$self->{closure_custom_perfdata}}($self, %options);
      }
      
      my $warn = defined($self->{threshold_warn}) ? $self->{threshold_warn} : 'warning-' . $self->{thlabel};
      my $crit = defined($self->{threshold_crit}) ? $self->{threshold_crit} : 'critical-' . $self->{thlabel}; 
      
      foreach my $perf (@{$self->{perfdatas}}) {
          my ($label, $extra_label, $min, $max, $th_total) = ($self->{label}, '');
          my $cast_int = (defined($perf->{cast_int}) && $perf->{cast_int} == 1) ? 1 : 0;
          my $template = '%s';
          
          $template = $perf->{template} if (defined($perf->{template}));
          $label = $perf->{label} if (defined($perf->{label}));
          if (defined($perf->{min})) {
              $min = ($perf->{min} =~ /[^0-9]/) ? $self->{result_values}->{$perf->{min}} : $perf->{min};
          }
          if (defined($perf->{max})) {
              $max = ($perf->{max} =~ /[^0-9]/) ? $self->{result_values}->{$perf->{max}} : $perf->{max};
          }
          if (defined($perf->{threshold_total})) {
              $th_total = ($perf->{threshold_total} =~ /[^0-9]/) ? $self->{result_values}->{$perf->{threshold_total}} : $perf->{threshold_total};
          }
          
          my $instances;
          if (defined($perf->{label_extra_instance}) && $perf->{label_extra_instance} == 1) {
              my $instance = '';
              if (defined($perf->{instance_use})) {
                  $instance = $self->{result_values}->{$perf->{instance_use}};
              } else {
                  $instance = $self->{instance};
              }
              
              if (!defined($options{extra_instance}) || $options{extra_instance} != 0 || $self->{output}->use_new_perfdata()) {
                  $instances = $instance;
              }
          }
  
          $self->{output}->perfdata_add(
              label => $label,
              instances => $instances,
              nlabel => $self->{nlabel},
              unit => $perf->{unit},
              value => $cast_int == 1 ? int($self->{result_values}->{$perf->{value}}) : sprintf($template, $self->{result_values}->{$perf->{value}}),
              warning => $self->{perfdata}->get_perfdata_for_output(label => $warn, total => $th_total, cast_int => $cast_int),
              critical => $self->{perfdata}->get_perfdata_for_output(label => $crit, total => $th_total, cast_int => $cast_int),
              min => $min, max => $max
          );
      }
  }
  
  sub execute {
      my ($self, %options) = @_;
      my $old_datas = {};
  
      $self->{result_values} = {},
      $self->{error_msg} = undef;
      my $quit = 0;
      my $per_second = 0;
      
      $options{new_datas} = {} if (!defined($options{new_datas}));
      foreach my $value (@{$self->{key_values}}) {
          if (!defined($options{values}->{$value->{name}}) || 
              defined($value->{no_value}) && $options{values}->{$value->{name}} eq $value->{no_value}) {
              $quit = 2;
              last;
          }
      
          if (defined($value->{diff}) && $value->{diff} == 1) {            
              $options{new_datas}->{$self->{instance} . '_' . $value->{name}} = $options{values}->{$value->{name}};
              $old_datas->{$self->{instance} . '_' . $value->{name}} = $self->{statefile}->get(name => $self->{instance} . '_' . $value->{name});
              if (!defined($old_datas->{$self->{instance} . '_' . $value->{name}})) {
                  $quit = 1;
                  next;
              }
              if ($old_datas->{$self->{instance} . '_' . $value->{name}} > $options{new_datas}->{$self->{instance} . '_' . $value->{name}}) {
                  $old_datas->{$self->{instance} . '_' . $value->{name}} = 0;
              }
          } else {
              $options{new_datas}->{$self->{instance} . '_' . $value->{name}} = $options{values}->{$value->{name}};
              if (defined($self->{statefile})) {
                  $old_datas->{$self->{instance} . '_' . $value->{name}} = $self->{statefile}->get(name => $self->{instance} . '_' . $value->{name});
              }
          }
      }
      
      # Very manual
      if ($self->{manual_keys} == 1) {
          foreach my $name (keys %{$options{values}}) {
              $options{new_datas}->{$self->{instance} . '_' . $name} = $options{values}->{$name};
              if (defined($self->{statefile})) {
                  $old_datas->{$self->{instance} . '_' . $name} = $self->{statefile}->get(name => $self->{instance} . '_' . $name);
              }
          }
      }
  
      if ($quit == 2) {
          $self->{error_msg} = "skipped (no value(s))";
          return -10;
      }
      
      if ($quit == 1) {
          $self->{error_msg} = "Buffer creation";
          return -1;
      }
      
      if (defined($self->{per_second}) && $self->{per_second} == 1) {
          if (!defined($self->{last_timestamp})) {
              $self->{last_timestamp} = $self->{statefile}->get(name => 'last_timestamp');
          }
          if (!defined($self->{last_timestamp})) {
              $self->{error_msg} = "Buffer creation";
              return -1;
          }
      }
     
      my $delta_time;
      if (defined($self->{per_second}) && $self->{per_second} == 1) {
          $delta_time = $options{new_datas}->{last_timestamp} - $self->{last_timestamp};
          if ($delta_time <= 0) {
              $delta_time = 1;
          }
      }
  
      if (defined($self->{closure_custom_calc})) {
          return $self->{closure_custom_calc}->($self, old_datas => $old_datas, new_datas => $options{new_datas}, delta_time => $delta_time, extra_options => $self->{closure_custom_calc_extra_options});
      }
      return $self->calc(old_datas => $old_datas, new_datas => $options{new_datas}, delta_time => $delta_time);
  }
  
  1;
  
  
CENTREON_PLUGINS_VALUES

$fatpacked{"database/oracle/dbi.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_DBI';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::dbi;
  
  use base qw(centreon::plugins::dbi);
  
  use strict;
  use warnings;
  use POSIX qw(:signal_h);
  
  sub connect_oracle {
      my ($self, %options) = @_;
      
      $self->{instance} = DBI->connect(
          'DBI:' . $self->{data_source},
          $self->{username},
          $self->{password},
          { RaiseError => 0, PrintError => 0, AutoCommit => 1, %{$self->{connect_options_hash}} }
      );
  }
  
  sub connect {
      my ($self, %options) = @_;
      my $dontquit = (defined($options{dontquit}) && $options{dontquit} == 1) ? 1 : 0;
  
      # Set ENV
      if (defined($self->{env})) {
          foreach (keys %{$self->{env}}) {
              $ENV{$_} = $self->{env}->{$_};
          }
      }
  
      if (defined($self->{timeout})) {
          my $mask = POSIX::SigSet->new(SIGALRM);
          my $action = POSIX::SigAction->new(
              sub { $self->handle_ALRM() },
              $mask,
          );
          my $oldaction = POSIX::SigAction->new();
          sigaction(SIGALRM, $action, $oldaction);
          eval {
              eval {
                  alarm($self->{timeout});
                  $self->connect_oracle();
              };
              alarm(0);
          };
          sigaction(SIGALRM, $oldaction);
      } else {
          $self->connect_oracle();
      }
  
      if (!defined($self->{instance})) {
          my $err_msg = sprintf('Cannot connect: %s', defined($DBI::errstr) ? $DBI::errstr : '(no error string)');
          if ($dontquit == 0) {
              $self->{output}->add_option_msg(short_msg => $err_msg);
              $self->{output}->option_exit(exit_litteral => $self->{sql_errors_exit});
          }
          return (-1, $err_msg);
      }
      
      $self->set_version();
      return 0;
  }
  
  1;
  
DATABASE_ORACLE_DBI

$fatpacked{"database/oracle/mode/asmdiskgroupusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_ASMDISKGROUPUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::asmdiskgroupusage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use centreon::plugins::templates::catalog_functions qw(catalog_status_threshold);
  
  sub custom_offline_output {
      my ($self, %options) = @_;
      my $msg = 'Offline disks : ' . $self->{result_values}->{offline_disks};
      
      return $msg;
  }
  
  sub custom_offline_calc {
      my ($self, %options) = @_;
      
      $self->{result_values}->{offline_disks} = $options{new_datas}->{$self->{instance} . '_offline_disks'};
      $self->{result_values}->{type} = $options{new_datas}->{$self->{instance} . '_type'};
      $self->{result_values}->{display} = $options{new_datas}->{$self->{instance} . '_display'};
      return 0;
  }
  
  sub custom_status_output {
      my ($self, %options) = @_;
  
      my $msg = 'status: ' . $self->{result_values}->{status};
      return $msg;
  }
  
  sub custom_status_threshold {
      my ($self, %options) = @_;
  
      my $status = catalog_status_threshold($self, %options);
      $self->{instance_mode}->{last_status} = 0;
      if (!$self->{output}->is_status(value => $status, compare => 'ok', litteral => 1)) {
          $self->{instance_mode}->{last_status} = 1;
      }
      return $status;
  }
  
  sub custom_status_calc {
      my ($self, %options) = @_;
      
      $self->{result_values}->{status} = $options{new_datas}->{$self->{instance} . '_status'};
      return 0;
  }
  
  sub custom_usage_perfdata {
      my ($self, %options) = @_;
      
      my $label = 'used';
      my $value_perf = $self->{result_values}->{used};
      if ($self->{result_values}->{total} > 0 && defined($self->{instance_mode}->{option_results}->{free})) {
          $label = 'free';
          $value_perf = $self->{result_values}->{free};
      }
      
      $label .= '_' . $self->{result_values}->{label_ref}
          if (defined($self->{result_values}->{label_ref}));
  
      my %total_options = ();
      if ($self->{result_values}->{total} > 0 && $self->{instance_mode}->{option_results}->{units} eq '%') {
          $total_options{total} = $self->{result_values}->{total};
          $total_options{cast_int} = 1;
      }
  
      $self->{output}->perfdata_add(
          label => $label, unit => 'B',
          instances => $self->use_instances(extra_instance => $options{extra_instance}) ? $self->{result_values}->{display} : undef,
          value => $value_perf,
          warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning-' . $self->{thlabel}, %total_options),
          critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical-' . $self->{thlabel}, %total_options),
          min => 0, max => $self->{result_values}->{total}
      );
  }
  
  sub custom_usage_threshold {
      my ($self, %options) = @_;
      
      # cannot use '%' or free option with unlimited system 
      return 'ok' if ($self->{result_values}->{total} <= 0 && ($self->{instance_mode}->{option_results}->{units} eq '%' || $self->{instance_mode}->{option_results}->{free}));
      my ($exit, $threshold_value);
      $threshold_value = $self->{result_values}->{used};
      $threshold_value = $self->{result_values}->{free} if (defined($self->{instance_mode}->{option_results}->{free}));
      if ($self->{instance_mode}->{option_results}->{units} eq '%') {
          $threshold_value = $self->{result_values}->{prct_used};
          $threshold_value = $self->{result_values}->{prct_free} if (defined($self->{instance_mode}->{option_results}->{free}));
      }
      $exit = $self->{perfdata}->threshold_check(value => $threshold_value, threshold => [ { label => 'critical-' . $self->{thlabel}, exit_litteral => 'critical' }, { label => 'warning-'. $self->{thlabel}, exit_litteral => 'warning' } ]);
      return $exit;
  }
  
  sub custom_usage_output {
      my ($self, %options) = @_;
  
      my $label = 'Disk ';
      if (defined($self->{result_values}->{label_ref})) {
          $label = 'Disk Failure';
      }
  
      my ($total_used_value, $total_used_unit) = $self->{perfdata}->change_bytes(value => $self->{result_values}->{used});    
      my $msg;
      if ($self->{result_values}->{total} <= 0) {
          $msg = sprintf("%s Used: %s (unlimited)", $label, $total_used_value . " " . $total_used_unit);
      } else {
          my ($total_size_value, $total_size_unit) = $self->{perfdata}->change_bytes(value => $self->{result_values}->{total});
          my ($total_free_value, $total_free_unit) = $self->{perfdata}->change_bytes(value => $self->{result_values}->{free});
          $msg = sprintf("%s Total: %s Used: %s (%.2f%%) Free: %s (%.2f%%)",
                     $label,
                     $total_size_value . " " . $total_size_unit,
                     $total_used_value . " " . $total_used_unit, $self->{result_values}->{prct_used},
                     $total_free_value . " " . $total_free_unit, $self->{result_values}->{prct_free});
      }
  
      return $msg;
  }
  
  sub custom_usage_calc {
      my ($self, %options) = @_;
  
      return -10 if (defined($self->{instance_mode}->{last_status}) && $self->{instance_mode}->{last_status} == 0);
      
      my $label_used = 'used';
      $label_used .= '_' . $options{extra_options}->{label_ref}
          if (defined($options{extra_options}->{label_ref}));
  
      $self->{result_values}->{label_ref} = defined($options{extra_options}->{label_ref}) ? $options{extra_options}->{label_ref} : undef;
      $self->{result_values}->{display} = $options{new_datas}->{$self->{instance} . '_display'};
      $self->{result_values}->{total} = $options{new_datas}->{$self->{instance} . '_total'};
      $self->{result_values}->{used} = $options{new_datas}->{$self->{instance} . '_' . $label_used};
      
      return 0 if ($self->{result_values}->{total} == 0);
      $self->{result_values}->{prct_used} = $self->{result_values}->{used} * 100 / $self->{result_values}->{total};
      $self->{result_values}->{prct_free} = 100 - $self->{result_values}->{prct_used};
      $self->{result_values}->{free} = $self->{result_values}->{total} - $self->{result_values}->{used};
      
      return 0;
  }
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'dg', type => 1, cb_prefix_output => 'prefix_dg_output', message_multiple => 'All diskgroups are ok', skipped_code => { -10 => 1 } },
      ];
  
      $self->{maps_counters}->{dg} = [
          { label => 'status', threshold => 0, set => {
                  key_values => [ { name => 'status' } ],
                  closure_custom_calc => $self->can('custom_status_calc'),
                  closure_custom_output => $self->can('custom_status_output'),
                  closure_custom_perfdata => sub { return 0; },
                  closure_custom_threshold_check => $self->can('custom_status_output'),
              }
          },
          { label => 'offline-disks', set => {
                  key_values => [ { name => 'offline_disks' }, { name => 'type' }, { name => 'display' } ],
                  closure_custom_calc => $self->can('custom_offline_calc'),
                  closure_custom_output =>  $self->can('custom_offline_output'),
                  closure_custom_perfdata => sub { return 0; },
                  closure_custom_threshold_check => \&catalog_status_threshold,
              }
          },
          { label => 'usage', set => {
                  key_values => [ { name => 'used' }, { name => 'total' }, { name => 'display' } ],
                  closure_custom_calc => $self->can('custom_usage_calc'),
                  closure_custom_output => $self->can('custom_usage_output'),
                  closure_custom_perfdata => $self->can('custom_usage_perfdata'),
                  closure_custom_threshold_check => $self->can('custom_usage_threshold'),
              }
          },
          { label => 'usage-failure', set => {
                  key_values => [ { name => 'used_failure' }, { name => 'total' }, { name => 'display' } ],
                  closure_custom_calc => $self->can('custom_usage_calc'), closure_custom_calc_extra_options => { label_ref => 'failure' },
                  closure_custom_output => $self->can('custom_usage_output'),
                  closure_custom_perfdata => $self->can('custom_usage_perfdata'),
                  closure_custom_threshold_check => $self->can('custom_usage_threshold'),
              }
          },
      ];
  }
  
  sub prefix_dg_output {
      my ($self, %options) = @_;
  
      return "Diskgroup '" . $options{instance_value}->{display} . "' ";
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => {
          "unknown-status:s"          => { name => 'unknown_status', default => '' },
          "warning-status:s"          => { name => 'warning_status', default => '' },
          "critical-status:s"         => { name => 'critical_status', default => '' },
          "warning-offline-disks:s"   => { name => 'warning_offline_disks', default => '(%{offline_disks} > 0 && %{type} eq "extern") || (%{offline_disks} > 1 && %{type} eq "high")' },
          "critical-offline-disks:s"  => { name => 'critical_offline_disks', default => '%{offline_disks} > 0 && %{type} =~ /^normal|high$/' },
          "filter-name:s"             => { name => 'filter_name', },
          "units:s"                   => { name => 'units', default => '%' },
          "free"                      => { name => 'free' },
      });
   
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::check_options(%options);
  
      $self->change_macros(macros => [
          'warning_offline_disks', 'critical_offline_disks',
          'warning_status', 'critical_status', 'unknown_status',
      ]);
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
  
      $options{sql}->connect();
      my $query = q{SELECT name, state, type, total_mb, usable_file_mb, offline_disks, FREE_MB FROM V$ASM_DISKGROUP};
      $options{sql}->query(query => $query);
      my $result = $options{sql}->fetchall_arrayref();
      $options{sql}->disconnect();
      
      $self->{dg} = {};
      foreach my $row (@$result) {
          my ($name, $state, $type, $total_mb, $usable_file_mb, $offline_disks, $free_mb) = @$row;
          
          if (defined($self->{option_results}->{filter_name}) && $self->{option_results}->{filter_name} ne '' &&
              $name !~ /$self->{option_results}->{filter_name}/) {
              $self->{output}->output_add(long_msg => "skipping  '" . $name . "': no matching filter name.", debug => 1);
              next;
          }
  
          my $used_failure = ($total_mb * 1024 * 1024) - ($usable_file_mb * 1024 * 1024);
          if ($usable_file_mb < 0) {
              $used_failure = ($total_mb * 1024 * 1024);
          }
          $self->{dg}->{$name} = { 
              display => $name, 
              total => $total_mb * 1024 * 1024,
              used => ($total_mb * 1024 * 1024) - ($free_mb * 1024 * 1024),
              used_failure => $used_failure,
              status => $state, 
              type => lc($type), 
              offline_disks => $offline_disks
          };                        
      }
      
      if (scalar(keys %{$self->{dg}}) <= 0) {
          $self->{output}->add_option_msg(short_msg => "No diskgroup found.");
          $self->{output}->option_exit();
      }
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle ASM diskgroup usage and status.
  
  =over 8
  
  =item B<--warning-usage>
  
  Threshold warning.
  
  =item B<--critical-usage>
  
  Threshold critical.
  
  =item B<--warning-usage-failure>
  
  Threshold warning.
  
  =item B<--critical-usage-failure>
  
  Threshold critical.
  
  =item B<--unknown-status>
  
  Set warning threshold for status (Default: '').
  Can used special variables like: %{status}, %{display}
  
  =item B<--warning-status>
  
  Set warning threshold for status (Default: '').
  Can used special variables like: %{status}, %{display}
  
  =item B<--critical-status>
  
  Set critical threshold for status (Default: '').
  Can used special variables like: %{status}, %{display}
  
  =item B<--warning-offline-disks>
  
  Set warning threshold for offline disks (Default: '(%{offline_disks} > 0 && %{type} eq "extern") || (%{offline_disks} > 1 && %{type} eq "high")').
  Can used special variables like: %{offline_disks}, %{type}, %{display}
  
  =item B<--critical-offline-disks>
  
  Set critical threshold for offline disks (Default: '%{offline_disks} > 0 && %{type} =~ /^normal|high$/').
  Can used special variables like: %{offline_disks}, %{type}, %{display}
  
  =item B<--units>
  
  Units of thresholds (Default: '%') ('%', 'B').
  
  =item B<--free>
  
  Thresholds are on free space left.
  
  =item B<--filter-name>
  
  Filter by name (regexp can be used).
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_ASMDISKGROUPUSAGE

$fatpacked{"database/oracle/mode/connectedusers.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_CONNECTEDUSERS';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::connectedusers;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "warning:s"               => { name => 'warning', },
          "critical:s"              => { name => 'critical', },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
          $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      $self->{sql}->connect();
      $self->{sql}->query(query => q{SELECT COUNT(*) FROM v$session WHERE type = 'USER'});
      my $users = $self->{sql}->fetchrow_array();
      $self->{sql}->disconnect();
  
      my $exit_code = $self->{perfdata}->threshold_check(value => $users, threshold => [ { label => 'critical', 'exit_litteral' => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
      $self->{output}->output_add(severity => $exit_code,
                                    short_msg => sprintf("%i Connected user(s).", $users));
      $self->{output}->perfdata_add(label => 'connected_users',
                                    value => $users,
                                    warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning'),
                                    critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical'),
                                    min => 0);
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle connected users.
  
  =over 8
  
  =item B<--warning>
  
  Threshold warning.
  
  =item B<--critical>
  
  Threshold critical.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_CONNECTEDUSERS

$fatpacked{"database/oracle/mode/corruptedblocks.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_CORRUPTEDBLOCKS';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::corruptedblocks;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "warning:s"               => { name => 'warning', },
          "critical:s"              => { name => 'critical', },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
          $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      $self->{sql}->connect();
      $self->{sql}->query(query => q{SELECT COUNT(*) FROM v$database_block_corruption});
      my $corrupted_blocks = $self->{sql}->fetchrow_array();
      $self->{sql}->disconnect();
  
      my $exit_code = $self->{perfdata}->threshold_check(value => $corrupted_blocks, threshold => [ { label => 'critical', 'exit_litteral' => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
      $self->{output}->output_add(severity => $exit_code,
                                    short_msg => sprintf("%i corrupted blocks.", $corrupted_blocks));
      $self->{output}->perfdata_add(label => 'corrupted_blocks',
                                    value => $corrupted_blocks,
                                    warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning'),
                                    critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical'),
                                    min => 0);
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle corrupted blocks.
  
  =over 8
  
  =item B<--warning>
  
  Threshold warning.
  
  =item B<--critical>
  
  Threshold critical.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_CORRUPTEDBLOCKS

$fatpacked{"database/oracle/mode/datacachehitratio.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_DATACACHEHITRATIO';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::datacachehitratio;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub custom_hitratio_calc {
      my ($self, %options) = @_;
  
      my $delta_phys = ($options{new_datas}->{$self->{instance} . '_physical_reads'} - $options{old_datas}->{$self->{instance} . '_physical_reads'});
      my $delta_cache = 
          ($options{new_datas}->{$self->{instance} . '_db_block_gets'} - $options{old_datas}->{$self->{instance} . '_db_block_gets'}) +
          ($options{new_datas}->{$self->{instance} . '_consistent_gets'} - $options{old_datas}->{$self->{instance} . '_consistent_gets'});
      $self->{result_values}->{hit_ratio} = ($delta_cache == 0) ? 0 : 
          ((1 - ($delta_phys / $delta_cache)) * 100);
  
      return 0;
  }
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'global', type => 0 },
      ];
  
      $self->{maps_counters}->{global} = [
          { label => 'usage', set => {
                  key_values => [ { name => 'physical_reads', diff => 1 }, { name => 'db_block_gets', diff => 1 },
                      { name => 'consistent_gets', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_hitratio_calc'),
                  output_template => 'Buffer cache hit ratio is %.2f%%',  output_error_template => 'Buffer cache hit ratio: %s', 
                  output_use => 'hit_ratio', threshold_use => 'hit_ratio',
                  perfdatas => [
                      { label => 'sga_data_buffer_hit_ratio', value => 'hit_ratio', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
      ];
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, statefile => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
      });
      
      return $self;
  }
  
  sub manage_selection {
      my ($self, %options) = @_;    
  
      my $query = q{
          SELECT SUM(DECODE(name, 'physical reads', value, 0)),
              SUM(DECODE(name, 'db block gets', value, 0)),
              SUM(DECODE(name, 'consistent gets', value, 0))
          FROM sys.v_$sysstat
      };
  
      $options{sql}->connect();
      $options{sql}->query(query => $query);
      my @result = $options{sql}->fetchrow_array();
      $options{sql}->disconnect();
      
      $self->{global} = {
          physical_reads => $result[0], 
          db_block_gets => $result[1],
          consistent_gets => $result[2],
      };
  
      $self->{cache_name} = "oracle_" . $self->{mode} . '_' . $options{sql}->get_unique_id4save() . '_' .
          (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all'));
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle buffer cache hit ratio.
  
  =over 8
  
  =item B<--warning-usage>
  
  Threshold warning.
  
  =item B<--critical-usage>
  
  Threshold critical.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_DATACACHEHITRATIO

$fatpacked{"database/oracle/mode/datafilesstatus.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_DATAFILESSTATUS';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::datafilesstatus;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use centreon::plugins::templates::catalog_functions qw(catalog_status_threshold);
  use Digest::MD5 qw(md5_hex);
  
  sub custom_traffic_calc {
      my ($self, %options) = @_;
  
      my $total_traffic = -1;
      foreach (keys %{$options{new_datas}}) {
          if (/^(.*)_(phyrds|phywrts)$/) {
              my $new_total = $options{new_datas}->{$_};
              next if (!defined($options{old_datas}->{$_}));
              $total_traffic = 0 if ($total_traffic == -1);
  
              my $old_total = $options{old_datas}->{$_};
              if ($old_total > $new_total) {
                  $options{old_datas}->{$_} = 0;
                  $old_total = 0;
              }
  
              my $diff_total = $new_total - $old_total;
              $total_traffic += $diff_total;
          }
      }
  
      if ($total_traffic == -1) {
          $self->{error_msg} = "Buffer creation";
          return -1;
      }
  
      $self->{result_values}->{traffic} = $total_traffic  / $options{delta_time};
      return 0;
  }
  
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'global', type => 0 },
          { name => 'df', type => 1, cb_prefix_output => 'prefix_df_output', message_multiple => 'All data files are ok', skipped_code => { -10 => 1 } },
      ];
  
      $self->{maps_counters}->{global} = [
          { label => 'total-traffic', nlabel => 'datafiles.traffic.io.usage.iops', set => {
                  key_values => [],
                  closure_custom_calc => $self->can('custom_traffic_calc'),
                  per_second => 1, manual_keys => 1,
                  threshold_use => 'traffic', output_use => 'traffic',
                  output_template => 'Total Traffic IOPs %.2f',
                  perfdatas => [
                      { label => 'total_traffic', value => 'traffic', template => '%.2f', min => 0 , unit => 'iops' },
                  ],
              }
          },
      ];
  
      $self->{maps_counters}->{df} = [
          { label => 'status', threshold => 0, set => {
                  key_values => [ { name => 'status' }, { name => 'display' } ],
                  closure_custom_calc => $self->can('custom_status_calc'),
                  closure_custom_output => $self->can('custom_status_output'),
                  closure_custom_perfdata => sub { return 0; },
                  closure_custom_threshold_check => \&catalog_status_threshold,
              }
          },
          { label => 'online-status', threshold => 0, set => {
                  key_values => [ { name => 'online_status' }, { name => 'display' } ],
                  closure_custom_calc => $self->can('custom_online_status_calc'),
                  closure_custom_output => $self->can('custom_status_output'),
                  closure_custom_perfdata => sub { return 0; },
                  closure_custom_threshold_check => \&catalog_status_threshold,
              }
          },
      ];
  }
  
  sub custom_status_output {
      my ($self, %options) = @_;
      my $msg = $self->{result_values}->{label_display} . ' : ' . $self->{result_values}->{$self->{result_values}->{label_th}};
  
      return $msg;
  }
  
  sub custom_status_calc {
      my ($self, %options) = @_;
      
      $self->{result_values}->{label_display} = 'Status';
      $self->{result_values}->{label_th} = 'status';
      $self->{result_values}->{status} = $options{new_datas}->{$self->{instance} . '_status'};
      $self->{result_values}->{display} = $options{new_datas}->{$self->{instance} . '_display'};
      return 0;
  }
  
  sub custom_online_status_calc {
      my ($self, %options) = @_;
      
      $self->{result_values}->{label_display} = 'Online Status';
      $self->{result_values}->{label_th} = 'online_status';
      $self->{result_values}->{online_status} = $options{new_datas}->{$self->{instance} . '_online_status'};
      $self->{result_values}->{display} = $options{new_datas}->{$self->{instance} . '_display'};
      return 0;
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, statefile => 1, force_new_perfdata => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "filter-tablespace:s"       => { name => 'filter_tablespace' },
          "filter-data-file:s"        => { name => 'filter_data_file' },
          "warning-status:s"          => { name => 'warning_status', default => '' },
          "critical-status:s"         => { name => 'critical_status', default => '' },
          "warning-online-status:s"   => { name => 'warning_online_status', default => '%{online_status} =~ /sysoff/i' },
          "critical-online-status:s"  => { name => 'critical_online_status', default => '%{online_status} =~ /offline|recover/i' },
      });
      
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::check_options(%options);
  
      $self->change_macros(macros => ['warning_status', 'critical_status', 'warning_online_status', 'critical_online_status']);
  }
  
  sub prefix_df_output {
      my ($self, %options) = @_;
  
      return "Data file '" . $options{instance_value}->{display} . "' ";
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      
      $options{sql}->connect();
      
      if ($options{sql}->is_version_minimum(version => '10')) {
          $options{sql}->query(query => q{
              SELECT a.file_name, a.tablespace_name, a.status, b.phyrds, b.phywrts, a.online_status
                  FROM dba_data_files a, v$filestat b
                  WHERE a.file_id = b.file#
              UNION
              SELECT a.name, c.name, a.status, b.phyrds, b.phywrts, NULL
                  FROM v$tempfile a, v$tablespace c, v$tempstat b
                  WHERE a.ts#= c.ts# AND a.file# = b.file#
          });
      } else {
          $options{sql}->query(query => q{
              SELECT a.file_name, a.tablespace_name, a.status, b.phyrds, b.phywrts
                  FROM dba_data_files a, v$filestat b
                  WHERE a.file_id = b.file#
              UNION
              SELECT a.name, c.name, a.status, b.phyrds, b.phywrts
                  FROM v$tempfile a, v$tablespace c, v$tempstat b
                  WHERE a.ts#= c.ts# AND a.file# = b.file#
           });
      }
      my $result = $options{sql}->fetchall_arrayref();
      $options{sql}->disconnect();
  
      $self->{global} = {};
      $self->{df} = {};
      foreach my $row (@$result) {
          if (defined($self->{option_results}->{filter_data_file}) && $self->{option_results}->{filter_data_file} ne '' &&
              $$row[0] !~ /$self->{option_results}->{filter_data_file}/) {
              $self->{output}->output_add(long_msg => "skipping  '" . $$row[0] . "': no matching filter.", debug => 1);
              next;
          }
          if (defined($self->{option_results}->{filter_tablespace}) && $self->{option_results}->{filter_tablespace} ne '' &&
              $$row[1] !~ /$self->{option_results}->{filter_tablespace}/) {
              $self->{output}->output_add(long_msg => "skipping  '" . $$row[1] . "': no matching filter.", debug => 1);
              next
          }
          
          my $name = $$row[1] . '/' . $$row[0];
          $self->{df}->{$name} = { 
              status => $$row[2], 
              online_status => defined($$row[5]) ? $$row[5] : undef, 
              display => $name
          };
          $self->{global}->{$name . '_phyrds'} = $$row[3];
          $self->{global}->{$name . '_phywrts'} = $$row[4];
      }
  
      if (scalar(keys %{$self->{df}}) <= 0) {
          $self->{output}->add_option_msg(short_msg => "No data file found");
          $self->{output}->option_exit();
      }
  
      $self->{cache_name} = "oracle_" . $self->{mode} . '_' . $options{sql}->get_unique_id4save() . '_' .
          (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all')) . '_' .
          (defined($self->{option_results}->{filter_tablespace}) ? md5_hex($self->{option_results}->{filter_tablespace}) : md5_hex('all')) . '_' .
          (defined($self->{option_results}->{filter_data_file}) ? md5_hex($self->{option_results}->{filter_data_file}) : md5_hex('all'));
  }
  
  1;
  
  
  =head1 MODE
  
  Check data files status.
  
  =over 8
  
  =item B<--filter-counters>
  
  Only display some counters (regexp can be used).
  
  =item B<--filter-tablespace>
  
  Filter tablespace name (can be a regexp).
  
  =item B<--filter-data-file>
  
  Filter data file name (can be a regexp).
  
  =item B<--warning-status>
  
  Set warning threshold for status (Default: none).
  Can used special variables like: %{display}, %{status}
  
  =item B<--critical-status>
  
  Set critical threshold for status (Default: none).
  Can used special variables like: %{display}, %{status}
  
  =item B<--warning-online-status>
  
  Set warning threshold for online status (Default: '%{online_status} =~ /sysoff/i').
  Can used special variables like: %{display}, %{online_status}
  
  =item B<--critical-online-status>
  
  Set critical threshold for online status (Default: '%{online_status} =~ /offline|recover/i').
  Can used special variables like: %{display}, %{online_status}
  
  =item B<--warning-*> B<--critical-*> 
  
  Thresholds.
  Can be: 'total-traffic'.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_DATAFILESSTATUS

$fatpacked{"database/oracle/mode/dictionarycacheusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_DICTIONARYCACHEUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::dictionarycacheusage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub custom_hitratio_calc {
      my ($self, %options) = @_;
  
      my $delta_total = ($options{new_datas}->{$self->{instance} . '_gets'} - $options{old_datas}->{$self->{instance} . '_gets'});
      my $delta_cache = ($options{new_datas}->{$self->{instance} . '_getmisses'} - $options{old_datas}->{$self->{instance} . '_getmisses'});
      $self->{result_values}->{hit_ratio} = $delta_total ? (100 * $delta_cache / $delta_total) : 0;
  
      return 0;
  }
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'global', cb_prefix_output => 'prefix_global_output', type => 0 },
      ];
  
      $self->{maps_counters}->{global} = [
          { label => 'get-hits', nlabel => 'dictionary.cache.get.hitratio.percentage', set => {
                  key_values => [ { name => 'getmisses', diff => 1 }, { name => 'gets', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_hitratio_calc'),
                  output_template => 'get hit ratio %.2f%%',
                  output_use => 'hit_ratio', threshold_use => 'hit_ratio',
                  perfdatas => [
                      { label => 'get_hit_ratio', value => 'hit_ratio', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
      ];
  }
  
  sub prefix_global_output {
      my ($self, %options) = @_;
  
      return 'SGA dictionary cache ';
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, statefile => 1, force_new_perfdata => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
      });
      
      return $self;
  }
  
  sub manage_selection {
      my ($self, %options) = @_;    
  
      my $query = q{
          SELECT SUM(gets), SUM(gets-getmisses) FROM v$rowcache
      };
  
      $options{sql}->connect();
      $options{sql}->query(query => $query);
      my @result = $options{sql}->fetchrow_array();
      $options{sql}->disconnect();
      
      $self->{global} = {
          gets => $result[0],
          getmisses => $result[1],
      };
  
      $self->{cache_name} = "oracle_" . $self->{mode} . '_' . $options{sql}->get_unique_id4save() . '_' .
          (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all'));
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle dictionary cache usage.
  
  =over 8
  
  =item B<--warning-*> B<--critical-*> 
  
  Thresholds.
  Can be: 'get-hits'.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_DICTIONARYCACHEUSAGE

$fatpacked{"database/oracle/mode/eventwaitsusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_EVENTWAITSUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::eventwaitsusage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'event_count', type => 0 },
          { name => 'event', type => 1, cb_prefix_output => 'prefix_event_output', message_multiple => 'All event waits are OK', skipped_code => { -11 => 1, -10 => 1 } },
      ];
  
  
      $self->{maps_counters}->{event_count} = [
          { label => 'event-count', set => {
                  key_values => [ { name => 'count' } ],
                  output_template => 'Event Wait Count : %s events',
                  perfdatas => [
                      { label => 'event_wait_count', value => 'count_absolute', template => '%s', min => 0 }
                  ],
              }
          },
      ];
      $self->{maps_counters}->{event} = [
          { label => 'total-waits-sec', set => {
                  key_values => [ { name => 'total_waits', diff => 1 }, { name => 'display' } ],
                  per_second => 1,
                  output_template => 'Total Waits : %.2f/s',
                  perfdatas => [
                      { label => 'total_waits', value => 'total_waits_per_second', template => '%.2f',
                        unit => '/s', min => 0, label_extra_instance => 1, instance_use => 'display_absolute' },
                  ],
              }
          },
          { label => 'total-waits-time', set => {
                  key_values => [ { name => 'time_waited_micro', diff => 1 }, { name => 'display' } ],
                  per_second => 1,
                  closure_custom_calc => $self->can('custom_usage_calc'),
                  output_template => 'Total Waits Time : %.2f %%', output_use => 'prct_wait', threshold_use => 'prct_wait',
                  perfdatas => [
                      { label => 'total_waits_time', value => 'prct_wait', template => '%.2f', min => 0, max => 100, unit => '%',
                        label_extra_instance => 1, instance_use => 'display' },
                  ],
              }
          },
     ],
  }
  
  sub custom_usage_calc {
      my ($self, %options) = @_;
  
      $self->{result_values}->{display} = $options{new_datas}->{$self->{instance} . '_display'};
      my $delta_total = $options{new_datas}->{$self->{instance} . '_time_waited_micro'} - $options{old_datas}->{$self->{instance} . '_time_waited_micro'};
      $self->{result_values}->{prct_wait} = 100 * ($delta_total / 1000000) / $options{delta_time};
  
      return 0;
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, statefile => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "filter-name:s"     => { name => 'filter_name' },
          "wait-time-min:s"   => { name => 'wait_time_min', default => 1000 },
          "show-details"      => { name => 'show_details' }
      });
  
      return $self;
  }
  
  sub prefix_event_output {
      my ($self, %options) = @_;
  
      return "Event '" . $options{instance_value}->{display} . "' ";
  }
  
  sub event_count_and_details {
      my ($self, %options) = @_;
  
      my $query_count = "SELECT count(*) as NB
          FROM v\$session
          WHERE  WAIT_TIME_MICRO>" . $self->{option_results}->{wait_time_min} . "
          AND status='ACTIVE' and WAIT_CLASS <>'Idle'";
  
      $self->{sql}->query(query => $query_count);
      my $result = $self->{sql}->fetchrow_hashref();
  
      $self->{event_count}->{count} = $result->{NB};
  
      if (defined($self->{option_results}->{show_details})) {
          my $query_details = "SELECT
                                   a.username USERNAME,
                                   a.program PROGRAM,
                                   a.event EVENT,
                                   round(a.WAIT_TIME_MICRO/1000000,0) SEC_WAIT,
                                   d.sql_text SQL_TEXT
                               FROM
                                   v\$session a,
                                   v\$sqlstats d
                               WHERE
                                   a.sql_id = d.sql_id
                                   and a.status='ACTIVE'
                                   and a.wait_class <> 'Idle'
                                   and WAIT_TIME_MICRO>" . $self->{option_results}->{wait_time_min} . "
                                   and a.sid not in (SELECT SID FROM V\$SESSION WHERE audsid = userenv('SESSIONID'))
                               ORDER BY
                                  a.WAIT_TIME_MICRO desc";
                                  
          $self->{sql}->query(query => $query_details );
          while (my $result = $self->{sql}->fetchrow_hashref()) {
              $self->{output}->output_add(long_msg => sprintf("Username: '%s', Program: '%s' Event: '%s', Second wait: '%s's, Details: '%s'\n",
                                                           $result->{USERNAME}, $result->{PROGRAM}, $result->{EVENT}, $result->{SEC_WAIT}, $result->{SQL_TEXT}));
          }
      }
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
      $self->{sql}->connect();
  
      my $query = q{
          SELECT e.event#, e.name,
                  NVL(s.total_waits, 0), NVL(s.total_timeouts, 0), NVL(s.time_waited, 0),
                  NVL(s.time_waited_micro, 0), NVL(s.average_wait, 0)
            FROM v$event_name e LEFT JOIN sys.v_$system_event s ON e.name = s.event
          };
      if ($self->{sql}->is_version_minimum(version => '10')) {
          $query = q{
              SELECT e.event_id, e.name,
                  NVL(s.total_waits, 0), NVL(s.total_timeouts, 0), NVL(s.time_waited, 0),
                  NVL(s.time_waited_micro, 0), NVL(s.average_wait, 0)
              FROM v$event_name e LEFT JOIN sys.v_$system_event s ON e.name = s.event
          };
      }
  
      $self->{sql}->query(query => $query);
      my $result = $self->{sql}->fetchall_arrayref();
  
      $self->{event} = {};
      foreach my $row (@$result) {
          my ($name, $total_waits, $time_waited_micro) = ($row->[1], $row->[2], $row->[5]);
  
          if (defined($self->{option_results}->{filter_name}) && $self->{option_results}->{filter_name} ne '' &&
              $name !~ /$self->{option_results}->{filter_name}/) {
              $self->{output}->output_add(long_msg => "skipping  '" . $name . "': no matching filter.", debug => 1);
              next;
          }
  
          $self->{event}->{$name} = {
              display => $name,
              total_waits => $total_waits,
              time_waited_micro => $time_waited_micro
          };
      }
  
      if ($self->{sql}->is_version_minimum(version => '10')) {
          $self->event_count_and_details();
      }
  
      $self->{sql}->disconnect();
  
      if (scalar(keys %{$self->{event}}) <= 0) {
          $self->{output}->add_option_msg(short_msg => "No event found.");
          $self->{output}->option_exit();
      }
  
      $self->{cache_name} = "oracle_" . $self->{mode} . '_' . $self->{sql}->get_unique_id4save() . '_' .
          (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all')) . '_' .
          (defined($self->{option_results}->{filter_name}) ? md5_hex($self->{option_results}->{filter_name}) : md5_hex('all'));
  
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle event wait usage.
  
  =over 8
  
  =item B<--warning-*>
  
  Threshold warning.
  Can be: 'total-waits-sec', 'total-waits-time', 'event-count'.
  
  =item B<--critical-*>
  
  Threshold critical.
  Can be: 'total-waits-sec', 'total-waits-time', 'event-count'.
  
  =item B<--filter-name>
  
  Filter by event name. Can be a regex.
  
  =item B<--wait-time-min>
  
  Time in ms above which we count an event as waiting
  
  =item B<--show-details>
  
  Print details of waiting events (user, query, ...) in long output
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_EVENTWAITSUSAGE

$fatpacked{"database/oracle/mode/frausage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_FRAUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::frausage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'file', type => 1, cb_prefix_output => 'prefix_file_output', message_multiple => 'All recovery areas are ok', skipped_code => { -10 => 1 } },
      ];
  
      $self->{maps_counters}->{file} = [
          { label => 'space-usage', nlabel => 'recoveryarea.space.usage.percentage', set => {
                  key_values => [ { name => 'percent_space_usage' }, { name => 'display' } ],
                  output_template => 'used : %.2f %%',
                  perfdatas => [
                      { value => 'percent_space_usage_absolute', template => '%.2f', min => 0, max => 100,
                        unit => '%', label_extra_instance => 1, instance_use => 'display_absolute' },
                  ],
              }
          },
          { label => 'space-reclaimable', nlabel => 'recoveryarea.space.reclaimable.percentage', set => {
                  key_values => [ { name => 'percent_space_reclaimable' }, { name => 'display' } ],
                  output_template => 'reclaimable : %.2f %%',
                  perfdatas => [
                      { value => 'percent_space_reclaimable_absolute', template => '%.2f', min => 0, max => 100,
                        unit => '%', label_extra_instance => 1, instance_use => 'display_absolute' },
                  ],
              }
          },
      ];
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, force_new_perfdata => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          'filter-type:s' => { name => 'filter_type' },
      });
      
      return $self;
  }
  
  sub prefix_file_output {
      my ($self, %options) = @_;
  
      return "File type '" . $options{instance_value}->{display} . "' recovery area ";
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      
      $options{sql}->connect();
      $options{sql}->query(query => q{
          SELECT file_type, percent_space_used, percent_space_reclaimable
              FROM v$recovery_area_usage
       });
      my $result = $options{sql}->fetchall_arrayref();
      $options{sql}->disconnect();
  
      $self->{file} = {};
      foreach my $row (@$result) {
          if (defined($self->{option_results}->{filter_type}) && $self->{option_results}->{filter_type} ne '' &&
              $$row[0] !~ /$self->{option_results}->{filter_type}/i) {
              $self->{output}->output_add(long_msg => "skipping  '" . $$row[0] . "': no matching filter.", debug => 1);
              next;
          }
          
          $self->{file}->{$$row[0]} = { 
              display => $$row[0],
              percent_space_usage => $$row[1],
              percent_space_reclaimable => $$row[2],
          };
      }
  
      if (scalar(keys %{$self->{file}}) <= 0) {
          $self->{output}->add_option_msg(short_msg => "No file type found");
          $self->{output}->option_exit();
      }
  }
  
  1;
  
  
  =head1 MODE
  
  Check fast recovery area space usage
  
  =over 8
  
  =item B<--filter-counters>
  
  Only display some counters (regexp can be used).
  
  =item B<--filter-type>
  
  Filter file type (can be a regexp).
  
  =item B<--warning-*> B<--critical-*> 
  
  Thresholds.
  Can be: 'space-usage', 'space-reclaimable'.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_FRAUSAGE

$fatpacked{"database/oracle/mode/invalidobject.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_INVALIDOBJECT';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::invalidobject;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  
  sub set_counters {
      my ($self, %options) = @_;
      
      $self->{maps_counters_type} = [
          { name => 'global', type => 0, cb_prefix_output => 'prefix_invalid_output', skipped_code => { -10 => 1 } },
      ];
      
      $self->{maps_counters}->{global} = [
          { label => 'objects', set => {
                  key_values => [ { name => 'invalid_objects' } ],
                  output_template => 'objects : %s',
                  perfdatas => [
                      { label => 'invalid_objects', value => 'invalid_objects_absolute', template => '%d', min => 0 },
                  ],
              }
          },
          { label => 'indexes', set => {
                  key_values => [ { name => 'invalid_indexes' } ],
                  output_template => 'indexes : %s',
                  perfdatas => [
                      { label => 'invalid_indexes', value => 'invalid_indexes_absolute', template => '%d', min => 0 },
                  ],
              }
          },
          { label => 'ind-partitions', set => {
                  key_values => [ { name => 'invalid_ind_partitions' } ],
                  output_template => 'index partitions : %s',
                  perfdatas => [
                      { label => 'invalid_ind_partitions', value => 'invalid_ind_partitions_absolute', template => '%d', min => 0 },
                  ],
              }
          },
          { label => 'ind-subpartitions', set => {
                  key_values => [ { name => 'invalid_ind_subpartitions' } ],
                  output_template => 'index subpartitions : %s',
                  perfdatas => [
                      { label => 'invalid_ind_subpartitions', value => 'invalid_ind_subpartitions_absolute', template => '%d', min => 0 },
                  ],
              }
          },
          { label => 'registry-components', set => {
                  key_values => [ { name => 'invalid_registry_components' } ],
                  output_template => 'registry components : %s',
                  perfdatas => [
                      { label => 'invalid_registry_components', value => 'invalid_registry_components_absolute', template => '%d', min => 0 },
                  ],
              }
          },
      ];
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "filter-message:s"    => { name => 'filter_message' },
          "retention-objects:s" => { name => 'retention_objects', default => 3 },
      });
      
      return $self;
  }
  
  sub prefix_invalid_output {
      my ($self, %options) = @_;
      
      return "Invalid ";
  }
  
  sub get_invalids {
      my ($self, %options) = @_;
      
      $self->{global}->{$options{type}} = 0;
      $options{sql}->query(query => $options{query});
      my $result = $options{sql}->fetchall_arrayref();
      foreach (@$result) {
          if (defined($self->{option_results}->{filter_message}) && $self->{option_results}->{filter_message} ne '' &&
              $_->[0] !~ /$self->{option_results}->{filter_message}/) {
              $self->{output}->output_add(long_msg => "skipping $options{type} => '" . $_->[0] . "': no matching filter.", debug => 1);
              next;
          }
          
          $self->{global}->{$options{type}}++;
      }
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
  
      $self->{global} = {};
      $options{sql}->connect();
  
      $self->get_invalids(%options, type => 'invalid_objects', query => q{
            SELECT
              O.object_type||' '||O.owner||'.'||O.object_name||' is '||O.status
            FROM dba_objects O 
              LEFT OUTER JOIN DBA_MVIEW_refresh_times V ON O.object_name = V.NAME AND O.owner = V.owner
            WHERE (LAST_REFRESH <= (SELECT sysdate - } . $self->{option_results}->{retention_objects} . q{ FROM dual) OR LAST_REFRESH is null) AND
              STATUS = 'INVALID' AND O.object_name NOT LIKE 'BIN$%'
      });
  
      $self->get_invalids(%options, type => 'invalid_indexes', query => q{
            SELECT index_type||' index '||owner||'.'||index_name||' of '||table_owner||'.'||table_name||' is '||status
            FROM dba_indexes
            WHERE status <> 'VALID' AND status <> 'N/A'
      });
      
      $self->get_invalids(%options, type => 'invalid_ind_partitions', query => q{
            SELECT partition_name||' of '||index_owner||'.'||index_name||' is '||status
            FROM dba_ind_partitions
            WHERE status <> 'USABLE' AND status <> 'N/A'
      });
  
      if ($options{sql}->is_version_minimum(version => '10.x')) {
          $self->get_invalids(%options, type => 'invalid_ind_subpartitions', query => q{
            SELECT subpartition_name||' of '||partition_name||' of '||index_owner||'.'||index_name||' is '||status
              FROM dba_ind_subpartitions
              WHERE status <> 'USABLE' AND status <> 'N/A'
          });
      }
  
      if ($options{sql}->is_version_minimum(version => '10.x')) {
          $self->get_invalids(%options, type => 'invalid_registry_components', query => q{
            SELECT namespace||'.'||comp_name||'-'||version||' is '||status
              FROM dba_registry
              WHERE status <> 'VALID' AND status <> 'OPTION OFF'
          });
      } else {
          $self->get_invalids(%options, type => 'invalid_registry_components', query => q{
            SELECT 'SCHEMA.'||comp_name||'-'||version||' is '||status
              FROM dba_registry
              WHERE status <> 'VALID' AND status <> 'OPTION OFF'
          });
      }
  
      $options{sql}->disconnect();
  }
  
  1;
  
  
  =head1 MODE
  
  Check faulty objects, indices, partitions.
  
  =over 8
  
  =item B<--filter-counters>
  
  Only display some counters (regexp can be used).
  Example: --filter-counters='^indexes$'
  
  =item B<--retention-objects>
  
  Retention in days for invalid objects (default : 3).
  
  =item B<--filter-message>
  
  Filter by message (can be a regexp).
  
  =item B<--warning-*>
  
  Threshold warning.
  Can be: 'objects', 'indexes', 'ind-partitions', 'ind-subpartitions',
  'registry-components'.
  
  =item B<--critical-*>
  
  Threshold critical.
  Can be: 'objects', 'indexes', 'ind-partitions', 'ind-subpartitions',
  'registry-components'.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_INVALIDOBJECT

$fatpacked{"database/oracle/mode/librarycacheusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_LIBRARYCACHEUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::librarycacheusage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub custom_pin_hitratio_calc {
      my ($self, %options) = @_;
  
      my $delta_total = ($options{new_datas}->{$self->{instance} . '_pins'} - $options{old_datas}->{$self->{instance} . '_pins'});
      my $delta_cache = ($options{new_datas}->{$self->{instance} . '_pin_hits'} - $options{old_datas}->{$self->{instance} . '_pin_hits'});
      $self->{result_values}->{hit_ratio} = $delta_total ? (100 * $delta_cache / $delta_total) : 0;
  
      return 0;
  }
  
  sub custom_get_hitratio_calc {
      my ($self, %options) = @_;
  
      my $delta_total = ($options{new_datas}->{$self->{instance} . '_gets'} - $options{old_datas}->{$self->{instance} . '_gets'});
      my $delta_cache = ($options{new_datas}->{$self->{instance} . '_get_hits'} - $options{old_datas}->{$self->{instance} . '_get_hits'});
      $self->{result_values}->{hit_ratio} = $delta_total ? (100 * $delta_cache / $delta_total) : 0;
  
      return 0;
  }
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'global', cb_prefix_output => 'prefix_global_output', type => 0 },
      ];
  
      $self->{maps_counters}->{global} = [
          { label => 'get-hits', nlabel => 'library.cache.get.hitratio.percentage', set => {
                  key_values => [ { name => 'get_hits', diff => 1 }, { name => 'gets', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_get_hitratio_calc'),
                  output_template => 'get hit ratio %.2f%%',
                  output_use => 'hit_ratio', threshold_use => 'hit_ratio',
                  perfdatas => [
                      { label => 'get_hit_ratio', value => 'hit_ratio', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
          { label => 'pin-hits', nlabel => 'library.cache.pin.hitratio.percentage', set => {
                  key_values => [ { name => 'pin_hits', diff => 1 }, { name => 'pins', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_pin_hitratio_calc'),
                  output_template => 'pin hit ratio %.2f%%',
                  output_use => 'hit_ratio', threshold_use => 'hit_ratio',
                  perfdatas => [
                      { label => 'pin_hit_ratio', value => 'hit_ratio', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
          { label => 'reloads', nlabel => 'library.cache.reloads.persecond', set => {
                  key_values => [ { name => 'reloads', diff => 1 }, ],
                  per_second => 1,
                  output_template => 'reloads %.2f/s',
                  perfdatas => [
                      { label => 'reloads', value => 'reloads_per_second', template => '%.2f', min => 0, unit => '/s' },
                  ],
              }
          },
          { label => 'invalids', nlabel => 'library.cache.invalids.persecond', set => {
                  key_values => [ { name => 'invalids', diff => 1 }, ],
                  per_second => 1,
                  output_template => 'invalids %.2f/s',
                  perfdatas => [
                      { label => 'invalids', value => 'invalids_per_second', template => '%.2f', min => 0, unit => '/s' },
                  ],
              }
          },
      ];
  }
  
  sub prefix_global_output {
      my ($self, %options) = @_;
  
      return 'SGA library cache ';
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, statefile => 1, force_new_perfdata => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
      });
      
      return $self;
  }
  
  sub manage_selection {
      my ($self, %options) = @_;    
  
      my $query = q{
          SELECT SUM(gethits), SUM(gets), SUM(pinhits), SUM(pins),
              SUM(reloads), SUM(invalidations)
          FROM v$librarycache
      };
  
      $options{sql}->connect();
      $options{sql}->query(query => $query);
      my @result = $options{sql}->fetchrow_array();
      $options{sql}->disconnect();
      
      $self->{global} = {
          get_hits => $result[0],
          gets => $result[1],
          pin_hits => $result[2],
          pins => $result[3],
          reloads => $result[4],
          invalids => $result[5],
      };
  
      $self->{cache_name} = "oracle_" . $self->{mode} . '_' . $options{sql}->get_unique_id4save() . '_' .
          (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all'));
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle library cache usage.
  
  =over 8
  
  =item B<--warning-*> B<--critical-*> 
  
  Thresholds.
  Can be: 'get-hits', 'pin-hits', 'reloads', 'invalid'.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_LIBRARYCACHEUSAGE

$fatpacked{"database/oracle/mode/listasmdiskgroups.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_LISTASMDISKGROUPS';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::listasmdiskgroups;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  use centreon::plugins::misc;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      
      $self->{sql}->connect();
      $self->{sql}->query(query => q{
  SELECT name, state, type FROM V$ASM_DISKGROUP
  });
      $self->{list_dg} = {};
      my $result = $self->{sql}->fetchall_arrayref();
      foreach my $row (@$result) {
          $self->{list_dg}->{$row->[0]} = {
              state => $row->[1],
              type => $row->[2],
          };
      }
  
      $self->{sql}->disconnect();
  }
  
  sub run {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
  
      $self->manage_selection();
      foreach my $name (sort keys %{$self->{list_dg}}) {
          $self->{output}->output_add(long_msg => 
              '[name = ' . $name . '] ' .
              '[state = ' . $self->{list_dg}->{$name}->{state} . '] ' .
              '[type = ' . $self->{list_dg}->{$name}->{type} . '] '
          );
      }
      $self->{output}->output_add(severity => 'OK',
                                  short_msg => "List of asm disk groups:");
  
      $self->{output}->display(nolabel => 1, force_ignore_perfdata => 1, force_long_output => 1);
      $self->{output}->exit();
  }
  
  sub disco_format {
      my ($self, %options) = @_;
      
      $self->{output}->add_disco_format(elements => ['name', 'state', 'type']);
  }
  
  sub disco_show {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
  
      $self->manage_selection();
      foreach my $name (sort keys %{$self->{list_dg}}) {
          $self->{output}->add_disco_entry(
              name => $name,
              state => $self->{list_dg}->{$name}->{state}, 
              type => $self->{list_dg}->{$name}->{type}
          );
      }
  }
  
  1;
  
  
  =head1 MODE
  
  List asm diskgroup.
  
  =over 8
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_LISTASMDISKGROUPS

$fatpacked{"database/oracle/mode/longqueries.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_LONGQUERIES';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::longqueries;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use centreon::plugins::misc;
  use centreon::plugins::statefile;
  use centreon::plugins::templates::catalog_functions qw(catalog_status_threshold);
  
  sub custom_status_output {
      my ($self, %options) = @_;
      
      my $msg = sprintf("query [status: %s] [sql: %s] %s", $self->{result_values}->{status},
          $self->{result_values}->{sql_text}, $self->{result_values}->{generation_time});
      return $msg;
  }
  
  sub custom_status_calc {
      my ($self, %options) = @_;
      
      $self->{result_values}->{status} = $options{new_datas}->{$self->{instance} . '_status'};
      $self->{result_values}->{sql_text} = $options{new_datas}->{$self->{instance} . '_sql_text'};
      $self->{result_values}->{username} = $options{new_datas}->{$self->{instance} . '_username'};
      $self->{result_values}->{since} = $options{new_datas}->{$self->{instance} . '_since'};
      $self->{result_values}->{generation_time} = $options{new_datas}->{$self->{instance} . '_generation_time'};
      return 0;
  }
  
  
  sub set_counters {
      my ($self, %options) = @_;
      
      $self->{maps_counters_type} = [
          { name => 'alarms', type => 2, message_multiple => '0 problem(s) detected', display_counter_problem => { label => 'alerts', min => 0 },
            group => [ { name => 'alarm', skipped_code => { -11 => 1 } } ] 
          }
      ];
      
      $self->{maps_counters}->{alarm} = [
          { label => 'status', threshold => 0, set => {
                  key_values => [ { name => 'status' }, { name => 'sql_text' }, { name => 'since' }, { name => 'username' }, { name => 'generation_time' } ],
                  closure_custom_calc => $self->can('custom_status_calc'),
                  closure_custom_output => $self->can('custom_status_output'),
                  closure_custom_perfdata => sub { return 0; },
                  closure_custom_threshold_check => \&catalog_status_threshold,
              }
          },
      ];
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => {
          "warning-status:s"    => { name => 'warning_status', default => '' },
          "critical-status:s"   => { name => 'critical_status', default => '' },
          "memory"              => { name => 'memory' },
          "timezone:s"          => { name => 'timezone' },
      });
      
      centreon::plugins::misc::mymodule_load(output => $self->{output}, module => 'DateTime',
                                             error_msg => "Cannot load module 'DateTime'.");
      $self->{statefile_cache} = centreon::plugins::statefile->new(%options);
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::check_options(%options);
  
      $self->change_macros(macros => ['warning_status', 'critical_status']);
      if (defined($self->{option_results}->{memory})) {
          $self->{statefile_cache}->check_options(%options);
      }
      
      if (defined($self->{option_results}->{timezone}) && $self->{option_results}->{timezone} ne '') {
          $ENV{TZ} = $self->{option_results}->{timezone};
      }
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
      $self->{sql}->connect();
  
      if (!$self->{sql}->is_version_minimum(version => '11')) {
          $self->{output}->add_option_msg(short_msg => "Need oracle version >= 11");
          $self->{output}->option_exit();
      }
      
      $self->{alarms}->{global} = { alarm => {} };
      
      my $query = q{
          SELECT status, ((sql_exec_start - date '1970-01-01')*24*60*60) as sql_exec_start, elapsed_time
                  FROM v$sql_monitor
      };
      if ($self->{sql}->is_version_minimum(version => '12')) {
          $query = q{
              SELECT status, ((sql_exec_start - date '1970-01-01')*24*60*60) as sql_exec_start, elapsed_time, username, sql_text
                  FROM v$sql_monitor
          };
      }
      $self->{sql}->query(query => $query);
      
      my $last_time;
      if (defined($self->{option_results}->{memory})) {
          $self->{statefile_cache}->read(statefile => "cache_oracle_" . $self->{mode} . $self->{sql}->get_unique_id4save());
          $last_time = $self->{statefile_cache}->get(name => 'last_time');
      }
  
      my ($i, $current_time) = (1, time());
      while ((my @row = $self->{sql}->fetchrow_array())) {
          # can be: 1541985283,999999999999999999999999999996
          $row[1] =~ s/,/./;
          my @values = localtime($row[1]);
          my $dt = DateTime->new(
              year       => $values[5] + 1900,
              month      => $values[4] + 1,
              day        => $values[3],
              hour       => $values[2],
              minute     => $values[1],
              second     => $values[0],
              time_zone  => 'UTC',
          );
   
          next if (defined($self->{option_results}->{memory}) && defined($last_time) && $last_time > $dt->epoch);
          $row[4] =~ s/(\n|\|)/-/ms if (defined($row[4]));
   
          my $since = $row[2] / 1000000;
          $self->{alarms}->{global}->{alarm}->{$i} = {
              status => $row[0],
              sql_text => defined($row[4]) ? $row[4] : '-',
              username => defined($row[5]) ? $row[5] : '-',
              since => $since,
              generation_time => centreon::plugins::misc::change_seconds(value => $since) };
          $i++;
      }
      
      if (defined($self->{option_results}->{memory})) {
          $self->{statefile_cache}->write(data => { last_time => $current_time });
      }
  
      $self->{sql}->disconnect();
  }
  
  1;
  
  
  =head1 MODE
  
  Check long sql queries.
  
  =over 8
  
  =item B<--warning-status>
  
  Set warning threshold for status (Default: '')
  Can used special variables like: %{username}, %{sql_text}, %{since}, %{status}
  
  =item B<--critical-status>
  
  Set critical threshold for status (Default: '').
  Can used special variables like: %{username}, %{sql_text}, %{since}, %{status}
  
  =item B<--timezone>
  
  Timezone of oracle server (If not set, we use current server execution timezone).
  
  =item B<--memory>
  
  Only check new queries.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_LONGQUERIES

$fatpacked{"database/oracle/mode/passwordexpiration.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_PASSWORDEXPIRATION';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::passwordexpiration;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use centreon::plugins::misc;
  use centreon::plugins::statefile;
  use centreon::plugins::templates::catalog_functions qw(catalog_status_threshold);
  
  sub custom_status_output {
      my ($self, %options) = @_;
      
      my $msg = sprintf("[username: %s] [account status: %s] expired in : %s",
          $self->{result_values}->{username},
          $self->{result_values}->{account_status},
          $self->{result_values}->{expire_time}
      );
      return $msg;
  }
  
  sub custom_status_calc {
      my ($self, %options) = @_;
      
      $self->{result_values}->{account_status} = $options{new_datas}->{$self->{instance} . '_account_status'};
      $self->{result_values}->{username} = $options{new_datas}->{$self->{instance} . '_username'};
      $self->{result_values}->{expire} = $options{new_datas}->{$self->{instance} . '_expire'};
      $self->{result_values}->{expire_time} = $options{new_datas}->{$self->{instance} . '_expire_time'};
      return 0;
  }
  
  
  sub set_counters {
      my ($self, %options) = @_;
      
      $self->{maps_counters_type} = [
          { name => 'users', type => 2, format_output => '%s user(s) detected', display_counter_problem => { label => 'users', min => 0 },
            group => [ { name => 'user', skipped_code => { -11 => 1 } } ] 
          }
      ];
      
      $self->{maps_counters}->{user} = [
          { label => 'status', threshold => 0, set => {
                  key_values => [ { name => 'username' }, { name => 'account_status' }, { name => 'expire' }, { name => 'expire_time' } ],
                  closure_custom_calc => $self->can('custom_status_calc'),
                  closure_custom_output => $self->can('custom_status_output'),
                  closure_custom_perfdata => sub { return 0; },
                  closure_custom_threshold_check => \&catalog_status_threshold,
              }
          },
      ];
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => {
          "warning-status:s"    => { name => 'warning_status', default => '' },
          "critical-status:s"   => { name => 'critical_status', default => '' },
          "timezone:s"          => { name => 'timezone' },
      });
      
      centreon::plugins::misc::mymodule_load(output => $self->{output}, module => 'DateTime',
                                             error_msg => "Cannot load module 'DateTime'.");
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::check_options(%options);
  
      $self->change_macros(macros => ['warning_status', 'critical_status']);
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      $options{sql}->connect();
  
      $self->{users}->{global} = { user => {} };
      
      my $query = q{
          SELECT username, account_status, ((expiry_date - date '1970-01-01')*24*60*60) 
          FROM dba_users 
          WHERE expiry_date is not null AND account_status NOT LIKE '%EXPIRED%'
      };
      $options{sql}->query(query => $query);
  
      my $tz = centreon::plugins::misc::set_timezone(name => $self->{option_results}->{timezone});
      my $i = 1;
      while ((my @row = $options{sql}->fetchrow_array())) {
          # can be: 1541985283,999999999999999999999999999996
          $row[2] =~ s/,/./;
          my @values = localtime($row[2]);
          my $dt = DateTime->new(
              year       => $values[5] + 1900,
              month      => $values[4] + 1,
              day        => $values[3],
              hour       => $values[2],
              minute     => $values[1],
              second     => $values[0],
              %$tz
          );
   
          my $expire = abs(time() - $dt->epoch);
          $self->{users}->{global}->{user}->{$i} = {
              account_status => $row[1],
              username => $row[0],
              expire => $expire,
              expire_time => centreon::plugins::misc::change_seconds(value => $expire) 
          };
          $i++;
      }
  
      $self->{sql}->disconnect();
  }
  
  1;
  
  
  =head1 MODE
  
  Check user password expiration.
  
  =over 8
  
  =item B<--warning-status>
  
  Set warning threshold for status (Default: '')
  Can used special variables like: %{username}, %{account_status}, %{expire}
  
  =item B<--critical-status>
  
  Set critical threshold for status (Default: '').
  Can used special variables like: %{username}, %{account_status}, %{expire}
  
  =item B<--timezone>
  
  Timezone of oracle server (If not set, we use current server execution timezone).
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_PASSWORDEXPIRATION

$fatpacked{"database/oracle/mode/processusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_PROCESSUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::processusage;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "warning:s"               => { name => 'warning', },
          "critical:s"              => { name => 'critical', },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
          $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      $self->{sql}->connect();
      $self->{sql}->query(query => q{SELECT current_utilization/limit_value*100 FROM v$resource_limit WHERE resource_name = 'processes'});
      my $session = $self->{sql}->fetchrow_array();
      $self->{sql}->disconnect();
  
      my $exit_code = $self->{perfdata}->threshold_check(value => $session, threshold => [ { label => 'critical', exit_litteral => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
      $self->{output}->output_add(severity => $exit_code,
                                    short_msg => sprintf("%.2f%% of process resources used.", $session));
      $self->{output}->perfdata_add(label => 'process_used', unit => '%',
                                    value => sprintf("%.2f", $session),
                                    warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning'),
                                    critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical'),
                                    min => 0, max => 100);
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle process used.
  
  =over 8
  
  =item B<--warning>
  
  Threshold warning.
  
  =item B<--critical>
  
  Threshold critical.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_PROCESSUSAGE

$fatpacked{"database/oracle/mode/redologusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_REDOLOGUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::redologusage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub custom_get_hitratio_calc {
      my ($self, %options) = @_;
  
      my $delta_total = ($options{new_datas}->{$self->{instance} . '_redo_entries'} - $options{old_datas}->{$self->{instance} . '_redo_entries'});
      my $delta_retry = ($options{new_datas}->{$self->{instance} . '_redo_buffer_alloc_retries'} - $options{old_datas}->{$self->{instance} . '_redo_buffer_alloc_retries'});
      $self->{result_values}->{retry_ratio} = $delta_total ? (100 * $delta_retry / $delta_total) : 0;
  
      return 0;
  }
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'global', cb_prefix_output => 'prefix_global_output', type => 0 },
      ];
  
      $self->{maps_counters}->{global} = [
          { label => 'retry-ratio', nlabel => 'redolog.retry.ratio.percentage', set => {
                  key_values => [ { name => 'redo_buffer_alloc_retries', diff => 1 }, { name => 'redo_entries', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_get_hitratio_calc'),
                  output_template => 'retry ratio %.2f%%',
                  output_use => 'retry_ratio', threshold_use => 'retry_ratio',
                  perfdatas => [
                      { label => 'retry_ratio', value => 'retry_ratio', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
          { label => 'traffic-io', nlabel => 'redolog.traffic.io.bytespersecond', set => {
                  key_values => [ { name => 'redo_size', diff => 1 } ],
                  output_change_bytes => 1, per_second => 1,
                  output_template => 'traffic io %s %s/s',
                  perfdatas => [
                      { label => 'traffic_io', value => 'redo_size_per_second', template => '%s', min => 0, unit => 'B/s' },
                  ],
              }
          },
      ];
  }
  
  sub prefix_global_output {
      my ($self, %options) = @_;
  
      return 'Redo log ';
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, statefile => 1, force_new_perfdata => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
      });
      
      return $self;
  }
  
  sub manage_selection {
      my ($self, %options) = @_;    
  
      my $query = q{
          SELECT a.value, b.value, c.value
              FROM v$sysstat a, v$sysstat b, v$sysstat c
              WHERE a.name = 'redo buffer allocation retries'  
              AND b.name = 'redo entries'
              AND c.name = 'redo size'
      };
  
      $options{sql}->connect();
      $options{sql}->query(query => $query);
      my @result = $options{sql}->fetchrow_array();
      $options{sql}->disconnect();
      
      $self->{global} = {
          redo_buffer_alloc_retries => $result[0],
          redo_entries => $result[1],
          redo_size => $result[2],
      };
  
      $self->{cache_name} = "oracle_" . $self->{mode} . '_' . $options{sql}->get_unique_id4save() . '_' .
          (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all'));
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle library cache usage.
  
  =over 8
  
  =item B<--warning-*> B<--critical-*> 
  
  Thresholds.
  Can be: 'retry-ratio', 'traffic-io'.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_REDOLOGUSAGE

$fatpacked{"database/oracle/mode/rmanbackupage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_RMANBACKUPAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::rmanbackupage;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  use DateTime;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "skip-no-backup"          => { name => 'skip_no_backup', },
          "filter-type:s"           => { name => 'filter_type', },
          "timezone:s"              => { name => 'timezone', },
          "incremental-level"       => { name => 'incremental_level', },
      });
  
      foreach (('db incr', 'db full', 'archivelog', 'controlfile')) {
          my $label = $_;
          $label =~ s/ /-/g;
          $options{options}->add_options(arguments => {	
                                                       'warning-' . $label . ':s'     => { name => 'warning-' . $label },
                                                       'critical-' . $label . ':s'    => { name => 'critical-' . $label },
                                                       'no-' . $label                 => { name => 'no-' . $label },
                                        });
      }
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      foreach (('db incr', 'db full', 'archivelog', 'controlfile')) {
          my $label = $_;
          $label =~ s/ /-/g;
          foreach my $threshold (('warning', 'critical')) {
              if (($self->{perfdata}->threshold_validate(label => $threshold . '-' . $label, value => $self->{option_results}->{$threshold . '-' . $label})) == 0) {
                  $self->{output}->add_option_msg(short_msg => "Wrong " . $threshold . '-' . $label . " threshold '" . $self->{option_results}->{warning_db_incr} . "'.");
                  $self->{output}->option_exit();
              }
          }
      }
  
      if (defined($self->{option_results}->{timezone}) && $self->{option_results}->{timezone} ne '') {
          $ENV{TZ} = $self->{option_results}->{timezone};
      }
      
      if (defined($self->{option_results}->{incremental_level})) {
          # the special request don't retrieve controlfiles. But controlfiles are saved with archivelog.
          $self->{option_results}->{'no-controlfile'} = 1;
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      $self->{sql}->connect();
      my $query;
      if (defined($self->{option_results}->{incremental_level})) {
          $query = q{SELECT v$rman_status.object_type,
                      ((max(v$rman_status.start_time) - date '1970-01-01')*24*60*60) as last_time,
                      SUM(v$backup_set_details.incremental_level)
                      FROM v$rman_status LEFT JOIN v$backup_set_details ON v$rman_status.session_recid = v$backup_set_details.session_recid
                      WHERE operation='BACKUP'
                      GROUP BY object_type, v$backup_set_details.session_recid ORDER BY last_time DESC
          };
      } else {
          $query = q{SELECT object_type,
                      ((max(start_time) - date '1970-01-01')*24*60*60) as last_time
                      FROM v$rman_status
                      WHERE operation='BACKUP'
                      GROUP BY object_type};
      }
      $self->{sql}->query(query => $query);
      my $result = $self->{sql}->fetchall_arrayref();
      $self->{sql}->disconnect();
  
      $self->{output}->output_add(severity => 'OK',
                                  short_msg => sprintf("Rman backup age are ok."));
  
      my $count_backups = 0;
      my $already_checked = {};
      foreach (('db full', 'db incr', 'archivelog', 'controlfile')) {
          my $executed = 0;
          my $label = $_;
          $label =~ s/ /-/g;
          foreach my $row (@$result) {
              if (defined($self->{option_results}->{incremental_level})) {
                  # db incr with incremental level 0 = DB FULL
                   if (/db full/ && $$row[0] =~ /db incr/i && (!defined($$row[2]) || $$row[2] == 0)) { # it's a full. we get
                      $$row[0] = 'DB FULL';
                  } else {
                      next if (/db incr/ && $$row[0] =~ /db incr/i && (!defined($$row[2]) || $$row[2] == 0)); # it's a full. we skip.
                      next if ($$row[0] !~ /$_/i);
                  }
              } else {
                  next if ($$row[0] !~ /$_/i);
              }
  
              next if (defined($already_checked->{$$row[0]}));
  
              $already_checked->{$$row[0]} = 1;
              
              $count_backups++;
              $executed = 1;
              my ($type, $last_time) = @$row;
              next if (defined($self->{option_results}->{filter_type}) && $type !~ /$self->{option_results}->{filter_type}/);
  
              my @values = localtime($last_time);
              my $dt = DateTime->new(
                              year       => $values[5] + 1900,
                              month      => $values[4] + 1,
                              day        => $values[3],
                              hour       => $values[2],
                              minute     => $values[1],
                              second     => $values[0],
                              time_zone  => 'UTC',
              );
              my $offset = $last_time - $dt->epoch;
              $last_time = $last_time + $offset;
  
              my $backup_age = time() - $last_time;
          
              my $backup_age_convert = centreon::plugins::misc::change_seconds(value => $backup_age);
              my $type_perfdata = $type;
              $type_perfdata =~ s/ /_/g;
              $self->{output}->output_add(long_msg => sprintf("Last Rman '%s' backups : %s", $type, $backup_age_convert));
              $self->{output}->perfdata_add(label => sprintf('%s_backup_age', $type_perfdata),
                                            value => $backup_age,
                                            unit => 's',
                                            warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning-' . $label),
                                            critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical-' . $label),
                                            min => 0);
              my $exit_code = $self->{perfdata}->threshold_check(value => $backup_age, threshold => [ { label => 'critical-' . $label, exit_litteral => 'critical' }, { label => 'warning-' . $label, exit_litteral => 'warning' } ]);
              
              if (!$self->{output}->is_status(value => $exit_code, compare => 'ok', litteral => 1)) {
                  $self->{output}->output_add(severity => $exit_code,
                                              short_msg => sprintf("Last Rman '%s' backups : %s", $type, $backup_age_convert));
              }
          }
          
          if ($executed == 0 && !defined($self->{option_results}->{'no-' . $label})) {
              $self->{output}->output_add(severity => 'CRITICAL',
                                          short_msg => sprintf("Rman '%s' backups never executed", uc($_)));
          }
      }
  
      if (($count_backups == 0) && (!defined($self->{option_results}->{skip_no_backup}))) {
          $self->{output}->output_add(severity => 'CRITICAL',
                                      short_msg => sprintf("Rman backups never executed."));
      }
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle rman backup age.
  
  =over 8
  
  =item B<--warning-*>
  
  Threshold warning in seconds.
  Can be: 'db-incr', 'db-full', 'archivelog', 'controlfile'.
  
  =item B<--critical-*>
  
  Threshold critical in seconds.
  Can be: 'db-incr', 'db-full', 'archivelog', 'controlfile'.
  
  =item B<--no-*>
  
  Skip error if never executed.
  Can be: 'db-incr', 'db-full', 'archivelog', 'controlfile'.
  
  =item B<--filter-type>
  
  Filter backup type.
  (type can be : 'DB INCR', 'DB FULL', 'ARCHIVELOG')
  
  =item B<--skip-no-backup>
  
  Return ok if no backup found.
  
  =item B<--timezone>
  
  Timezone of oracle server (If not set, we use current server execution timezone).
  
  =item B<--incremental-level>
  
  Please use the following option if your using incremental level 0 for full backup.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_RMANBACKUPAGE

$fatpacked{"database/oracle/mode/rmanbackupproblems.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_RMANBACKUPPROBLEMS';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::rmanbackupproblems;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "warning:s"       => { name => 'warning', },
          "critical:s"      => { name => 'critical', },
          "retention:s"     => { name => 'retention', default => 3 },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
          $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      $self->{sql}->connect();
      my $retention = $self->{option_results}->{retention};
      my $query = q{SELECT COUNT(*) FROM v$rman_status WHERE operation = 'BACKUP' AND status != 'COMPLETED' AND status != 'RUNNING' AND start_time > sysdate-} . $retention;
      $self->{sql}->query(query => $query);
      my $rman_backup_problems = $self->{sql}->fetchrow_array();
      $self->{sql}->disconnect();
  
      my $exit_code = $self->{perfdata}->threshold_check(value => $rman_backup_problems, threshold => [ { label => 'critical', exit_litteral => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
      $self->{output}->output_add(severity => $exit_code,
                                    short_msg => sprintf("rman had %i problems during the last %i days", $rman_backup_problems, $self->{option_results}->{retention}));
      $self->{output}->perfdata_add(label => 'rman_backup_problems',
                                    value => $rman_backup_problems,
                                    warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning'),
                                    critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical'),
                                    min => 0);
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle rman backup problems.
  
  =over 8
  
  =item B<--warning>
  
  Threshold warning.
  
  =item B<--critical>
  
  Threshold critical.
  
  =item B<--retention>
  
  Retention in days (default : 3).
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_RMANBACKUPPROBLEMS

$fatpacked{"database/oracle/mode/rmanonlinebackupage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_RMANONLINEBACKUPAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::rmanonlinebackupage;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  use DateTime;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments => { 
          "warning:s"               => { name => 'warning', },
          "critical:s"              => { name => 'critical', },
          "timezone:s"              => { name => 'timezone', },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
          $self->{output}->option_exit();
      }
      
      if (defined($self->{option_results}->{timezone}) && $self->{option_results}->{timezone} ne '') {
          $ENV{TZ} = $self->{option_results}->{timezone};
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      $self->{sql}->connect();
      my $query = q{SELECT min(((time - date '1970-01-01') * 86400)) as last_time
                    FROM v$backup
                    WHERE STATUS='ACTIVE'
      };
      $self->{sql}->query(query => $query);
      my $result = $self->{sql}->fetchall_arrayref();
      $self->{sql}->disconnect();
  
      $self->{output}->output_add(severity => 'OK',
                                  short_msg => sprintf("Backup online modes are ok."));
  
      foreach my $row (@$result) {
          next if (!defined($$row[0]));
          my $last_time = $$row[0];
          
          my @values = localtime($last_time);
          my $dt = DateTime->new(
                          year       => $values[5] + 1900,
                          month      => $values[4] + 1,
                          day        => $values[3],
                          hour       => $values[2],
                          minute     => $values[1],
                          second     => $values[0],
                          time_zone  => 'UTC',
          );
          my $offset = $last_time - $dt->epoch;
          $last_time = $last_time + $offset;
          
          my $launched = time() - $last_time;
          my $launched_convert = centreon::plugins::misc::change_seconds(value => $launched);
          $self->{output}->output_add(long_msg => sprintf("backup online mode since %s (%s)", $launched_convert, locatime($last_time)));
          my $exit_code = $self->{perfdata}->threshold_check(value => $launched, threshold => [ { label => 'critical', exit_litteral => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
          if (!$self->{output}->is_status(value => $exit_code, compare => 'ok', litteral => 1)) {
              $self->{output}->output_add(severity => $exit_code,
                                          short_msg => sprintf("backup online mode since %s (%s)", $launched_convert, locatime($last_time)));
          }
      }
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle backup online mode.
  
  =over 8
  
  =item B<--warning>
  
  Threshold warning in seconds.
  
  =item B<--critical>
  
  Threshold critical in seconds.
  
  =item B<--timezone>
  
  Timezone of oracle server (If not set, we use current server execution timezone)
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_RMANONLINEBACKUPAGE

$fatpacked{"database/oracle/mode/rollbacksegmentusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_ROLLBACKSEGMENTUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::rollbacksegmentusage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'segment', type => 0, cb_prefix_output => 'prefix_output' },
      ];
  
      $self->{maps_counters}->{segment} = [    
          { label => 'extends', set => {
                  key_values => [ { name => 'extends', diff => 1 } ],
                  per_second => 1,
                  output_template => 'Extends : %.2f/s',
                  perfdatas => [
                      { label => 'extends', value => 'extends_per_second', template => '%.2f',
                        unit => '/s', min => 0 },
                  ],
              }
          },
          { label => 'wraps', set => {
                  key_values => [ { name => 'wraps', diff => 1 } ],
                  per_second => 1,
                  output_template => 'Wraps : %.2f/s',
                  perfdatas => [
                      { label => 'wraps', value => 'wraps_per_second', template => '%.2f',
                        unit => '/s', min => 0 },
                  ],
              }
          },
          { label => 'header-contention', set => {
                  key_values => [ { name => 'undoheader', diff => 1 }, { name => 'complete', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_contention_calc'), closure_custom_calc_extra_options => { label_ref => 'header' },
                  output_template => 'Header Contention :  %.2f %%', output_use => 'header_prct', threshold_use => 'header_prct',
                  perfdatas => [
                      { label => 'header_contention', value => 'header_prct', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
          { label => 'block-contention', set => {
                  key_values => [ { name => 'undoblock', diff => 1 }, { name => 'complete', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_contention_calc'), closure_custom_calc_extra_options => { label_ref => 'block' },
                  output_template => 'Block Contention :  %.2f %%', output_use => 'block_prct', threshold_use => 'block_prct',
                  perfdatas => [
                      { label => 'block_contention', value => 'block_prct', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
          { label => 'hit-ratio', set => {
                  key_values => [ { name => 'waits', diff => 1 }, { name => 'gets', diff => 1 } ],
                  closure_custom_calc => $self->can('custom_hitratio_calc'),
                  output_template => 'gets/waits Ratio :  %.2f %%', output_use => 'hit_ratio', threshold_use => 'hit_ratio',
                  perfdatas => [
                      { label => 'hit_ratio', value => 'hit_ratio', template => '%.2f', min => 0, max => 100, unit => '%' },
                  ],
              }
          },
      ];
  }
  
  sub custom_hitratio_calc {
      my ($self, %options) = @_;
  
      my $delta_waits = $options{new_datas}->{$self->{instance} . '_waits'} - $options{old_datas}->{$self->{instance} . '_waits'};
      my $delta_gets = $options{new_datas}->{$self->{instance} . '_gets'} - $options{old_datas}->{$self->{instance} . '_gets'};
      $self->{result_values}->{hit_ratio} = $delta_gets == 0 ? 100 : (100 - 100 * $delta_waits / $delta_gets);
      
      return 0;
  }
  
  sub custom_contention_calc {
      my ($self, %options) = @_;
  
      my $delta_waits = $options{new_datas}->{$self->{instance} . '_complete'} - $options{old_datas}->{$self->{instance} . '_complete'};
      my $delta_undo = $options{new_datas}->{$self->{instance} . '_undo' . $options{extra_options}->{label_ref}} - $options{old_datas}->{$self->{instance} . '_undo' . $options{extra_options}->{label_ref}};
      $self->{result_values}->{$options{extra_options}->{label_ref} . '_prct'} = $delta_waits == 0 ? 0 : (100 * $delta_undo / $delta_waits);
      
      return 0;
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options, statefile => 1);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
      });
  
      return $self;
  }
  
  sub prefix_output {
      my ($self, %options) = @_;
  
      return "Rollback Segment ";
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
      $self->{sql}->connect();
  
      my $query = q{
          SELECT SUM(waits), SUM(gets), SUM(extends), SUM(wraps) FROM v$rollstat
      };
      
      $self->{sql}->query(query => $query);
      my @result = $self->{sql}->fetchrow_array();
      $self->{segment} = { waits => $result[0], gets => $result[1], extends => $result[2], wraps => $result[3] };
  
      $query = q{
          SELECT ( 
            SELECT SUM(count)
            FROM v$waitstat
            WHERE class = 'undo header' OR class = 'system undo header'
          ) undoheader,
          ( 
            SELECT SUM(count)
            FROM v$waitstat
            WHERE class = 'undo block' OR class = 'system undo block'
          ) undoblock, 
          (
            SELECT SUM(count)
            FROM v$waitstat
          ) complete
          FROM DUAL
      };
      $self->{sql}->query(query => $query);
      @result = $self->{sql}->fetchrow_array();
      $self->{segment}->{undoheader} = $result[0];
      $self->{segment}->{undoblock} = $result[1];
      $self->{segment}->{complete} = $result[2];
      
      $self->{cache_name} = "oracle_" . $self->{mode} . '_' . $self->{sql}->get_unique_id4save() . '_' . 
          (defined($self->{option_results}->{filter_counters}) ? md5_hex($self->{option_results}->{filter_counters}) : md5_hex('all'));
      $self->{sql}->disconnect();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle rollback segment usage.
  
  =over 8
  
  =item B<--warning-*>
  
  Threshold warning.
  Can be: 'header-contention', 'block-contention', 'hit-ratio',
  'extends', 'wraps'.
  
  =item B<--critical-*>
  
  Threshold critical.
  Can be: 'header-contention', 'block-contention', 'hit-ratio',
  'extends', 'wraps'.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_ROLLBACKSEGMENTUSAGE

$fatpacked{"database/oracle/mode/sessionusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_SESSIONUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::sessionusage;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "warning:s"               => { name => 'warning', },
          "critical:s"              => { name => 'critical', },
      });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
          $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      $self->{sql}->connect();
      $self->{sql}->query(query => q{SELECT current_utilization/limit_value*100 FROM v$resource_limit WHERE resource_name = 'sessions'});
      my $session = $self->{sql}->fetchrow_array();
      $self->{sql}->disconnect();
  
      $session =~ s/,/./g;
      my $exit_code = $self->{perfdata}->threshold_check(value => $session, threshold => [ { label => 'critical', exit_litteral => 'critical' }, { label => 'warning', exit_litteral => 'warning' } ]);
      $self->{output}->output_add(severity => $exit_code,
                                    short_msg => sprintf("%.2f%% of session resources used.", $session));
      $self->{output}->perfdata_add(label => 'session_used', unit => '%',
                                    value => sprintf("%.2f", $session),
                                    warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning'),
                                    critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical'),
                                    min => 0, max => 100);
  
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle session used.
  
  =over 8
  
  =item B<--warning>
  
  Threshold warning.
  
  =item B<--critical>
  
  Threshold critical.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_SESSIONUSAGE

$fatpacked{"database/oracle/mode/tablespaceusage.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_TABLESPACEUSAGE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::tablespaceusage;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'tablespace', type => 1, cb_prefix_output => 'prefix_tablespace_output', message_multiple => 'All tablespaces are OK' },
      ];
  
      $self->{maps_counters}->{tablespace} = [
          { label => 'tablespace', set => {
                  key_values => [ { name => 'prct_used' }, { name => 'used' }, { name => 'free' }, { name => 'total' }, { name => 'display' } ],
                  closure_custom_calc => \&custom_usage_calc,
                  closure_custom_output => \&custom_usage_output,
                  closure_custom_perfdata => \&custom_usage_perfdata,
                  closure_custom_threshold_check => \&custom_usage_threshold,
              }
          },
      ];
  }
  
  sub custom_usage_perfdata {
      my ($self, %options) = @_;
  
      my $label = 'tbs_' . $self->{result_values}->{display} . '_usage';
      my $value_perf = $self->{result_values}->{used};
      if (defined($self->{instance_mode}->{option_results}->{free})) {
          $label = 'tbs_' . $self->{result_values}->{display} . '_free';
          $value_perf = $self->{result_values}->{free};
      }
  
      my %total_options = ();
      if ($self->{instance_mode}->{option_results}->{units} eq '%') {
          $total_options{total} = $self->{result_values}->{total};
          $total_options{cast_int} = 1;
      }
  
      $self->{output}->perfdata_add(
          label => $label, unit => 'B',
          instances => $self->use_instances(extra_instance => $options{extra_instance}) ? $self->{result_values}->{display} : undef,
          value => $value_perf,
          warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning-' . $self->{thlabel}, %total_options),
          critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical-' . $self->{thlabel}, %total_options),
          min => 0, max => $self->{result_values}->{total}
      );
  }
  
  sub custom_usage_threshold {
      my ($self, %options) = @_;
  
      my ($exit, $threshold_value);
      $threshold_value = $self->{result_values}->{used};
      $threshold_value = $self->{result_values}->{free} if (defined($self->{instance_mode}->{option_results}->{free}));
      if ($self->{instance_mode}->{option_results}->{units} eq '%') {
          $threshold_value = $self->{result_values}->{prct_used};
          $threshold_value = $self->{result_values}->{prct_free} if (defined($self->{instance_mode}->{option_results}->{free}));
      }
      $exit = $self->{perfdata}->threshold_check(value => $threshold_value, threshold => [ { label => 'critical-' . $self->{thlabel}, exit_litteral => 'critical' }, { label => 'warning-'. $self->{thlabel}, exit_litteral => 'warning' } ]);
      return $exit;
  }
  
  sub custom_usage_output {
      my ($self, %options) = @_;
  
      my ($total_size_value, $total_size_unit) = $self->{perfdata}->change_bytes(value => $self->{result_values}->{total});
      my ($total_used_value, $total_used_unit) = $self->{perfdata}->change_bytes(value => $self->{result_values}->{used});
      my ($total_free_value, $total_free_unit) = $self->{perfdata}->change_bytes(value => $self->{result_values}->{free});
      my $msg = sprintf("Total: %s Used: %s (%.2f%%) Free: %s (%.2f%%)",
                     $total_size_value . " " . $total_size_unit,
                     $total_used_value . " " . $total_used_unit, $self->{result_values}->{prct_used},
                     $total_free_value . " " . $total_free_unit, $self->{result_values}->{prct_free});
      return $msg;
  }
  
  sub custom_usage_calc {
      my ($self, %options) = @_;
  
      $self->{result_values}->{display} = $options{new_datas}->{$self->{instance} . '_display'};
      $self->{result_values}->{total} = $options{new_datas}->{$self->{instance} . '_total'};
      $self->{result_values}->{used} = $options{new_datas}->{$self->{instance} . '_used'};
      $self->{result_values}->{prct_used} = $options{new_datas}->{$self->{instance} . '_prct_used'};
      $self->{result_values}->{free} = $options{new_datas}->{$self->{instance} . '_free'};
  
      $self->{result_values}->{prct_free} = 100 - $self->{result_values}->{prct_used};
      
      return 0;
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "filter-tablespace:s" => { name => 'filter_tablespace' },
          "units:s"             => { name => 'units', default => '%' },
          "free"                => { name => 'free' },
          "skip"                => { name => 'skip' },
      });
  
      return $self;
  }
  
  sub prefix_tablespace_output {
      my ($self, %options) = @_;
  
      return "Tablespace '" . $options{instance_value}->{display} . "' ";
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
      $self->{sql}->connect();
  
      my $query;
      if ($self->{sql}->is_version_minimum(version => '11')) {
          $query = q{
              SELECT
                tum.tablespace_name "Tablespace",
                t.status "Status",
                t.contents "Type",
                t.extent_management "Extent Mgmt",
                tum.used_space*t.block_size bytes,
                tum.tablespace_size*t.block_size bytes_max
              FROM
                DBA_TABLESPACE_USAGE_METRICS tum
              INNER JOIN
                dba_tablespaces t on tum.tablespace_name=t.tablespace_name
              WHERE
                t.contents<>'UNDO'
                OR (t.contents='UNDO' AND t.tablespace_name =(SELECT value FROM v$parameter WHERE name='undo_tablespace'))
          };
      } elsif ($self->{sql}->is_version_minimum(version => '9')) {
          $query = q{
              SELECT
                  a.tablespace_name         "Tablespace",
                  b.status                  "Status",
                  b.contents                "Type",
                  b.extent_management       "Extent Mgmt",
                  a.bytes                   bytes,
                  a.maxbytes                bytes_max,
                  c.bytes_free + NVL(d.bytes_expired,0)             bytes_free
              FROM
                (
                  SELECT
                      a.tablespace_name,
                      SUM(a.bytes)          bytes,
                      SUM(DECODE(a.autoextensible, 'YES', CASE WHEN (a.bytes > a.maxbytes) THEN 0 ELSE a.maxbytes END, 'NO', a.bytes)) maxbytes
                  FROM
                      dba_data_files a
                  GROUP BY
                      tablespace_name
                ) a,
                sys.dba_tablespaces b,
                (
                  SELECT
                      a.tablespace_name,
                      SUM(a.bytes) bytes_free
                  FROM
                      dba_free_space a
                  GROUP BY
                      tablespace_name
                ) c,
                (
                  SELECT
                      a.tablespace_name,
                      SUM(a.bytes) bytes_expired
                  FROM
                      dba_undo_extents a
                  WHERE
                      status = 'EXPIRED'
                  GROUP BY
                      tablespace_name
                ) d
              WHERE
                  a.tablespace_name = c.tablespace_name (+)
                  AND a.tablespace_name = b.tablespace_name
                  AND a.tablespace_name = d.tablespace_name (+)
                  AND (b.contents = 'PERMANENT'
                  OR (b.contents <> 'PERMANENT'
                  AND a.tablespace_name=(select value from v$parameter where name='undo_tablespace')))
              UNION ALL
              SELECT
                  d.tablespace_name "Tablespace",
                  b.status "Status",
                  b.contents "Type",
                  b.extent_management "Extent Mgmt",
                  sum(a.bytes_free + a.bytes_used) bytes,   -- allocated
                  SUM(DECODE(d.autoextensible, 'YES', CASE WHEN (d.bytes > d.maxbytes) THEN 0 ELSE d.maxbytes END, 'NO', d.bytes)) bytes_max,
                  SUM(a.bytes_free + a.bytes_used - NVL(c.bytes_used, 0)) bytes_free
              FROM
                  sys.v_$TEMP_SPACE_HEADER a,
                  sys.dba_tablespaces b,
                  sys.v_$Temp_extent_pool c,
                  dba_temp_files d
              WHERE
                  c.file_id(+)             = a.file_id
                  and c.tablespace_name(+) = a.tablespace_name
                  and d.file_id            = a.file_id
                  and d.tablespace_name    = a.tablespace_name
                  and b.tablespace_name    = a.tablespace_name
              GROUP BY
                  b.status,
                  b.contents,
                  b.extent_management,
                  d.tablespace_name
              ORDER BY
                  1
          };
      } elsif ($self->{sql}->is_version_minimum(version => '8')) {
          $query = q{SELECT
                  a.tablespace_name         "Tablespace",
                  b.status                  "Status",
                  b.contents                "Type",
                  b.extent_management       "Extent Mgmt",
                  a.bytes                   bytes,
                  a.maxbytes                bytes_max,
                  c.bytes_free              bytes_free
              FROM
                (
                  -- belegter und maximal verfuegbarer platz pro datafile
                  -- nach tablespacenamen zusammengefasst
                  -- => bytes
                  -- => maxbytes
                  SELECT
                      a.tablespace_name,
                      SUM(a.bytes)          bytes,
                      SUM(DECODE(a.autoextensible, 'YES', a.maxbytes, 'NO', a.bytes)) maxbytes
                  FROM
                      dba_data_files a
                  GROUP BY
                      tablespace_name
                ) a,
                sys.dba_tablespaces b,
                (
                  -- freier platz pro tablespace
                  -- => bytes_free
                  SELECT
                      a.tablespace_name,
                      SUM(a.bytes) bytes_free
                  FROM
                      dba_free_space a
                  GROUP BY
                      tablespace_name
                ) c
              WHERE
                  a.tablespace_name = c.tablespace_name (+)
                  AND a.tablespace_name = b.tablespace_name
                  AND (b.contents = 'PERMANENT'
                  OR (b.contents <> 'PERMANENT'
                  AND a.tablespace_name=(select value from v$parameter where name='undo_tablespace')))
              UNION ALL
              SELECT
                  a.tablespace_name "Tablespace",
                  b.status "Status",
                  b.contents "Type",
                  b.extent_management "Extent Mgmt",
                  sum(a.bytes_free + a.bytes_used) bytes,   -- allocated
                  d.maxbytes bytes_max,
                  SUM(a.bytes_free + a.bytes_used - NVL(c.bytes_used, 0)) bytes_free
              FROM
                  sys.v_$TEMP_SPACE_HEADER a,
                  sys.dba_tablespaces b,
                  sys.v_$Temp_extent_pool c,
                  dba_temp_files d
              WHERE
                  c.file_id(+)             = a.file_id
                  and c.tablespace_name(+) = a.tablespace_name
                  and d.file_id            = a.file_id
                  and d.tablespace_name    = a.tablespace_name
                  and b.tablespace_name    = a.tablespace_name
              GROUP BY
                  a.tablespace_name,
                  b.status,
                  b.contents,
                  b.extent_management,
                  d.maxbytes
              ORDER BY
                  1
          };
      } else {
          $query = q{SELECT
                  a.tablespace_name         "Tablespace",
                  b.status                  "Status",
                  b.contents                "Type",
                  'DICTIONARY'              "Extent Mgmt",
                  a.bytes                   bytes,
                  a.maxbytes                bytes_max,
                  c.bytes_free              bytes_free
              FROM
                (
                  -- belegter und maximal verfuegbarer platz pro datafile
                  -- nach tablespacenamen zusammengefasst
                  -- => bytes
                  -- => maxbytes
                  SELECT
                      a.tablespace_name,
                      SUM(a.bytes)          bytes,
                      SUM(a.bytes) maxbytes
                  FROM
                      dba_data_files a
                  GROUP BY
                      tablespace_name
                ) a,
                sys.dba_tablespaces b,
                (
                  -- freier platz pro tablespace
                  -- => bytes_free
                  SELECT
                      a.tablespace_name,
                      SUM(a.bytes) bytes_free
                  FROM
                      dba_free_space a
                  GROUP BY
                      tablespace_name
                ) c
              WHERE
                  a.tablespace_name = c.tablespace_name (+)
                  AND a.tablespace_name = b.tablespace_name
          };
      }
      $self->{sql}->query(query => $query);
      my $result = $self->{sql}->fetchall_arrayref();
      $self->{sql}->disconnect();
  
      $self->{tablespace} = {};
  
      foreach my $row (@$result) {
          my ($name, $status, $type, $extentmgmt, $bytes, $bytes_max, $bytes_free) = @$row;
  
          if (defined($self->{option_results}->{filter_tablespace}) && $self->{option_results}->{filter_tablespace} ne '' &&
              $name !~ /$self->{option_results}->{filter_tablespace}/) {
              $self->{output}->output_add(long_msg => "Skipping  '" . $name . "': no matching filter.", debug => 1);
              next;
          }
          if (!defined($bytes)) {
              # seems corrupted, cannot get value
              $self->{output}->output_add(long_msg => sprintf("tbs '%s' cannot get data", $name), debug => 1);
              next;
          }
          if (defined($self->{option_results}->{skip}) && $status eq 'OFFLINE')  {
              $self->{output}->output_add(long_msg => "Skipping  '" . $name . "': tbs is offline", debug => 1);
              next;
          }
  
          my ($percent_used, $percent_free, $used, $free, $size);
          if ($self->{sql}->is_version_minimum(version => '11')) {
              $percent_used = $bytes / $bytes_max * 100;
              $size = $bytes_max;
              $free = $bytes_max - $bytes;
              $used = $bytes;
          } elsif ((!defined($bytes_max)) || ($bytes_max == 0)) {
              $percent_used = ($bytes - $bytes_free) / $bytes * 100;
              $size = $bytes;
              $free = $bytes_free;
              $used = $size - $free;
          } else {
              $percent_used = ($bytes - $bytes_free) / $bytes_max * 100;
              $size = $bytes_max;
              $free = $bytes_free + ($bytes_max - $bytes);
              $used = $size - $free;
          }
  
          $self->{tablespace}->{$name} = { 
              used => $used,
              free => $free,
              total => $size,
              prct_used => $percent_used,
              display => lc($name)
          };
      }
  
      if (scalar(keys %{$self->{tablespace}}) <= 0) {
          $self->{output}->add_option_msg(short_msg => "No tablespaces found.");
          $self->{output}->option_exit();
      }
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle tablespaces usage.
  
  =over 8
  
  =item B<--warning-tablespace>
  
  Threshold warning.
  
  =item B<--critical-tablespace>
  
  Threshold critical.
  
  =item B<--filter-tablespace>
  
  Filter tablespace by name. Can be a regex
  
  =item B<--units>
  
  Default is '%', can be 'B'
  
  =item B<--free>
  
  Perfdata show free space
  
  =item B<--skip>
  
  Skip offline tablespaces.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_TABLESPACEUSAGE

$fatpacked{"database/oracle/mode/temptablespace.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_TEMPTABLESPACE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::temptablespace;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub custom_usage_perfdata {
      my ($self, %options) = @_;
  
      my $label = 'used';
      my $value_perf = $self->{result_values}->{used};
      if (defined($self->{instance_mode}->{option_results}->{free})) {
          $label = 'free';
          $value_perf = $self->{result_values}->{free};
      }
  
      my %total_options = ();
      if ($self->{instance_mode}->{option_results}->{units} eq '%') {
          $total_options{total} = $self->{result_values}->{total};
          $total_options{cast_int} = 1;
      }
  
      $self->{output}->perfdata_add(
          label => $label,
          value => $value_perf, unit => 'B',
          warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning-' . $self->{label}, %total_options),
          critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical-' . $self->{label}, %total_options),
          min => 0, max => $self->{result_values}->{total}
      );
  }
  
  sub custom_usage_threshold {
      my ($self, %options) = @_;
  
      my ($exit, $threshold_value);
      $threshold_value = $self->{result_values}->{used};
      $threshold_value = $self->{result_values}->{free} if (defined($self->{instance_mode}->{option_results}->{free}));
      if ($self->{instance_mode}->{option_results}->{units} eq '%') {
          $threshold_value = $self->{result_values}->{prct_used};
          $threshold_value = $self->{result_values}->{prct_free} if (defined($self->{instance_mode}->{option_results}->{free}));
      }
      $exit = $self->{perfdata}->threshold_check(value => $threshold_value, threshold => [ { label => 'critical-' . $self->{label}, exit_litteral => 'critical' }, { label => 'warning-'. $self->{label}, exit_litteral => 'warning' } ]);
      return $exit;
  }
  
  sub custom_usage_output {
      my ($self, %options) = @_;
  
      my $msg = sprintf("Total: %s%s Used: %s%s (%.2f%%) Free: %s%s (%.2f%%)",
                     $self->{perfdata}->change_bytes(value => $self->{result_values}->{total}),
                     $self->{perfdata}->change_bytes(value => $self->{result_values}->{used}), $self->{result_values}->{prct_used},
                     $self->{perfdata}->change_bytes(value => $self->{result_values}->{free}), $self->{result_values}->{prct_free});
      return $msg;
  }
  
  sub custom_usage_calc {
      my ($self, %options) = @_;
  
      $self->{result_values}->{total} = $options{new_datas}->{$self->{instance} . '_total'};
      $self->{result_values}->{used} = $options{new_datas}->{$self->{instance} . '_used'};
      $self->{result_values}->{prct_used} = $self->{result_values}->{used} * 100 / $self->{result_values}->{total};
      $self->{result_values}->{free} = $self->{result_values}->{total} - $self->{result_values}->{used};
      $self->{result_values}->{prct_free} = 100 - $self->{result_values}->{prct_used};
  
      return 0;
  }
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'tmptablespace', type => 1, cb_prefix_output => 'prefix_tablespace_output', message_multiple => 'All temporary tablespaces are OK' },
      ];
  
      $self->{maps_counters}->{tmptablespace} = [
          { label => 'usage', set => {
                  key_values => [ { name => 'used' }, { name => 'total' }, { name => 'display' } ],
                  closure_custom_calc => \&custom_usage_calc,
                  closure_custom_output => \&custom_usage_output,
                  closure_custom_perfdata => \&custom_usage_perfdata,
                  closure_custom_threshold_check => \&custom_usage_threshold,
              }
          },
      ];
  }
  
  sub prefix_tablespace_output {
      my ($self, %options) = @_;
  
      return "Temp Tablespace '" . $options{instance_value}->{display} . "' ";
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "units:s"   => { name => 'units', default => '%' },
          "free"      => { name => 'free' },
      });
  
      return $self;
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
      $self->{sql}->connect();
  
      my $query = q{
                  WITH
                  TMP as
                  (
                  SELECT
                      B.name,
                      C.block_size,
                      SUM (C.bytes) b_total
                   FROM
                      v$tablespace B join
                      v$tempfile C
                      using  ( ts#)
                   GROUP BY
                      B.name, C.block_size
                  )
                  SELECT
                      A.tablespace_name tablespace, TMP.b_total,
                      SUM (A.used_blocks * TMP.block_size) b_used,
                      TMP.b_total - SUM (A.used_blocks * TMP.block_size) / 1024 b_free
                  FROM
                      v$sort_segment A join TMP on A.tablespace_name = TMP.name
                  GROUP by
                      A.tablespace_name, TMP.b_total
                  };
  
      $self->{sql}->query(query => $query);
  
      while (my $result = $self->{sql}->fetchrow_hashref()) {
          $self->{tmptablespace}->{$result->{TABLESPACE}} = { used => $result->{B_USED}, total => $result->{B_TOTAL}, display => lc $result->{TABLESPACE} };
      }
  
      $self->{sql}->disconnect();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle TEMP tablespaces
  
  =over 8
  
  =item B<--units>
  
  Unit of thresholds (Can be : '%' (default) or 'B')
  
  =item B<--free>
  
  Threshold are on free space left
  
  =item B<--warning-usage>
  
  Threshold warning.
  
  =item B<--critical-usage>
  
  Threshold critical.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_TEMPTABLESPACE

$fatpacked{"database/oracle/mode/tnsping.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_TNSPING';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::tnsping;
  
  use base qw(centreon::plugins::mode);
  
  use strict;
  use warnings;
  use Time::HiRes;
  use POSIX;
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
      
      $options{options}->add_options(arguments =>
                                  { 
                                    "warning:s"       => { name => 'warning', },
                                    "critical:s"      => { name => 'critical', },
                                  });
  
      return $self;
  }
  
  sub check_options {
      my ($self, %options) = @_;
      $self->SUPER::init(%options);
  
      if (($self->{perfdata}->threshold_validate(label => 'warning', value => $self->{option_results}->{warning})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong warning threshold '" . $self->{option_results}->{warning} . "'.");
          $self->{output}->option_exit();
      }
      if (($self->{perfdata}->threshold_validate(label => 'critical', value => $self->{option_results}->{critical})) == 0) {
          $self->{output}->add_option_msg(short_msg => "Wrong critical threshold '" . $self->{option_results}->{critical} . "'.");
          $self->{output}->option_exit();
      }
  }
  
  sub run {
      my ($self, %options) = @_;
      # $options{sql} = sqlmode object
      $self->{sql} = $options{sql};
  
      my ($exit, $msg_error) = $self->{sql}->connect(dontquit => 1);
      if (defined($msg_error) && $msg_error !~ /(ORA-01017|ORA-01004)/i) {
          $self->{output}->output_add(severity => 'CRITICAL',
                                      short_msg => $msg_error);
      } else {
          my ($sid) = $self->{sql}->{data_source} =~ /(?:sid|service_name)=(\S+)/;
          $self->{output}->output_add(severity => 'OK',
                                      short_msg => sprintf("Connection established to listener '%s'.", $sid));
      }
   
      $self->{sql}->disconnect();
      $self->{output}->display();
      $self->{output}->exit();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle listener status.
  
  =over 8
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_TNSPING

$fatpacked{"database/oracle/mode/undotablespace.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_MODE_UNDOTABLESPACE';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::mode::undotablespace;
  
  use base qw(centreon::plugins::templates::counter);
  
  use strict;
  use warnings;
  use Digest::MD5 qw(md5_hex);
  
  sub custom_usage_perfdata {
      my ($self, %options) = @_;
  
      my $label = 'used';
      my $value_perf = $self->{result_values}->{used};
      if (defined($self->{instance_mode}->{option_results}->{free})) {
          $label = 'free';
          $value_perf = $self->{result_values}->{free};
      }
  
      my %total_options = ();
      if ($self->{instance_mode}->{option_results}->{units} eq '%') {
          $total_options{total} = $self->{result_values}->{total};
          $total_options{cast_int} = 1;
      }
  
      $self->{output}->perfdata_add(label => $label,
                                    value => $value_perf, unit => 'B',
                                    warning => $self->{perfdata}->get_perfdata_for_output(label => 'warning-' . $self->{label}, %total_options),
                                    critical => $self->{perfdata}->get_perfdata_for_output(label => 'critical-' . $self->{label}, %total_options),
                                    min => 0, max => $self->{result_values}->{total});
  }
  
  sub custom_usage_threshold {
      my ($self, %options) = @_;
  
      my ($exit, $threshold_value);
      $threshold_value = $self->{result_values}->{used};
      $threshold_value = $self->{result_values}->{free} if (defined($self->{instance_mode}->{option_results}->{free}));
      if ($self->{instance_mode}->{option_results}->{units} eq '%') {
          $threshold_value = $self->{result_values}->{prct_used};
          $threshold_value = $self->{result_values}->{prct_free} if (defined($self->{instance_mode}->{option_results}->{free}));
      }
      $exit = $self->{perfdata}->threshold_check(value => $threshold_value, threshold => [ { label => 'critical-' . $self->{label}, exit_litteral => 'critical' }, { label => 'warning-'. $self->{label}, exit_litteral => 'warning' } ]);
      return $exit;
  }
  
  sub custom_usage_output {
      my ($self, %options) = @_;
  
      my $msg = sprintf("Total: %s%s Used: %s%s (%.2f%%) Free: %s%s (%.2f%%)",
                     $self->{perfdata}->change_bytes(value => $self->{result_values}->{total}),
                     $self->{perfdata}->change_bytes(value => $self->{result_values}->{used}), $self->{result_values}->{prct_used},
                     $self->{perfdata}->change_bytes(value => $self->{result_values}->{free}), $self->{result_values}->{prct_free});
      return $msg;
  }
  
  sub custom_usage_calc {
      my ($self, %options) = @_;
  
      $self->{result_values}->{total} = $options{new_datas}->{$self->{instance} . '_total'};
      $self->{result_values}->{used} = $options{new_datas}->{$self->{instance} . '_used'};
      $self->{result_values}->{prct_used} = $self->{result_values}->{used} * 100 / $self->{result_values}->{total};
      $self->{result_values}->{free} = $self->{result_values}->{total} - $self->{result_values}->{used};
      $self->{result_values}->{prct_free} = 100 - $self->{result_values}->{prct_used};
  
      return 0;
  }
  
  sub set_counters {
      my ($self, %options) = @_;
  
      $self->{maps_counters_type} = [
          { name => 'undotablespace', type => 1, cb_prefix_output => 'prefix_tablespace_output', message_multiple => 'All undo tablespaces are OK' },
      ];
  
      $self->{maps_counters}->{undotablespace} = [
          { label => 'usage', set => {
                  key_values => [ { name => 'used' }, { name => 'total' }, { name => 'display' } ],
                  closure_custom_calc => \&custom_usage_calc,
                  closure_custom_output => \&custom_usage_output,
                  closure_custom_perfdata => \&custom_usage_perfdata,
                  closure_custom_threshold_check => \&custom_usage_threshold,
              }
          },
      ];
  }
  
  sub prefix_tablespace_output {
      my ($self, %options) = @_;
  
      return "Undo Tablespace '" . $options{instance_value}->{display} . "' ";
  }
  
  sub new {
      my ($class, %options) = @_;
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
  
      $options{options}->add_options(arguments => {
          "units:s"   => { name => 'units', default => '%' },
          "free"      => { name => 'free' },
      });
  
      return $self;
  }
  
  sub manage_selection {
      my ($self, %options) = @_;
      $self->{sql} = $options{sql};
      $self->{sql}->connect();
  
      my $query = q{
                  WITH
                  UND as
                  (
                  SELECT
                      a.tablespace_name,
                      nvl(sum(bytes),0)  used_bytes
                  FROM
                      dba_undo_extents a
                  WHERE
                      tablespace_name in (select upper(value) from gv$parameter where name='undo_tablespace') and status in ('ACTIVE','UNEXPIRED')
  group by a.tablespace_name
                  ),
                  DF as
                  (
                  SELECT
                      b.tablespace_name,
                      round(SUM(decode(B.maxbytes, 0, B.BYTES/(1024*1024), B.maxbytes))) total_bytes
                  FROM
                      dba_data_files b
                  WHERE
                      tablespace_name in (select upper(value) from gv$parameter where name='undo_tablespace') group by b.tablespace_name
                  )
                  SELECT
                      UND.tablespace_name,
                      UND.used_bytes,
                      DF.total_bytes
                  FROM UND left outer join DF
                      on (UND.tablespace_name=DF.tablespace_name)
                      order by DF.tablespace_name
                  };
  
      $self->{sql}->query(query => $query);
  
      while (my $result = $self->{sql}->fetchrow_hashref()) {
          $self->{undotablespace}->{$result->{TABLESPACE_NAME}} = { used => $result->{USED_BYTES}, total => $result->{TOTAL_BYTES}, display => lc $result->{TABLESPACE_NAME} };
      }
  
      $self->{sql}->disconnect();
  }
  
  1;
  
  
  =head1 MODE
  
  Check Oracle UNDO tablespaces
  
  =over 8
  
  =item B<--units>
  
  Unit of threshold (Can be : '%' (default) or 'B')
  
  =item B<--free>
  
  Threshold are on free space left
  
  =item B<--warning-usage>
  
  Threshold warning.
  
  =item B<--critical-usage>
  
  Threshold critical.
  
  =back
  
  =cut
DATABASE_ORACLE_MODE_UNDOTABLESPACE

$fatpacked{"database/oracle/plugin.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_PLUGIN';
  #
  # Copyright 2019 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::plugin;
  
  use strict;
  use warnings;
  use base qw(centreon::plugins::script_sql);
  
  sub new {
      my ($class, %options) = @_;
      
      my $self = $class->SUPER::new(package => __PACKAGE__, %options);
      bless $self, $class;
  
      $self->{version} = '0.1';
      %{$self->{modes}} = (
          'asm-diskgroup-usage'      => 'database::oracle::mode::asmdiskgroupusage',
          'connection-time'          => 'centreon::common::protocols::sql::mode::connectiontime',
          'connected-users'          => 'database::oracle::mode::connectedusers',
          'corrupted-blocks'         => 'database::oracle::mode::corruptedblocks',
          'data-files-status'        => 'database::oracle::mode::datafilesstatus',
          'datacache-hitratio'       => 'database::oracle::mode::datacachehitratio',
          'dictionary-cache-usage'   => 'database::oracle::mode::dictionarycacheusage',
          'event-waits-usage'        => 'database::oracle::mode::eventwaitsusage',
          'fra-usage'                => 'database::oracle::mode::frausage',
          'invalid-object'           => 'database::oracle::mode::invalidobject',
          'library-cache-usage'      => 'database::oracle::mode::librarycacheusage',
          'list-asm-diskgroups'      => 'database::oracle::mode::listasmdiskgroups',
          'long-queries'             => 'database::oracle::mode::longqueries',
          'password-expiration'      => 'database::oracle::mode::passwordexpiration',
          'process-usage'            => 'database::oracle::mode::processusage',
          'redolog-usage'            => 'database::oracle::mode::redologusage',
          'rman-backup-problems'     => 'database::oracle::mode::rmanbackupproblems',
          'rman-backup-age'          => 'database::oracle::mode::rmanbackupage',
          'rman-online-backup-age'   => 'database::oracle::mode::rmanonlinebackupage',
          'rollback-segment-usage'   => 'database::oracle::mode::rollbacksegmentusage',
          'session-usage'            => 'database::oracle::mode::sessionusage',
          'sql'                      => 'centreon::common::protocols::sql::mode::sql',
          'sql-string'               => 'centreon::common::protocols::sql::mode::sqlstring',
          'tablespace-usage'         => 'database::oracle::mode::tablespaceusage',
          'temp-usage'               => 'database::oracle::mode::temptablespace',
          'tnsping'                  => 'database::oracle::mode::tnsping',
          'undo-usage'               => 'database::oracle::mode::undotablespace',
      );
  
      $self->{sql_modes}{dbi} = 'database::oracle::dbi';
      $self->{sql_modes}{sqlpluscmd} = 'database::oracle::sqlpluscmd';						 
  						 
      return $self;
  }
  
  sub init {
      my ($self, %options) = @_;
  
      $self->{options}->add_options(arguments => {
          'hostname:s@'   => { name => 'hostname' },
          'port:s@'       => { name => 'port' },
          'sid:s'         => { name => 'sid' },
          'servicename:s' => { name => 'servicename' },
      });
  
      $self->{options}->parse_options();
      my $options_result = $self->{options}->get_options();
      $self->{options}->clean();
  
      if (defined($options_result->{hostname})) {
          @{$self->{sqldefault}->{dbi}} = ();
          @{$self->{sqldefault}->{sqlpluscmd}} = ();
          for (my $i = 0; $i < scalar(@{$options_result->{hostname}}); $i++) {
              $self->{sqldefault}->{dbi}[$i] = { data_source => 'Oracle:host=' . $options_result->{hostname}[$i] };
              $self->{sqldefault}->{sqlpluscmd}[$i] = { hostname => $options_result->{hostname}[$i] };
              if (defined($options_result->{port}[$i])) {
                  $self->{sqldefault}->{dbi}[$i]->{data_source} .= ';port=' . $options_result->{port}[$i];
                  $self->{sqldefault}->{sqlpluscmd}[$i]->{port} = $options_result->{port}[$i];
              }
              if (defined($options_result->{sid}) && $options_result->{sid} ne '') {
                  $self->{sqldefault}->{dbi}[$i]->{data_source} .= ';sid=' . $options_result->{sid};
  	            $self->{sqldefault}->{sqlpluscmd}[$i]->{sid} = $options_result->{sid};
              }
              if (defined($options_result->{servicename}) && $options_result->{servicename} ne '') {
                  $self->{sqldefault}->{dbi}[$i]->{data_source} .= ';service_name=' . $options_result->{servicename};
  	            $self->{sqldefault}->{sqlpluscmd}[$i]->{service_name} = $options_result->{servicename};
              }
          }
      }
      $self->SUPER::init(%options);    
  }
  
  1;
  
  
  =head1 PLUGIN DESCRIPTION
  
  Check Oracle Server.
  
  =over 8
  
  =item B<--hostname>
  
  Hostname to query.
  
  =item B<--port>
  
  Database Server Port.
  
  =item B<--sid>
  
  Database SID.
  
  =item B<--servicename>
  
  Database Service Name.
  
  =back
  
  =cut
DATABASE_ORACLE_PLUGIN

$fatpacked{"database/oracle/sqlpluscmd.pm"} = '#line '.(1+__LINE__).' "'.__FILE__."\"\n".<<'DATABASE_ORACLE_SQLPLUSCMD';
  #
  # Copyright 2018 Centreon (http://www.centreon.com/)
  #
  # Centreon is a full-fledged industry-strength solution that meets
  # the needs in IT infrastructure and application monitoring for
  # service performance.
  #
  # Licensed under the Apache License, Version 2.0 (the "License");
  # you may not use this file except in compliance with the License.
  # You may obtain a copy of the License at
  #
  #     http://www.apache.org/licenses/LICENSE-2.0
  #
  # Unless required by applicable law or agreed to in writing, software
  # distributed under the License is distributed on an "AS IS" BASIS,
  # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  # See the License for the specific language governing permissions and
  # limitations under the License.
  #
  
  package database::oracle::sqlpluscmd;
  
  use strict;
  use warnings;
  use centreon::plugins::misc;
  use Digest::MD5 qw(md5_hex);
  use File::Temp qw(tempfile);
  use Data::Dumper;
  
  sub new {
      my ($class, %options) = @_;
      my $self  = {};
      bless $self, $class;
      # $options{options} = options object
      # $options{output} = output object
      # $options{exit_value} = integer
      # $options{noptions} = integer
      
      if (!defined($options{output})) {
          print "Class sqlpluscmd: Need to specify 'output' argument.\n";
          exit 3;
      }
      if (!defined($options{options})) {
          $options{output}->add_option_msg(short_msg => "Class sqlpluscmd: Need to specify 'options' argument.");
          $options{output}->option_exit();
      }
      if (!defined($options{noptions})) {
          $options{options}->add_options(arguments => {
                  "sqlplus-cmd:s"             => { name => 'sqlplus_cmd'},
                  "oracle-home:s"             => { name => 'oracle_home' },
                  "tnsadmin-home:s"           => { name => 'tnsadmin_home' },
                  "tnsnames-sid:s"            => { name => 'tnsnames_sid'},
                  "tnsnames-servicename:s"    => { name => 'tnsnames_servicename'},
                  "username:s"                => { name => 'username' },
                  "password:s"                => { name => 'password' },
                  "local-connexion"           => { name => 'local_connexion', default => 0 }, 
                  "sysdba"                    => { name => 'sysdba', default => 0 }, 
                  "sql-errors-exit:s"         => { name => 'sql_errors_exit', default => 'unknown' },
                  "tempdir:s"                 => { name => 'tempdir', default => '/tmp' },
              }
          );
      }
      $options{options}->add_help(package => __PACKAGE__, sections => 'sqlpluscmd OPTIONS', once => 1);
  
      $self->{output} = $options{output};
      $self->{mode} = $options{mode};
      $self->{args} = undef;
      $self->{stdout} = undef;
      $self->{columns} = undef;
      $self->{version} = undef;
      
      $self->{sid} = undef;
      $self->{oracle_home} = undef;
      $self->{tnsadmin_home} = undef;
      $self->{local_connexion} = undef;
      
      return $self;
  }
  
  # Method to manage multiples
  sub set_options {
      my ($self, %options) = @_;
      # options{options_result}
  
      $self->{option_results} = $options{option_results};
  }
  
  # Method to manage multiples
  sub set_defaults {
      my ($self, %options) = @_;
      # options{default}
      
      # Manage default value
      foreach (keys %{$options{default}}) {
          if ($_ eq $self->{mode}) {
              for (my $i = 0; $i < scalar(@{$options{default}->{$_}}); $i++) {
                  foreach my $opt (keys %{$options{default}->{$_}[$i]}) {
                      if (!defined($self->{option_results}->{$opt}[$i])) {
                          $self->{option_results}->{$opt}[$i] = $options{default}->{$_}[$i]->{$opt};
                      }
                  }
              }
          }
      }
  }
  
  sub check_options {
      my ($self, %options) = @_;
      # return 1 = ok still data_source
      # return 0 = no data_source left
  
      $self->{sid} = defined($self->{option_results}->{sid}[0]) ? $self->{option_results}->{sid}[0]: $self->{option_results}->{tnsnames_sid};
      $self->{service_name} = defined($self->{option_results}->{service_name}[0]) ? $self->{option_results}->{service_name}[0]: $self->{option_results}->{tnsnames_servicename};
      $self->{oracle_home} = defined($self->{option_results}->{oracle_home}) ? $self->{option_results}->{oracle_home} : $ENV{'ORACLE_HOME'};
      $self->{tnsadmin_home} = defined($self->{option_results}->{tnsadmin_home}) ? $self->{option_results}->{tnsadmin_home} : $ENV{'TNSADMIN'};
      $self->{local_connexion} = $self->{option_results}->{local_connexion};
      $self->{sqlplus_cmd} = $self->{option_results}->{sqlplus_cmd};
          
      $self->{output}->output_add(long_msg => "*** DEBUG MODE****\n", debug => 1);
      $self->{output}->output_add(long_msg => Data::Dumper::Dumper($self->{option_results}), debug => 1);
   
      if ((!defined($self->{sid}) || $self->{sid} eq '') &&
          (!defined($self->{service_name}) || $self->{service_name} eq '')) {
          $self->{output}->add_option_msg(short_msg => "Need to specify sid or servicename argument.");
          $self->{output}->option_exit(exit_litteral => $self->{option_results}->{sql_errors_exit});
      }
      
      # check the ORACLE_HOME variable
      if (!defined($self->{oracle_home}) || $self->{oracle_home} eq '') {
          $self->{output}->add_option_msg(short_msg => "Need to specify oracle-home argument.");
          $self->{output}->option_exit(exit_litteral => $self->{option_results}->{sql_errors_exit});
      }
      
      # construct the TNSADMIN variable if not available
      if(!defined($self->{tnsadmin_home})) {
          $self->{tnsadmin_home} = $self->{oracle_home} . "/network/admin";
      }
      
      # check the SQLPLUS command to use
      if(!$self->{sqlplus_cmd}) {
          $self->{sqlplus_cmd} = $self->{oracle_home} . "/bin/sqlplus";
      }
      
      $self->{args} = ['-L', '-S'];
      my $connection_string = "";
      if ($self->{option_results}->{sysdba} == 1) {
          $self->{output}->output_add(long_msg => "*** SYDBA MODE****", debug => 1);
          $connection_string="/ as sysdba";
          $self->{local_connexion} = 1;
      } elsif (defined($self->{option_results}->{username}) && defined($self->{option_results}->{password})) {
          $connection_string=$self->{option_results}->{username} . "/" . $self->{option_results}->{password};
      } else {
          $self->{output}->add_option_msg(short_msg => "Need to specify username/password arguments or sysdba option.");
          $self->{output}->option_exit(exit_litteral => $self->{option_results}->{sql_errors_exit});
      }
  
      if ($self->{local_connexion} == 0) {
          if (defined($self->{option_results}->{hostname})) {
              my $port = defined($self->{option_results}->{port}) ? $self->{option_results}->{port}[0] : 1521;
              $connection_string .= "\@//" . $self->{option_results}->{hostname}[0] . ':' . $port . '/' . ((defined($self->{sid}) && $self->{sid} ne '') ? $self->{sid} : $self->{service_name});
          } else {
              $connection_string .= "\@" . ((defined($self->{sid}) && $self->{sid} ne '') ? $self->{sid} : $self->{service_name});
          }
      } else {
          $self->{output}->output_add(long_msg => "*** LOCAL CONNEXION MODE****", debug => 1);
          if (defined($self->{sid}) && $self->{sid} ne '') {
              $ENV{ORACLE_SID} = $self->{sid};
          } else {
              $ENV{TWO_TASK} = '/' . $self->{service_name};
          }
      }
      
      # register a false data_source to be compliant with tnsping mode
      if (defined($self->{sid}) && $self->{sid} ne '') {
          $self->{data_source} = "sid=" . $self->{sid};
      } else {
          $self->{data_source} = "service_name=" . $self->{service_name};
      }
      
      push @{$self->{args}}, $connection_string;
      
      # set oracle env variable
      $ENV{ORACLE_HOME} = $self->{oracle_home};
      $ENV{TNSADMIN} = $self->{tnsadmin_home};
      
      if (defined($self->{option_results}->{sid})) {
          return 0;
      }
      return 1;
  }
  
  sub is_version_minimum {
      my ($self, %options) = @_;
      # $options{version} = string version to check
      
      my @version_src = split /\./, $self->{version};
      my @versions = split /\./, $options{version};
      for (my $i = 0; $i < scalar(@versions); $i++) {
          return 1 if ($versions[$i] eq 'x');
          return 1 if (!defined($version_src[$i]));
          $version_src[$i] =~ /^([0-9]*)/;
          next if ($versions[$i] == int($1));
          return 0 if ($versions[$i] > int($1));
          return 1 if ($versions[$i] < int($1));
      }
      
      return 1;
  }
  
  sub get_id {
      my ($self, %options) = @_;
      
      my $msg = $self->{sid};
      return $msg;
  }
  
  
  sub get_unique_id4save {
      my ($self, %options) = @_;
  
      my $msg = $self->{sid};
      return md5_hex($msg);
  }
  
  sub quote {
      my $self = shift;
  
      return undef;
  }
  
  sub command_execution {
      my ($self, %options) = @_;
      
      my ($fh, $tempfile) = tempfile(DIR => $self->{option_results}->{tempdir}, SUFFIX => ".sql", UNLINK => 1);
      print $fh "set echo off
  -- set heading off
  set feedback off
  set linesize 16000
  set pagesize 50000
  set colsep '#&!#'
  set numwidth 15
  $options{request};
  exit;";
      
      $self->{output}->output_add(long_msg => "*** COMMAND: " . $self->{sqlplus_cmd} . ' ' . join(' ', (@{$self->{args}}, '@', $tempfile)), debug => 1);
      $self->{output}->output_add(long_msg => "*** REQUEST: " . $options{request}, debug => 1);
      my ($lerror, $stdout, $exit_code) = centreon::plugins::misc::backtick(
                                                   command => $self->{sqlplus_cmd},
                                                   arguments =>  [@{$self->{args}}, '@', $tempfile],
                                                   timeout => 30,
                                                   wait_exit => 1,
                                                   redirect_stderr => 1
                                                   );
      $self->{output}->output_add(long_msg => "REQ. STDOUT: '$stdout'", debug => 1);
      $self->{output}->output_add(long_msg => "REQ. EXIT_CODE: $exit_code", debug => 1);
      
      # search oracle error lines
      $exit_code = -1 if($stdout =~ /^(ORA\-\d+|TNS\-\d+|SP\d\-\d+)/);
      
      if ($exit_code <= -1000) {
          if ($exit_code == -1000) {
              $self->{output}->output_add(severity => 'UNKNOWN', 
                                          short_msg => $stdout);
          }
          $self->{output}->display();
          $self->{output}->exit();
      }
      
      return ($exit_code, $stdout); 
  }
  
  sub disconnect {}
  
  # Connection initializer
  sub connect {
      my ($self, %options) = @_;
      my $dontquit = (defined($options{dontquit}) && $options{dontquit} == 1) ? 1 : 0;
  
      (my $exit_code, $self->{stdout}) = $self->command_execution(request => "select version from v\$instance");
      if ($exit_code != 0) {
          if ($dontquit == 0) {
              $self->{output}->add_option_msg(short_msg => "Cannot connect: " . $self->{stdout});
              $self->{output}->option_exit(exit_litteral => $self->{option_results}->{sql_errors_exit});
          }
          return (-1, "Cannot connect: " . $self->{stdout});
      }
      
      $self->{version} = $self->fetchrow_array();
      
      $self->{output}->output_add(long_msg => "VERSION: " . $self->{version}, debug => 1);
      return 0;
  }
  
  sub fetchall_arrayref {
      my ($self, %options) = @_;
      my $array_ref = [];
      
      if($self->{stdout} eq '') {
          $self->{output}->output_add(long_msg => "fetchall_arrayref: no data returned (no rows selected)", debug => 1);
          return $array_ref;
      }
      
      if (!defined($self->{columns})) {
          $self->{stdout} =~ s/^\s*\n(.*?)(\n|$)//;
          my $line = $1;
          $self->{output}->output_add(long_msg => "fetchall_arrayref COLUMNS: $line", debug => 1) if(defined($line));
          @{$self->{columns}} = split(/#&!#/, $line);
          map { s/^\s+|\s+$//g; } @{$self->{columns}};
          $self->{stdout} =~ s/[\-#&!]+(\n|$)//;
      }
      foreach (split /\n/, $self->{stdout}) {
          my $line = $_;
          $line =~ s/^\s+|\s+$//g;
          $line =~ s/#&!#\s+/#&!#/g;
          $line =~ s/\s+#&!#/#&!#/g;
          
          $self->{output}->output_add(long_msg => "fetchall_arrayref VALUE: " . $line, debug => 1);
          push @$array_ref, [map({ s/\\n/\x{0a}/g; s/\\t/\x{09}/g; s/\\/\x{5c}/g; $_; } split(/#&!#/, $line))];
      }
      return $array_ref;
  }
  
  sub fetchrow_array {
      my ($self, %options) = @_;
      my @array_result = ();
      
      if($self->{stdout} eq '') {
          $self->{output}->output_add(long_msg => "fetchrow_array: no data returned (no rows selected)", debug => 1);
          return @array_result;
      }
      
      if (!defined($self->{columns})) {
          $self->{stdout} =~ s/^\s*\n(.*?)(\n|$)//;
          my $line = $1;
          $self->{output}->output_add(long_msg => "fetchrow_array COLUMNS: $line", debug => 1);
          @{$self->{columns}} = split(/#&!#/, $line);
          map { s/^\s+|\s+$//g; } @{$self->{columns}};
          $self->{stdout} =~ s/[\-#&!]+(\n|$)//;
      }
      $self->{output}->output_add(long_msg => "fetchrow_array STDOUT: '" . $self->{stdout} . "'", debug => 1);
      if (($self->{stdout} =~ s/^(.*?)(\n|$)//)) {
          my $line = $1;
          $self->{output}->output_add(long_msg => "fetchrow_array VALUE: '" . $line . "'", debug => 1);
          push @array_result, map({ s/\\n/\x{0a}/g; s/\\t/\x{09}/g; s/\\/\x{5c}/g; $_; } split(/#&!#/, $line));
          map { s/^\s+|\s+$//g; } @array_result;
          $self->{output}->output_add(long_msg => "ARRAY: " . Data::Dumper::Dumper(@array_result), debug => 1);
      }
      
      $self->{output}->output_add(long_msg => "RETURN: " . Data::Dumper::Dumper(@array_result), debug => 1);
      return scalar(@array_result) == 1 ? $array_result[0] : @array_result;
  }
  
  sub fetchrow_hashref {
      my ($self, %options) = @_;
      my $array_result = undef;
      
      if($self->{stdout} eq '') {
          $self->{output}->output_add(long_msg => "fetchrow_hashref: no data returned (no rows selected)", debug => 1);
          return $array_result;
      }
      
      if (!defined($self->{columns})) {
          $self->{stdout} =~ s/^\s*\n(.*?)(\n|$)//;
          my $line = $1;
          $self->{output}->output_add(long_msg => "fetchrow_hashref COLUMNS: $line", debug => 1);
          @{$self->{columns}} = split(/#&!#/, $line);
          map { s/^\s+|\s+$//g; } @{$self->{columns}};
          $self->{stdout} =~ s/[\-#&!]+(\n|$)//;
      }
      if ($self->{stdout} ne '' && $self->{stdout} =~ s/^(.*?)(\n|$)//) {
          my $line = $1;
          $self->{output}->output_add(long_msg => "fetchrow_hashref VALUE: " . $line, debug => 1);
          $array_result = {};
          my @values = split(/#&!#/, $line);
          for (my $i = 0; $i < scalar(@values); $i++) {
              my $value = $values[$i];
              $value =~ s/^\s+|\s+$//g;
              $value =~ s/\\n/\x{0a}/g;
              $value =~ s/\\t/\x{09}/g;
              $value =~ s/\\/\x{5c}/g;
              $self->{output}->output_add(long_msg => "fetchrow_hashref RES: '" . $self->{columns}[$i] . "' = '$value'", debug => 1);
              $array_result->{$self->{columns}[$i]} = $value;
          }
      }
      
      return $array_result;
  }
  
  sub query {
      my ($self, %options) = @_;
      
      $self->{columns} = undef;
      (my $exit_code, $self->{stdout}) = $self->command_execution(request => $options{query});
      if ($exit_code != 0) {
          $self->{output}->add_option_msg(short_msg => "Cannot execute query: " . $self->{stdout});
          $self->{output}->option_exit(exit_litteral => $self->{option_results}->{sql_errors_exit});
      }
  }
  
  1;
  
  
  =head1 NAME
  
  sqlpluscmd global
  
  =head1 SYNOPSIS
  
  sqlpluscmd class
  
  =head1 sqlpluscmd OPTIONS
  
  =over 8
  
  =item B<--sqlplus-cmd>
  
  sqlplus command (Default: 'sqlplus').
  
  =item B<--oracle-home>
  
  Oracle Database Server Home.
  
  =item B<--tnsadmin-home>
  
  Oracle TNS Admin Home. Where to locate tnsnames.ora file (default: ${ORACLE_HOME}/network/admin)
  
  =item B<--tnsnames-sid>
  
  Oracle SID defined in tnsnames.ora.
  
  =item B<--tnsnames-servicename>
  
  Oracle Service Name defined in tnsnames.ora. 
  
  =item B<--username>
  
  Database username.
  
  =item B<--password>
  
  Database password.
  
  =item B<--sysdba>
  
  Use a sysdba connexion, need to be execute under the oracle local user on the server, and use a local connexion.
  
  =item B<--local-connexion>
  
  Use a local connexion, don't need listener.
  
  =item B<--sql-errors-exit>
  
  Exit code for DB Errors (default: unknown)
  
  =back
  
  =head1 DESCRIPTION
  
  B<sql>.
  
  =cut
DATABASE_ORACLE_SQLPLUSCMD

s/^  //mg for values %fatpacked;

my $class = 'FatPacked::'.(0+\%fatpacked);
no strict 'refs';
*{"${class}::files"} = sub { keys %{$_[0]} };

if ($] < 5.008) {
  *{"${class}::INC"} = sub {
    if (my $fat = $_[0]{$_[1]}) {
      my $pos = 0;
      my $last = length $fat;
      return (sub {
        return 0 if $pos == $last;
        my $next = (1 + index $fat, "\n", $pos) || $last;
        $_ .= substr $fat, $pos, $next - $pos;
        $pos = $next;
        return 1;
      });
    }
  };
}

else {
  *{"${class}::INC"} = sub {
    if (my $fat = $_[0]{$_[1]}) {
      open my $fh, '<', \$fat
        or die "FatPacker error loading $_[1] (could be a perl installation issue?)";
      return $fh;
    }
    return;
  };
}

unshift @INC, bless \%fatpacked, $class;
  } # END OF FATPACK CODE

#
# Copyright 2019 Centreon (http://www.centreon.com/)
#
# Centreon is a full-fledged industry-strength solution that meets
# the needs in IT infrastructure and application monitoring for
# service performance.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

use strict;
use warnings;
# Not perl embedded compliant at all
use FindBin;
use lib "$FindBin::Bin";
# use lib '/usr/lib/nagios/plugins/';

use centreon::plugins::script;

centreon::plugins::script->new()->run();
